System.registerDynamic("source/filters/filter.tests.js", ["./filter"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var __extends = (this && this.__extends) || function(d, b) {
    for (var p in b)
      if (b.hasOwnProperty(p))
        d[p] = b[p];
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
  var filter_1 = $__require('./filter');
  var TestSerializableFilter = (function(_super) {
    __extends(TestSerializableFilter, _super);
    function TestSerializableFilter() {
      _super.apply(this, arguments);
    }
    TestSerializableFilter.prototype.filter = function(item) {
      return true;
    };
    return TestSerializableFilter;
  }(filter_1.SerializableFilter));
  describe('serializable filter', function() {
    var filter;
    beforeEach(function() {
      filter = new TestSerializableFilter();
    });
    it('should provide a default serialize that returns the filter directly', function() {
      filter.type = 'myFilter';
      var serializedValue = filter.serialize();
      expect(serializedValue).to.be.not.empty;
      expect(serializedValue.type).to.equal('myFilter');
    });
    it('should fire an event every time onChange is called by default', function() {
      var onValueChange = sinon.spy();
      filter.subscribe(onValueChange);
      filter.onChange();
      sinon.assert.calledOnce(onValueChange);
    });
    it('should deep compare the new seralized value with the old one if force is set to false', function() {
      var obj1 = {prop: '1234'};
      var obj2 = {prop: '5678'};
      filter.serialize = function() {
        return obj1;
      };
      filter.onChange();
      var onValueChange = sinon.spy();
      filter.subscribe(onValueChange);
      filter.onChange(false);
      sinon.assert.notCalled(onValueChange);
      filter.serialize = function() {
        return obj2;
      };
      filter.onChange(false);
      sinon.assert.calledOnce(onValueChange);
    });
  });
  return module.exports;
});

System.registerDynamic("source/filters/index.js", ["./filter"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  function __export(m) {
    for (var p in m)
      if (!exports.hasOwnProperty(p))
        exports[p] = m[p];
  }
  __export($__require('./filter'));
  return module.exports;
});

System.registerDynamic("source/types/index.js", ["./compareResult", "./itemList"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  function __export(m) {
    for (var p in m)
      if (!exports.hasOwnProperty(p))
        exports[p] = m[p];
  }
  __export($__require('./compareResult'));
  __export($__require('./itemList'));
  return module.exports;
});

System.registerDynamic("source/utilitiesDowngrade.js", ["@angular/core", "angular", "./services/array/array.service", "./services/boolean/boolean.service", "./services/dataContracts/resourceBuilder/resourceBuilder.service", "./services/date/date.service", "./services/errorHandler/errorHandler.service", "./services/genericSearchFilter/genericSearchFilter.service", "./services/guid/guid.service", "./services/http/http.service", "./services/digest/digest.service", "./services/notification/notification.service", "./services/number/number.service", "./services/object/object.service", "./services/observable/observable.service", "./services/string/string.service", "./services/synchronizedRequests/synchronizedRequests.service", "./services/time/time.service", "./services/timeout/timeout.service", "./services/timezone/timezone.service", "./services/transform/transform.service", "./services/validation/validation.service", "./services/validation/emailValidation.service"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var core_1 = $__require('@angular/core');
  var angular = $__require('angular');
  var array_service_1 = $__require('./services/array/array.service');
  var boolean_service_1 = $__require('./services/boolean/boolean.service');
  var resourceBuilder_service_1 = $__require('./services/dataContracts/resourceBuilder/resourceBuilder.service');
  var date_service_1 = $__require('./services/date/date.service');
  var errorHandler_service_1 = $__require('./services/errorHandler/errorHandler.service');
  var genericSearchFilter_service_1 = $__require('./services/genericSearchFilter/genericSearchFilter.service');
  var guid_service_1 = $__require('./services/guid/guid.service');
  var http_service_1 = $__require('./services/http/http.service');
  var digest_service_1 = $__require('./services/digest/digest.service');
  var notification_service_1 = $__require('./services/notification/notification.service');
  var number_service_1 = $__require('./services/number/number.service');
  var object_service_1 = $__require('./services/object/object.service');
  var observable_service_1 = $__require('./services/observable/observable.service');
  var string_service_1 = $__require('./services/string/string.service');
  var synchronizedRequests_service_1 = $__require('./services/synchronizedRequests/synchronizedRequests.service');
  var time_service_1 = $__require('./services/time/time.service');
  var timeout_service_1 = $__require('./services/timeout/timeout.service');
  var timezone_service_1 = $__require('./services/timezone/timezone.service');
  var transform_service_1 = $__require('./services/transform/transform.service');
  var validation_service_1 = $__require('./services/validation/validation.service');
  var emailValidation_service_1 = $__require('./services/validation/emailValidation.service');
  exports.arrayServiceName = 'rlArrayService';
  exports.booleanServiceName = 'rlBooleanService';
  exports.resourceBuilderServiceName = 'rlResourceBuilderService';
  exports.dateServiceName = 'rlDateService';
  exports.errorHandlerServiceName = 'rlErrorHandlerService';
  exports.digestServiceName = 'rlDigestService';
  exports.genericSearchFilterServiceName = 'rlGenericSearchFilterService';
  exports.guidServiceName = 'rlGuidService';
  exports.httpServiceName = 'rlHttpService';
  exports.notificationServiceName = 'rlNotificationService';
  exports.numberServiceName = 'rlNumberService';
  exports.objectServiceName = 'rlObjectService';
  exports.observableServiceName = 'rlObservableService';
  exports.stringServiceName = 'rlStringService';
  exports.synchronizedRequestsServiceName = 'rlSynchronizedRequestsService';
  exports.timeServiceName = 'rlTimeService';
  exports.timeoutServiceName = 'rlTimeoutService';
  exports.timezoneServiceName = 'rlTimezoneService';
  exports.transformServiceName = 'rlTransformService';
  exports.validationServiceName = 'rlValidationService';
  exports.emailValidationServiceName = 'rlEmailValidationService';
  exports.moduleName = 'rl.utilities';
  var utilitiesModule = angular.module(exports.moduleName, []);
  function downgradeUtilitiesToAngular1(upgradeAdapter) {
    var observableFactoryProvider = new core_1.Provider(observable_service_1.observableToken, {useValue: {
        deps: [core_1.ExceptionHandler],
        getInstance: function(exceptionHandler) {
          return new observable_service_1.ObservableService(exceptionHandler);
        }
      }});
    upgradeAdapter.addProvider(observableFactoryProvider);
    utilitiesModule.factory(exports.arrayServiceName, upgradeAdapter.downgradeNg2Provider(array_service_1.ArrayUtility));
    utilitiesModule.factory(exports.booleanServiceName, upgradeAdapter.downgradeNg2Provider(boolean_service_1.BooleanUtility));
    utilitiesModule.factory(exports.resourceBuilderServiceName, upgradeAdapter.downgradeNg2Provider(resourceBuilder_service_1.ResourceBuilder));
    utilitiesModule.factory(exports.dateServiceName, upgradeAdapter.downgradeNg2Provider(date_service_1.DateUtility));
    utilitiesModule.factory(exports.errorHandlerServiceName, upgradeAdapter.downgradeNg2Provider(errorHandler_service_1.ErrorHandlerService));
    utilitiesModule.factory(exports.digestServiceName, upgradeAdapter.downgradeNg2Provider(digest_service_1.DigestService));
    utilitiesModule.factory(exports.genericSearchFilterServiceName, upgradeAdapter.downgradeNg2Provider(genericSearchFilter_service_1.GenericSearchFilterFactory));
    utilitiesModule.factory(exports.guidServiceName, upgradeAdapter.downgradeNg2Provider(guid_service_1.GuidService));
    utilitiesModule.factory(exports.httpServiceName, upgradeAdapter.downgradeNg2Provider(http_service_1.HttpUtility));
    utilitiesModule.factory(exports.notificationServiceName, upgradeAdapter.downgradeNg2Provider(notification_service_1.NotificationService));
    utilitiesModule.factory(exports.numberServiceName, upgradeAdapter.downgradeNg2Provider(number_service_1.NumberUtility));
    utilitiesModule.factory(exports.objectServiceName, upgradeAdapter.downgradeNg2Provider(object_service_1.ObjectUtility));
    utilitiesModule.factory(exports.observableServiceName, upgradeAdapter.downgradeNg2Provider(observable_service_1.observableToken));
    utilitiesModule.factory(exports.stringServiceName, upgradeAdapter.downgradeNg2Provider(string_service_1.StringUtility));
    utilitiesModule.factory(exports.synchronizedRequestsServiceName, upgradeAdapter.downgradeNg2Provider(synchronizedRequests_service_1.SynchronizedRequestsFactory));
    utilitiesModule.factory(exports.timeServiceName, upgradeAdapter.downgradeNg2Provider(time_service_1.TimeUtility));
    utilitiesModule.factory(exports.timeoutServiceName, upgradeAdapter.downgradeNg2Provider(timeout_service_1.TimeoutService));
    utilitiesModule.factory(exports.timezoneServiceName, upgradeAdapter.downgradeNg2Provider(timezone_service_1.TimezoneService));
    utilitiesModule.factory(exports.transformServiceName, upgradeAdapter.downgradeNg2Provider(transform_service_1.TransformService));
    utilitiesModule.factory(exports.validationServiceName, upgradeAdapter.downgradeNg2Provider(validation_service_1.ValidationService));
    utilitiesModule.factory(exports.emailValidationServiceName, upgradeAdapter.downgradeNg2Provider(emailValidation_service_1.EmailValidationService));
  }
  exports.downgradeUtilitiesToAngular1 = downgradeUtilitiesToAngular1;
  return module.exports;
});

System.registerDynamic("source/vendor.js", ["rxjs/add/operator/map", "rxjs/add/operator/toPromise"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  $__require('rxjs/add/operator/map');
  $__require('rxjs/add/operator/toPromise');
  return module.exports;
});

System.registerDynamic("source/services/dataContracts/contractLibrary/dataServiceMocks.js", [], false, function ($__require, $__exports, $__module) {
  var _retrieveGlobal = System.get("@@global-helpers").prepareGlobal($__module.id, null, null);

  (function ($__global) {})(this);

  return _retrieveGlobal();
});
System.registerDynamic("source/services/dataContracts/index.js", ["./resourceBuilder/resourceBuilder.service", "./dataService/data.service", "./singletonDataService/singletonData.service", "./converters/converters", "./contractLibrary/dataServiceMocks", "./contractLibrary/contractLibrary", "./dataService/view/dataServiceView", "./dataService/parent/parentData.service", "./singletonDataService/parent/parentSingletonData.service"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  function __export(m) {
    for (var p in m)
      if (!exports.hasOwnProperty(p))
        exports[p] = m[p];
  }
  var resourceBuilder_service_1 = $__require('./resourceBuilder/resourceBuilder.service');
  var data_service_1 = $__require('./dataService/data.service');
  var singletonData_service_1 = $__require('./singletonDataService/singletonData.service');
  var converters = $__require('./converters/converters');
  exports.converters = converters;
  var mocks = $__require('./contractLibrary/dataServiceMocks');
  exports.mocks = mocks;
  __export($__require('./contractLibrary/contractLibrary'));
  __export($__require('./dataService/data.service'));
  __export($__require('./dataService/view/dataServiceView'));
  __export($__require('./dataService/parent/parentData.service'));
  __export($__require('./singletonDataService/singletonData.service'));
  __export($__require('./singletonDataService/parent/parentSingletonData.service'));
  __export($__require('./resourceBuilder/resourceBuilder.service'));
  exports.DATA_CONTRACT_PROVIDERS = [resourceBuilder_service_1.ResourceBuilder, data_service_1.DataServiceFactory, singletonData_service_1.SingletonDataServiceFactory];
  return module.exports;
});

System.registerDynamic("source/services/fileSize/index.js", ["./fileSize.service"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  function __export(m) {
    for (var p in m)
      if (!exports.hasOwnProperty(p))
        exports[p] = m[p];
  }
  __export($__require('./fileSize.service'));
  return module.exports;
});

System.registerDynamic("source/services/guid/guid.service.js", ["angular2-uuid"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var angular2_uuid_1 = $__require('angular2-uuid');
  var GuidService = (function() {
    function GuidService() {}
    GuidService.prototype.random = function() {
      return angular2_uuid_1.UUID.UUID();
    };
    return GuidService;
  }());
  exports.GuidService = GuidService;
  exports.guid = new GuidService();
  return module.exports;
});

System.registerDynamic("source/services/digest/digest.service.js", ["@angular/core", "angular"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var __decorate = (this && this.__decorate) || function(decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
      r = Reflect.decorate(decorators, target, key, desc);
    else
      for (var i = decorators.length - 1; i >= 0; i--)
        if (d = decorators[i])
          r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
  };
  var __metadata = (this && this.__metadata) || function(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
      return Reflect.metadata(k, v);
  };
  var core_1 = $__require('@angular/core');
  var angular = $__require('angular');
  var DigestService = (function() {
    function DigestService() {
      this.$applyAsync = null;
    }
    DigestService.prototype.runDigestCycle = function() {
      if (this.$applyAsync == null) {
        var elem = angular.element($(".ng-scope"));
        var scope = elem && elem.scope();
        this.$applyAsync = scope && scope.$root && scope.$root.$applyAsync;
        if (this.$applyAsync == null) {
          console.error('Scope not found!');
          return;
        }
      }
      this.$applyAsync();
    };
    DigestService = __decorate([core_1.Injectable(), __metadata('design:paramtypes', [])], DigestService);
    return DigestService;
  }());
  exports.DigestService = DigestService;
  return module.exports;
});

System.registerDynamic("source/services/index.js", ["@angular/http", "./array/array.service", "./boolean/boolean.service", "./dataContracts/index", "./date/index", "./errorHandler/errorHandler.service", "./fileSize/index", "./genericSearchFilter/genericSearchFilter.service", "./guid/guid.service", "./http/http.service", "./digest/digest.service", "./logger/logger.service", "./notification/notification.service", "./number/number.service", "./object/object.service", "./observable/observable.service", "./redirect/redirect.service", "./search/search.service", "./string/string.service", "./synchronizedRequests/synchronizedRequests.service", "./test/index", "./time/time.service", "./timeout/timeout.service", "./timezone/timezone.service", "./transform/transform.service", "./validation/validation.service", "./validation/emailValidation.service", "./window/window.provider"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var http_1 = $__require('@angular/http');
  var array = $__require('./array/array.service');
  exports.array = array;
  var boolean = $__require('./boolean/boolean.service');
  exports.boolean = boolean;
  var dataContracts = $__require('./dataContracts/index');
  exports.dataContracts = dataContracts;
  var date = $__require('./date/index');
  exports.date = date;
  var errorHandler = $__require('./errorHandler/errorHandler.service');
  exports.errorHandler = errorHandler;
  var fileSize = $__require('./fileSize/index');
  exports.fileSize = fileSize;
  var genericSearchFilter = $__require('./genericSearchFilter/genericSearchFilter.service');
  exports.genericSearchFilter = genericSearchFilter;
  var guid = $__require('./guid/guid.service');
  exports.guid = guid;
  var http = $__require('./http/http.service');
  exports.http = http;
  var digestService = $__require('./digest/digest.service');
  exports.digestService = digestService;
  var logger = $__require('./logger/logger.service');
  exports.logger = logger;
  var notification = $__require('./notification/notification.service');
  exports.notification = notification;
  var numberService = $__require('./number/number.service');
  exports.number = numberService;
  var objectService = $__require('./object/object.service');
  exports.object = objectService;
  var observable = $__require('./observable/observable.service');
  exports.observable = observable;
  var redirect = $__require('./redirect/redirect.service');
  exports.redirect = redirect;
  var search = $__require('./search/search.service');
  exports.search = search;
  var stringService = $__require('./string/string.service');
  exports.string = stringService;
  var synchronizedRequests = $__require('./synchronizedRequests/synchronizedRequests.service');
  exports.synchronizedRequests = synchronizedRequests;
  var test = $__require('./test/index');
  exports.test = test;
  var time = $__require('./time/time.service');
  exports.time = time;
  var timeout = $__require('./timeout/timeout.service');
  exports.timeout = timeout;
  var timezone = $__require('./timezone/timezone.service');
  exports.timezone = timezone;
  var transform = $__require('./transform/transform.service');
  exports.transform = transform;
  var validation = $__require('./validation/validation.service');
  exports.validation = validation;
  var emailValidation = $__require('./validation/emailValidation.service');
  exports.emailValidation = emailValidation;
  var window = $__require('./window/window.provider');
  exports.window = window;
  exports.UTILITY_PROVIDERS = [http_1.HTTP_PROVIDERS, array.ArrayUtility, boolean.BooleanUtility, dataContracts.DATA_CONTRACT_PROVIDERS, date.DateUtility, errorHandler.ErrorHandlerService, genericSearchFilter.GenericSearchFilterFactory, guid.GuidService, http.HttpUtility, digestService.DigestService, numberService.NumberUtility, objectService.ObjectUtility, search.SearchUtility, stringService.StringUtility, synchronizedRequests.SynchronizedRequestsFactory, time.TimeUtility, timeout.TimeoutService, timezone.TimezoneService, transform.TransformService, validation.ValidationService, emailValidation.EmailValidationService, logger.Logger, errorHandler.DefaultErrors, errorHandler.DefaultLoginUrlSettings, notification.NotificationService, redirect.RedirectService, window.WINDOW_PROVIDER];
  return module.exports;
});

System.registerDynamic("source/utilities.module.js", ["@angular/core", "@angular/http", "./services/index"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var __decorate = (this && this.__decorate) || function(decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
      r = Reflect.decorate(decorators, target, key, desc);
    else
      for (var i = decorators.length - 1; i >= 0; i--)
        if (d = decorators[i])
          r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
  };
  var __metadata = (this && this.__metadata) || function(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
      return Reflect.metadata(k, v);
  };
  var core_1 = $__require('@angular/core');
  var http_1 = $__require('@angular/http');
  var index_1 = $__require('./services/index');
  var UtilitiesModule = (function() {
    function UtilitiesModule() {}
    UtilitiesModule = __decorate([core_1.NgModule({
      imports: [http_1.HttpModule],
      providers: [index_1.UTILITY_PROVIDERS]
    }), __metadata('design:paramtypes', [])], UtilitiesModule);
    return UtilitiesModule;
  }());
  exports.UtilitiesModule = UtilitiesModule;
  return module.exports;
});

System.registerDynamic("source/main.js", ["./filters/index", "./services/index", "./types/index", "./utilitiesDowngrade", "./vendor", "./utilities.module"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  function __export(m) {
    for (var p in m)
      if (!exports.hasOwnProperty(p))
        exports[p] = m[p];
  }
  var filters = $__require('./filters/index');
  exports.filters = filters;
  var services = $__require('./services/index');
  exports.services = services;
  var types = $__require('./types/index');
  exports.types = types;
  var downgrade = $__require('./utilitiesDowngrade');
  exports.downgrade = downgrade;
  $__require('./vendor');
  __export($__require('./utilities.module'));
  return module.exports;
});

System.registerDynamic("source/services/array/array.service.tests.js", ["./array.service", "lodash"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var array_service_1 = $__require('./array.service');
  var _ = $__require('lodash');
  describe('arrayUtility', function() {
    var arrayUtility;
    beforeEach(function() {
      arrayUtility = new array_service_1.ArrayUtility();
    });
    describe('findIndexOf', function() {
      it('should find the index of the first item in array that matches the predicate', function() {
        var array = [1, 2, 3, 4, 5];
        expect(arrayUtility.findIndexOf(array, function(item) {
          return (item % 2) === 0;
        })).to.equal(1);
        expect(arrayUtility.findIndexOf(array, function(item) {
          return (item > 10);
        })).to.equal(-1);
      });
    });
    describe('remove', function() {
      it('should remove the specified item from the array and return the item', function() {
        var array = [1, 2, 3, 4, 5];
        expect(arrayUtility.remove(array, 3)).to.equal(3);
        expect(array.length).to.equal(4);
        expect(arrayUtility.remove(array, 10)).to.not.exist;
      });
      it('should remove the first item matching the predicate and return it', function() {
        var array = [1, 2, 3, 4, 5];
        expect(arrayUtility.remove(array, function(item) {
          return (item > 3);
        })).to.equal(4);
        expect(array.length).to.equal(4);
        expect(arrayUtility.remove(array, function(item) {
          return (item > 10);
        })).to.not.exist;
      });
    });
    describe('replace', function() {
      it('should replace an item in the array with another item', function() {
        var arrayWithItems = [3, 5, 7];
        arrayUtility.replace(arrayWithItems, 5, 10);
        expect(arrayWithItems[0]).to.equal(3);
        expect(arrayWithItems[1]).to.equal(10);
        expect(arrayWithItems[2]).to.equal(7);
      });
      it('should do nothing if the item to replace is not found', function() {
        var arrayWithItems = [4, 6, 8];
        arrayUtility.replace(arrayWithItems, 5, 10);
        expect(arrayWithItems[0]).to.equal(4);
        expect(arrayWithItems[1]).to.equal(6);
        expect(arrayWithItems[2]).to.equal(8);
      });
    });
    describe('sum', function() {
      it('should sum the values in an array', function() {
        var values = [1, 2, 3, 4, 5];
        expect(arrayUtility.sum(values)).to.equal(15);
      });
      it('should apply a transform to the values before summing them', function() {
        var values = [{prop: 1}, {prop: 4}, {prop: 7}];
        var transform = function(item) {
          return item.prop;
        };
        expect(arrayUtility.sum(values, transform)).to.equal(12);
      });
      it('should return 0 if there are no items to sum', function() {
        var values = [];
        expect(arrayUtility.sum(values)).to.equal(0);
      });
    });
    describe('toDictionary', function() {
      it('should convert an array to a dictionary', function() {
        var array = [{key: '11'}, {key: '12'}, {key: '13'}, {key: '14'}, {key: '15'}];
        var dictionary = arrayUtility.toDictionary(array, function(item) {
          return item.key;
        });
        expect(dictionary['11']).to.equal(array[0]);
        expect(dictionary['12']).to.equal(array[1]);
        expect(dictionary['13']).to.equal(array[2]);
        expect(dictionary['14']).to.equal(array[3]);
        expect(dictionary['15']).to.equal(array[4]);
      });
      it('should trim items with null keys', function() {
        var array = [{key: null}, {key: null}, {key: '13'}, {key: '14'}, {key: '15'}];
        var dictionary = arrayUtility.toDictionary(array, function(item) {
          return item.key;
        });
        expect(dictionary['null']).to.not.exist;
        expect(dictionary['13']).to.equal(array[2]);
        expect(dictionary['14']).to.equal(array[3]);
        expect(dictionary['15']).to.equal(array[4]);
      });
      it('should not consider the dictionary to be an array', function() {
        var array = [{key: '11'}, {key: '12'}, {key: '13'}, {key: '14'}, {key: '15'}];
        var dictionary = arrayUtility.toDictionary(array, function(item) {
          return item.key;
        });
        expect(_.isArray(dictionary)).to.be.false;
      });
    });
    describe('last', function() {
      it('should get the last item in the array', function() {
        var array = [1, 2, 3];
        expect(arrayUtility.last(array)).to.equal(3);
      });
      it('should return undefined if array is empty', function() {
        expect(arrayUtility.last([])).to.be.undefined;
      });
      it('should return undefined if array is null', function() {
        expect(arrayUtility.last(null)).to.be.undefined;
      });
    });
    describe('has', function() {
      it('should return true', function() {
        var someArray = [];
        someArray[5] = 5;
        expect(arrayUtility.has(someArray, 5)).to.be.true;
      });
      it('should return false', function() {
        var someArray = [];
        someArray[5] = 5;
        someArray[4] = null;
        expect(arrayUtility.has(someArray, 2)).to.be.false;
        expect(arrayUtility.has(someArray, 10)).to.be.false;
        expect(arrayUtility.has(someArray, 4)).to.be.false;
      });
    });
    describe('arrayify', function() {
      it('should leave an array untouched', function() {
        expect(arrayUtility.arrayify([1, 2, 3])).to.deep.equal([1, 2, 3]);
      });
      it('should return an array with the specified value', function() {
        expect(arrayUtility.arrayify(4)).to.deep.equal([4]);
      });
      it('should return an empty array for null values', function() {
        expect(arrayUtility.arrayify(null)).to.deep.equal([]);
      });
    });
  });
  return module.exports;
});

System.registerDynamic("source/services/boolean/boolean.service.js", [], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var BooleanUtility = (function() {
    function BooleanUtility() {}
    BooleanUtility.prototype.toBool = function(object) {
      return !!object;
    };
    return BooleanUtility;
  }());
  exports.BooleanUtility = BooleanUtility;
  return module.exports;
});

System.registerDynamic("source/services/boolean/boolean.service.tests.js", ["./boolean.service"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var boolean_service_1 = $__require('./boolean.service');
  describe('booleanUtility', function() {
    var booleanUtility;
    beforeEach(function() {
      booleanUtility = new boolean_service_1.BooleanUtility();
    });
    describe('toBool', function() {
      it('should convert null and undefined to false', function() {
        expect(booleanUtility.toBool(null)).to.be.false;
        expect(booleanUtility.toBool(undefined)).to.be.false;
      });
      it('should leave bool values unchanged', function() {
        expect(booleanUtility.toBool(false)).to.be.false;
        expect(booleanUtility.toBool(true)).to.be.true;
      });
    });
  });
  return module.exports;
});

System.registerDynamic("source/services/dataContracts/baseDataServiceBehavior.tests.js", ["./baseDataServiceBehavior", "../array/array.service", "../test/index"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var baseDataServiceBehavior_1 = $__require('./baseDataServiceBehavior');
  var array_service_1 = $__require('../array/array.service');
  var index_1 = $__require('../test/index');
  describe('base data service behavior', function() {
    var dataServiceBehavior;
    var mockHttp;
    beforeEach(function() {
      mockHttp = {
        get: null,
        put: null,
        post: null,
        delete: null
      };
    });
    describe('use http', function() {
      var testUrl;
      beforeEach(function() {
        testUrl = '/api/test';
        dataServiceBehavior = new baseDataServiceBehavior_1.BaseDataServiceBehavior(mockHttp, null);
      });
      it('should make an http request to get a list of data', index_1.rlFakeAsync(function() {
        var mockList = [{id: 1}, {id: 2}, {id: 3}, {id: 4}, {id: 5}];
        var mockGet = index_1.mock.request(mockList);
        mockHttp.get = mockGet;
        dataServiceBehavior.getList({
          endpoint: testUrl,
          useMock: false,
          logRequests: false,
          getMockData: null,
          params: null
        }).subscribe(function(data) {
          expect(data).to.have.length(5);
          expect(data[0].id).to.equal(1);
          expect(data[1].id).to.equal(2);
          expect(data[2].id).to.equal(3);
          expect(data[3].id).to.equal(4);
          expect(data[4].id).to.equal(5);
        });
        sinon.assert.calledOnce(mockGet);
        sinon.assert.calledWith(mockGet, testUrl, null);
        mockGet.flush();
      }));
      it('should make a POST request to search the data', index_1.rlFakeAsync(function() {
        var mockList = [{id: 1}, {id: 2}, {id: 3}, {id: 4}, {id: 5}];
        var searchObject = {dataSet: mockList};
        var mockPost = index_1.mock.request({dataSet: mockList});
        mockHttp.post = mockPost;
        dataServiceBehavior.search({
          endpoint: testUrl,
          useMock: false,
          logRequests: false,
          getMockData: null,
          params: searchObject
        }).subscribe(function(result) {
          var data = result.dataSet;
          expect(data).to.have.length(5);
          expect(data[0].id).to.equal(1);
          expect(data[1].id).to.equal(2);
          expect(data[2].id).to.equal(3);
          expect(data[3].id).to.equal(4);
          expect(data[4].id).to.equal(5);
        });
        sinon.assert.calledOnce(mockPost);
        sinon.assert.calledWith(mockPost, testUrl, searchObject);
        mockPost.flush();
      }));
      it('should make an http request to get a domain object', index_1.rlFakeAsync(function() {
        var id = 1;
        var mockItem = {id: id};
        var mockGet = index_1.mock.request(mockItem);
        mockHttp.get = mockGet;
        dataServiceBehavior.getItem({
          endpoint: testUrl,
          useMock: false,
          logRequests: false,
          getMockData: null
        }).subscribe(function(data) {
          expect(data).to.deep.equal(mockItem);
        });
        sinon.assert.calledOnce(mockGet);
        sinon.assert.calledWith(mockGet, testUrl);
        mockGet.flush();
      }));
      it('should make an http request to create a domain object', index_1.rlFakeAsync(function() {
        var mockItem = {id: 1};
        var mockPost = index_1.mock.request(mockItem);
        mockHttp.post = mockPost;
        dataServiceBehavior.create({
          domainObject: mockItem,
          endpoint: testUrl,
          useMock: false,
          logRequests: false,
          addMockData: null
        }).subscribe(function(data) {
          expect(data).to.deep.equal(mockItem);
        });
        sinon.assert.calledOnce(mockPost);
        sinon.assert.calledWith(mockPost, testUrl, mockItem);
        mockPost.flush();
      }));
      it('should make an http request to save an existing domain object', index_1.rlFakeAsync(function() {
        var mockItem = {id: 1};
        var mockPut = index_1.mock.request(mockItem);
        mockHttp.put = mockPut;
        dataServiceBehavior.update({
          domainObject: mockItem,
          endpoint: testUrl,
          useMock: false,
          logRequests: false,
          updateMockData: null
        }).subscribe(function(data) {
          expect(data).to.deep.equal(mockItem);
        });
        sinon.assert.calledOnce(mockPut);
        sinon.assert.calledWith(mockPut, testUrl, mockItem);
        mockPut.flush();
      }));
      it('should make an http request to delete an existing domain object', index_1.rlFakeAsync(function() {
        var mockItem = {id: 1};
        var mockDelete = index_1.mock.request();
        mockHttp.delete = mockDelete;
        dataServiceBehavior.delete({
          domainObject: mockItem,
          endpoint: testUrl,
          useMock: false,
          logRequests: false,
          removeMockData: null
        });
        sinon.assert.calledOnce(mockDelete);
        sinon.assert.calledWith(mockDelete, testUrl);
        mockDelete.flush();
      }));
    });
    describe('use mock', function() {
      var dataSet;
      beforeEach(function() {
        dataSet = [{
          id: 1,
          prop: 'item1'
        }, {
          id: 2,
          prop: 'item2'
        }, {
          id: 3,
          prop: 'item3'
        }];
        dataServiceBehavior = new baseDataServiceBehavior_1.BaseDataServiceBehavior(mockHttp, null);
      });
      it('should get the mocked data set', function(done) {
        dataServiceBehavior.getList({
          useMock: true,
          getMockData: function() {
            return dataSet;
          },
          endpoint: null,
          logRequests: false,
          params: null
        }).subscribe(function(data) {
          expect(data).to.have.length(3);
          expect(data[0]).to.equal(dataSet[0]);
          expect(data[1]).to.equal(dataSet[1]);
          expect(data[2]).to.equal(dataSet[2]);
          done();
        });
      });
      it('should get the mocked data set wrapped in a dataSet property', function(done) {
        dataServiceBehavior.search({
          useMock: true,
          getMockData: function() {
            return dataSet;
          },
          endpoint: null,
          logRequests: false,
          params: null
        }).subscribe(function(result) {
          var data = result.dataSet;
          expect(data).to.have.length(3);
          expect(data[0]).to.equal(dataSet[0]);
          expect(data[1]).to.equal(dataSet[1]);
          expect(data[2]).to.equal(dataSet[2]);
          done();
        });
      });
      it('should get an item from the mocked data set', function(done) {
        dataServiceBehavior.getItem({
          useMock: true,
          getMockData: function() {
            return dataSet[1];
          },
          endpoint: null,
          logRequests: false
        }).subscribe(function(data) {
          expect(data).to.equal(dataSet[1]);
          done();
        });
      });
      it('should create an item and call the add callback to add it to the mock data set', function(done) {
        var newItem = {
          id: null,
          prop: 'item4'
        };
        var addSpy = sinon.spy(function(item) {
          dataSet.push(item);
        });
        dataServiceBehavior.create({
          domainObject: newItem,
          useMock: true,
          addMockData: addSpy,
          endpoint: null,
          logRequests: false
        }).subscribe(function(data) {
          expect(data).to.equal(newItem);
          done();
        });
        sinon.assert.calledOnce(addSpy);
        sinon.assert.calledWith(addSpy, newItem);
        expect(dataSet[3]).to.equal(newItem);
      });
      it('should update an item', function(done) {
        var updatedItem = {
          id: 2,
          prop: 'made changes'
        };
        var updateSpy = sinon.spy(function(item) {
          dataSet[1] = item;
        });
        dataServiceBehavior.update({
          domainObject: updatedItem,
          useMock: true,
          updateMockData: updateSpy,
          endpoint: null,
          logRequests: false
        }).subscribe(function(data) {
          expect(data).to.equal(updatedItem);
          done();
        });
        sinon.assert.calledOnce(updateSpy);
        sinon.assert.calledWith(updateSpy, updatedItem);
        expect(dataSet[1]).to.equal(updatedItem);
      });
      it('should delete an item', function() {
        var removedItem = dataSet[1];
        var removeSpy = sinon.spy(function(item) {
          array_service_1.arrayUtility.remove(dataSet, item);
        });
        dataServiceBehavior.delete({
          domainObject: removedItem,
          useMock: true,
          removeMockData: removeSpy,
          endpoint: null,
          logRequests: false
        });
        sinon.assert.calledOnce(removeSpy);
        sinon.assert.calledWith(removeSpy, removedItem);
        expect(dataSet).to.have.length(2);
        expect(dataSet[0].id).to.equal(1);
        expect(dataSet[1].id).to.equal(3);
      });
    });
  });
  return module.exports;
});

System.registerDynamic("source/services/dataContracts/contractLibrary/contractLibrary.js", ["lodash", "../../test/mockAsync"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var _ = $__require('lodash');
  var mockAsync_1 = $__require('../../test/mockAsync');
  var ContractLibrary = (function() {
    function ContractLibrary(builder, baseEndpoint) {
      this.pendingRequests = [];
      this.builder = builder;
      this.baseEndpoint = baseEndpoint;
    }
    ContractLibrary.prototype.createResource = function(options) {
      var resource = this.builder.createResource(options);
      resource.url = this.baseEndpoint + resource.endpoint;
      return resource;
    };
    ContractLibrary.prototype.createResourceView = function(options) {
      var resource = this.builder.createResourceView(options);
      resource.url = this.baseEndpoint + resource.endpoint;
      return resource;
    };
    ContractLibrary.prototype.createParentResource = function(options) {
      var resource = this.builder.createParentResource(options);
      resource.url = this.baseEndpoint + resource.endpoint;
      return resource;
    };
    ContractLibrary.prototype.createParentResourceView = function(options) {
      var resource = this.builder.createParentResourceView(options);
      resource.url = this.baseEndpoint + resource.endpoint;
      return resource;
    };
    ContractLibrary.prototype.createSingletonResource = function(options) {
      var resource = this.builder.createSingletonResource(options);
      resource.url = this.baseEndpoint + resource.endpoint;
      return resource;
    };
    ContractLibrary.prototype.createParentSingletonResource = function(options) {
      var resource = this.builder.createParentSingletonResource(options);
      resource.url = this.baseEndpoint + resource.endpoint;
      return resource;
    };
    ContractLibrary.prototype.flush = function() {
      _.each(this.pendingRequests, function(request) {
        return request.flush();
      });
      this.pendingRequests = [];
    };
    ContractLibrary.prototype.mockGet = function(resource, data) {
      return this.baseMockGet(resource, 'get', data);
    };
    ContractLibrary.prototype.mockGetList = function(resource, data) {
      return this.baseMockGet(resource, 'getList', data);
    };
    ContractLibrary.prototype.mockGetDetail = function(resource, data) {
      return this.baseMockGet(resource, 'getDetail', data);
    };
    ContractLibrary.prototype.mockChild = function(parent, mockCallback) {
      var getChildren = parent.childContracts.bind(parent);
      parent.childContracts = function(id) {
        var children = getChildren(id);
        mockCallback(children);
        return children;
      };
    };
    ContractLibrary.prototype.createMock = function(resource) {
      var _this = this;
      var dataService = this.builder.createResource({});
      dataService.mockGetList = function(data) {
        return _this.baseMockGet(dataService, 'getList', data);
      };
      dataService.mockGetDetail = function(data) {
        return _this.baseMockGet(dataService, 'get', data);
      };
      dataService.mockUpdate = function(dataTransform) {
        return _this.baseMockSave(dataService, 'update', dataTransform);
      };
      dataService.mockCreate = function(dataTransform) {
        return _this.baseMockSave(dataService, 'create', dataTransform);
      };
      dataService.mockDelete = function() {
        return _this.baseMockSave(dataService, 'delete', function() {
          return null;
        });
      };
      dataService = this.updateResource(dataService, resource);
      return dataService;
    };
    ContractLibrary.prototype.createMockParent = function(resource) {
      var _this = this;
      var getChildren = resource != null ? resource.resourceDictionaryBuilder : function() {
        return {};
      };
      var dataService = this.builder.createParentResource({resourceDictionaryBuilder: getChildren});
      dataService.mockGetList = function(data) {
        return _this.baseMockGet(dataService, 'getList', data);
      };
      dataService.mockGetDetail = function(data) {
        return _this.baseMockGet(dataService, 'get', data);
      };
      dataService.mockChild = function(mockCallback) {
        return _this.mockChild(dataService, mockCallback);
      };
      dataService.mockUpdate = function(dataTransform) {
        return _this.baseMockSave(dataService, 'update', dataTransform);
      };
      dataService.mockCreate = function(dataTransform) {
        return _this.baseMockSave(dataService, 'create', dataTransform);
      };
      dataService.mockDelete = function() {
        return _this.baseMockSave(dataService, 'delete', function() {
          return null;
        });
      };
      dataService = this.updateResource(dataService, resource);
      return dataService;
    };
    ContractLibrary.prototype.createMockSingleton = function(resource) {
      var _this = this;
      var dataService = this.builder.createSingletonResource({});
      dataService.mockGet = function(data) {
        return _this.baseMockGet(dataService, 'get', data);
      };
      dataService.mockUpdate = function(dataTransform) {
        return _this.baseMockSave(dataService, 'update', dataTransform);
      };
      dataService = this.updateResource(dataService, resource);
      return dataService;
    };
    ContractLibrary.prototype.updateResource = function(dataService, resource) {
      if (resource != null) {
        dataService = _.extend(resource, dataService);
      }
      if (!dataService.url) {
        dataService.url = '/test';
      }
      return dataService;
    };
    ContractLibrary.prototype.baseMockGet = function(resource, actionName, data) {
      var func = mockAsync_1.mock.request(data);
      this.pendingRequests.push(func);
      resource[actionName] = func;
      return func;
    };
    ContractLibrary.prototype.baseMockSave = function(resource, actionName, dataTransform) {
      var func = mockAsync_1.mock.request(function(data) {
        return dataTransform ? dataTransform(data) : data;
      });
      this.pendingRequests.push(func);
      resource[actionName] = func;
      return func;
    };
    Object.defineProperty(ContractLibrary.prototype, "sinon", {
      get: function() {
        return sinon || {spy: function(func) {
            return func;
          }};
      },
      enumerable: true,
      configurable: true
    });
    return ContractLibrary;
  }());
  exports.ContractLibrary = ContractLibrary;
  return module.exports;
});

System.registerDynamic("source/services/dataContracts/contractLibrary/contractLibrary.tests.js", ["./contractLibrary", "../resourceBuilder/resourceBuilder.service"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var __extends = (this && this.__extends) || function(d, b) {
    for (var p in b)
      if (b.hasOwnProperty(p))
        d[p] = b[p];
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
  var contractLibrary_1 = $__require('./contractLibrary');
  var resourceBuilder_service_1 = $__require('../resourceBuilder/resourceBuilder.service');
  function testChildBuilder(resourceBuilder) {
    return function() {
      return {
        childResource: resourceBuilder.createResource({endpoint: '/childResource'}),
        resourceView: resourceBuilder.createResourceView({endpoint: '/resourceView'})
      };
    };
  }
  var TestLibrary = (function(_super) {
    __extends(TestLibrary, _super);
    function TestLibrary(resourceBuilder) {
      _super.call(this, resourceBuilder, 'www.example.com/api');
      this.resource1 = this.createResource({endpoint: '/test'});
      this.parent1 = this.createParentResource({
        endpoint: '/parent1',
        resourceDictionaryBuilder: testChildBuilder(resourceBuilder)
      });
      this.parentSingleton = this.createParentResourceView({
        endpoint: '/parentSingleton',
        resourceDictionaryBuilder: testChildBuilder(resourceBuilder)
      });
    }
    return TestLibrary;
  }(contractLibrary_1.ContractLibrary));
  describe('contractLibrary', function() {
    var testLibrary;
    var resourceBuilder;
    beforeEach(function() {
      resourceBuilder = new resourceBuilder_service_1.ResourceBuilder({}, {});
      testLibrary = new TestLibrary(resourceBuilder);
    });
    describe('urls', function() {
      it('should build the url of the resource using the base endpoint', function() {
        expect(testLibrary.resource1.endpoint).to.equal('/test');
        expect(testLibrary.resource1.url).to.equal('www.example.com/api/test');
      });
      it('should default to the endpoint if the builder is used directly', function() {
        testLibrary.resource1 = resourceBuilder.createResource({endpoint: '/test'});
        expect(testLibrary.resource1.url).to.equal('/test');
      });
      it('should build the child url from the parent', function() {
        expect(testLibrary.parent1.childContracts().childResource.url).to.equal('www.example.com/api/parent1/childResource');
        expect(testLibrary.parent1.childContracts().resourceView.url).to.equal('www.example.com/api/parent1/resourceView');
        expect(testLibrary.parentSingleton.childContracts().childResource.url).to.equal('www.example.com/api/parentSingleton/childResource');
        expect(testLibrary.parentSingleton.childContracts().resourceView.url).to.equal('www.example.com/api/parentSingleton/resourceView');
      });
      it('should append the id of the parent if a parent is selected', function() {
        expect(testLibrary.parent1.childContracts(11).childResource.url).to.equal('www.example.com/api/parent1/11/childResource');
        expect(testLibrary.parent1.childContracts(11).resourceView.url).to.equal('www.example.com/api/parent1/11/resourceView');
      });
    });
  });
  return module.exports;
});

System.registerDynamic("source/services/dataContracts/converters/aliasConverter/aliasConverter.tests.js", ["./aliasConverter", "../converters"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var aliasConverter_1 = $__require('./aliasConverter');
  var converters_1 = $__require('../converters');
  describe('aliasConverter', function() {
    var aliasConverter;
    beforeEach(function() {
      aliasConverter = new aliasConverter_1.AliasConverter('propValue');
    });
    it('should get the property from the parent context using the specified property name', function() {
      var parent = {propValue: 'value'};
      expect(aliasConverter.fromServer(undefined, parent)).to.equal('value');
    });
    it('should set the value on the parent context using the specified property name', function() {
      var parent = {};
      aliasConverter.toServer('value', parent);
      expect(parent.propValue).to.equal('value');
    });
    it('should return null if alias property doesnt exist on the parent', function() {
      var parent = {};
      expect(aliasConverter.fromServer(undefined, parent)).to.be.null;
    });
    it('should apply another converter to the aliased property', function() {
      var testConverter = {
        fromServer: sinon.spy(),
        toServer: sinon.spy()
      };
      aliasConverter = new aliasConverter_1.AliasConverter('propValue', testConverter);
      var parent = {propValue: 'value'};
      aliasConverter.fromServer(undefined, parent);
      sinon.assert.calledOnce(testConverter.fromServer);
      sinon.assert.calledWith(testConverter.fromServer, 'value');
      aliasConverter.toServer('value', parent);
      sinon.assert.calledOnce(testConverter.toServer);
      sinon.assert.calledWith(testConverter.toServer, 'value');
    });
    describe('integrationTest', function() {
      var testConverter;
      var transform;
      var serverData;
      beforeEach(function() {
        testConverter = {
          fromServer: function(value) {
            return value + 5;
          },
          toServer: function(value) {
            return value - 5;
          }
        };
        transform = {
          value: new aliasConverter_1.AliasConverter('valueFromServer'),
          number: new aliasConverter_1.AliasConverter('numberFromServer', testConverter)
        };
        serverData = {
          valueFromServer: 5,
          numberFromServer: 5
        };
      });
      it('should apply an alias as part of a transform mapping', function() {
        var transformedData = converters_1.converterService.applyTransform(serverData, transform, false);
        expect(transformedData.value).to.equal(5);
        expect(transformedData.number).to.equal(10);
        serverData = converters_1.converterService.applyTransform(transformedData, transform, true);
        expect(serverData.valueFromServer).to.equal(5);
        expect(serverData.numberFromServer).to.equal(5);
      });
      it('should cleanup the value at the original key of the alias', function() {
        var transformedData = converters_1.converterService.applyTransform(serverData, transform, false);
        expect(transformedData.valueFromServer).to.not.exist;
        expect(transformedData.numberFromServer).to.not.exist;
        serverData = converters_1.converterService.applyTransform(transformedData, transform, true);
        expect(serverData.value).to.not.exist;
        expect(serverData.number).to.not.exist;
      });
    });
  });
  return module.exports;
});

System.registerDynamic("source/services/dataContracts/converters/converters.tests.js", ["./converters"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var converters_1 = $__require('./converters');
  describe('Converters', function() {
    var transform;
    var numberConverter;
    beforeEach(function() {
      transform = {
        fromServer: sinon.spy(function(rawData) {
          return rawData.prop;
        }),
        toServer: sinon.spy(function(data) {
          return {prop: data};
        })
      };
      numberConverter = {
        fromServer: sinon.spy(function(rawData) {
          return rawData + 1;
        }),
        toServer: sinon.spy(function(data) {
          return data - 1;
        })
      };
    });
    it('should transform each entry in the list', function() {
      var dataSet = [{
        id: 1,
        prop: 'item1'
      }, {
        id: 2,
        prop: 'item2'
      }, {
        id: 3,
        prop: 'item3'
      }];
      var transformedData = converters_1.converterService.applyTransform(dataSet, transform, false);
      expect(transformedData).to.have.length(3);
      expect(transformedData[0]).to.equal(dataSet[0].prop);
      expect(transformedData[1]).to.equal(dataSet[1].prop);
      expect(transformedData[2]).to.equal(dataSet[2].prop);
      sinon.assert.calledThrice(transform.fromServer);
    });
    it('should transform a single item', function() {
      var item = {prop: 'item1'};
      var transformedItem = converters_1.converterService.applyTransform(item, transform, false);
      expect(transformedItem).to.equal(item.prop);
      sinon.assert.calledOnce(transform.fromServer);
    });
    it('should reverse the transformation if toServer is specified', function() {
      var item = 'item1';
      var transformedItem = converters_1.converterService.applyTransform(item, transform, true);
      expect(transformedItem.prop).to.equal(item);
      sinon.assert.calledOnce(transform.toServer);
    });
    it('should use a an object map to transform properties', function() {
      var map = {prop1: numberConverter};
      var item = {
        prop1: 4,
        prop2: 4
      };
      var transformedItem = converters_1.converterService.applyTransform(item, map, false);
      expect(transformedItem.prop1).to.equal(5);
      expect(transformedItem.prop2).to.equal(4);
      sinon.assert.calledOnce(numberConverter.fromServer);
    });
    it('should transform properties in reverse if toServer is specified', function() {
      var map = {prop1: numberConverter};
      var item = {
        prop1: 5,
        prop2: 4
      };
      var transformedItem = converters_1.converterService.applyTransform(item, map, true);
      expect(transformedItem.prop1).to.equal(4);
      expect(transformedItem.prop2).to.equal(4);
      sinon.assert.calledOnce(numberConverter.toServer);
    });
    it('should recursively transform nested object properties', function() {
      var map = {obj: {prop1: numberConverter}};
      var item = {obj: {
          prop1: 4,
          prop2: 4
        }};
      var transformedItem = converters_1.converterService.applyTransform(item, map, false);
      expect(transformedItem.obj.prop1).to.equal(5);
      expect(transformedItem.obj.prop2).to.equal(4);
      sinon.assert.calledOnce(numberConverter.fromServer);
    });
    it('should provide the parent object to a property transform', function() {
      var converter = {
        fromServer: sinon.spy(function(prop) {
          return prop;
        }),
        toServer: sinon.spy(function(prop) {
          return prop;
        })
      };
      var map = {prop: converter};
      var item = {prop: 'value'};
      converters_1.converterService.applyTransform(item, map, false);
      sinon.assert.calledOnce(converter.fromServer);
      var args = converter.fromServer.firstCall.args;
      expect(args[0]).to.equal('value');
      expect(args[1]).to.deep.equal(item);
      converters_1.converterService.applyTransform(item, map, true);
      sinon.assert.calledOnce(converter.toServer);
      args = converter.toServer.firstCall.args;
      expect(args[0]).to.equal('value');
      expect(args[1]).to.deep.equal(item);
    });
  });
  return module.exports;
});

System.registerDynamic("source/services/dataContracts/converters/dateConverter/dateConverter.tests.js", ["./dateConverter", "../../../timezone/timezone.enum", "moment", "moment-timezone"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var dateConverter_1 = $__require('./dateConverter');
  var timezone_enum_1 = $__require('../../../timezone/timezone.enum');
  var moment = $__require('moment');
  $__require('moment-timezone');
  describe('dateConverter', function() {
    it('should get the date from an ISO string', function() {
      var expectedDate = moment('2015-11-24T20:12:00-06:00', dateConverter_1.defaultFormats.isoFormat).tz(timezone_enum_1.timezones.CST.momentName);
      expect(dateConverter_1.dateConverter.fromServer('2015-11-24T20:12:00-06:00')).to.deep.equal(expectedDate);
    });
    it('should convert the date to an ISO string', function() {
      var date = moment('2015-11-24T20:12:00-06:00', dateConverter_1.defaultFormats.isoFormat).tz(timezone_enum_1.timezones.CST.momentName);
      expect(dateConverter_1.dateConverter.toServer(date)).to.equal('2015-11-24T20:12:00-06:00');
    });
    it('should handle nulls', function() {
      expect(dateConverter_1.dateConverter.toServer(null)).to.be.null;
    });
  });
  return module.exports;
});

System.registerDynamic("source/types/itemList.js", ["lodash"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var __extends = (this && this.__extends) || function(d, b) {
    for (var p in b)
      if (b.hasOwnProperty(p))
        d[p] = b[p];
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
  var _ = $__require('lodash');
  var ItemList = (function() {
    function ItemList() {}
    ItemList.prototype.setItems = function(items) {
      this.items = items;
    };
    ItemList.prototype.get = function(value) {
      var predicate;
      if (typeof value === 'string') {
        predicate = function(item) {
          return (item.name === value);
        };
      } else {
        predicate = function(item) {
          return (item.value === value);
        };
      }
      return _.find(this.items, predicate);
    };
    ItemList.prototype.all = function() {
      return this.items;
    };
    return ItemList;
  }());
  exports.ItemList = ItemList;
  var SortedItemList = (function(_super) {
    __extends(SortedItemList, _super);
    function SortedItemList() {
      _super.apply(this, arguments);
    }
    SortedItemList.prototype.setItems = function(items) {
      _super.prototype.setItems.call(this, _.sortBy(items, function(x) {
        return x.display;
      }));
    };
    return SortedItemList;
  }(ItemList));
  exports.SortedItemList = SortedItemList;
  return module.exports;
});

System.registerDynamic("source/services/dataContracts/converters/enumConverter/enumConverter.tests.js", ["./enumConverter", "../../../../types/itemList"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var __extends = (this && this.__extends) || function(d, b) {
    for (var p in b)
      if (b.hasOwnProperty(p))
        d[p] = b[p];
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
  var enumConverter_1 = $__require('./enumConverter');
  var itemList_1 = $__require('../../../../types/itemList');
  var TestEnum = (function(_super) {
    __extends(TestEnum, _super);
    function TestEnum() {
      _super.call(this);
      this.type1 = {
        value: 0,
        name: 'type1',
        display: 'Type 1'
      };
      this.type2 = {
        value: 1,
        name: 'type2',
        display: 'Type 2'
      };
      _super.prototype.setItems.call(this, [this.type1, this.type2]);
    }
    return TestEnum;
  }(itemList_1.ItemList));
  var testEnum = new TestEnum();
  var enumConverter = new enumConverter_1.EnumConverter(testEnum);
  describe('enumConverter', function() {
    it('should get the enum type for the specified value', function() {
      expect(enumConverter.fromServer(0)).to.equal(testEnum.type1);
      expect(enumConverter.fromServer(1)).to.equal(testEnum.type2);
    });
    it('should get the value of the enum type', function() {
      expect(enumConverter.toServer(testEnum.type1)).to.equal(0);
      expect(enumConverter.toServer(testEnum.type2)).to.equal(1);
    });
    it('should return undefined if an invalid value is specified', function() {
      expect(enumConverter.fromServer(10)).to.not.exist;
      expect(enumConverter.fromServer(null)).to.not.exist;
    });
    it('should return null if the enum type is null', function() {
      expect(enumConverter.toServer(null)).to.not.exist;
    });
  });
  return module.exports;
});

System.registerDynamic("source/services/dataContracts/converters/timeConverter/timeConverter.tests.js", ["./timeConverter", "../../../timezone/timezone.service", "moment", "moment-timezone"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var timeConverter_1 = $__require('./timeConverter');
  var timezone_service_1 = $__require('../../../timezone/timezone.service');
  var moment = $__require('moment');
  $__require('moment-timezone');
  describe('timeConverter', function() {
    it('should get the time from a time string and set the user timezone', function() {
      timezone_service_1.timezoneService.setCurrentTimezone(timezone_service_1.timezones.CST.offset);
      var timeMoment = timeConverter_1.timeConverter.fromServer('8:00PM');
      expect(timeMoment.tz()).to.equal(timezone_service_1.timezones.CST.momentName);
      expect(timeMoment.format(timeConverter_1.defaultFormats.timeFormat)).to.equal('8:00PM');
    });
    it('should convert the moment back to a time string', function() {
      var timeMoment = moment('2016-01-02T20:00:00-07:00', timeConverter_1.defaultFormats.isoFormat).tz(timezone_service_1.timezones.MST.momentName);
      expect(timeConverter_1.timeConverter.toServer(timeMoment)).to.equal('8:00PM');
    });
    it('should handle nulls', function() {
      expect(timeConverter_1.timeConverter.fromServer(null)).to.be.null;
      expect(timeConverter_1.timeConverter.toServer(null)).to.be.null;
    });
  });
  return module.exports;
});

System.registerDynamic("source/services/dataContracts/dataContractsHelper/dataContractsHelper.service.tests.js", ["./dataContractsHelper.service"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var dataContractsHelper_service_1 = $__require('./dataContractsHelper.service');
  describe('data contracts helper', function() {
    it('should version the url', function() {
      expect(dataContractsHelper_service_1.helper.versionEndpoint('/api/test', 2)).to.equal('/api/v2/test');
    });
    it('should replace the previous version if one is already specified', function() {
      expect(dataContractsHelper_service_1.helper.versionEndpoint('api/v2/test', 3)).to.equal('api/v3/test');
    });
  });
  return module.exports;
});

System.registerDynamic("source/services/dataContracts/dataService/view/dataServiceView.js", ["../data.service", "../parent/parentData.service", "../../singletonDataService/singletonData.service", "../../singletonDataService/parent/parentSingletonData.service", "lodash"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var __extends = (this && this.__extends) || function(d, b) {
    for (var p in b)
      if (b.hasOwnProperty(p))
        d[p] = b[p];
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
  var data_service_1 = $__require('../data.service');
  var parentData_service_1 = $__require('../parent/parentData.service');
  var singletonData_service_1 = $__require('../../singletonDataService/singletonData.service');
  var parentSingletonData_service_1 = $__require('../../singletonDataService/parent/parentSingletonData.service');
  var _ = $__require('lodash');
  var DataServiceView = (function(_super) {
    __extends(DataServiceView, _super);
    function DataServiceView(http, array, options) {
      _super.call(this, http, array, options);
      this.http = http;
      this.transform = options.transform;
    }
    DataServiceView.prototype.AsSingleton = function(parentId) {
      var mockData = _.find(this.mockData, function(item) {
        return item.id === parentId;
      });
      var singleton = new singletonData_service_1.SingletonDataService(this.http, {
        endpoint: this.endpoint,
        mockData: mockData,
        transform: this.transform,
        useMock: this.useMock,
        logRequests: this.logRequests
      });
      singleton.url = this.url;
      return singleton;
    };
    return DataServiceView;
  }(data_service_1.DataService));
  exports.DataServiceView = DataServiceView;
  var ParentDataServiceView = (function(_super) {
    __extends(ParentDataServiceView, _super);
    function ParentDataServiceView(http, array, options) {
      _super.call(this, http, array, options);
      this.http = http;
    }
    ParentDataServiceView.prototype.AsSingleton = function(parentId) {
      var mockData = _.find(this.mockData, function(item) {
        return item.id === parentId;
      });
      var singleton = new parentSingletonData_service_1.ParentSingletonDataService(this.http, {
        endpoint: this.endpoint,
        mockData: mockData,
        resourceDictionaryBuilder: this.resourceDictionaryBuilder,
        transform: this.transform,
        useMock: this.useMock,
        logRequests: this.logRequests,
        parentId: parentId
      });
      singleton.url = this.url;
      return singleton;
    };
    return ParentDataServiceView;
  }(parentData_service_1.ParentDataService));
  exports.ParentDataServiceView = ParentDataServiceView;
  return module.exports;
});

System.registerDynamic("source/services/dataContracts/dataService/data.service.js", ["@angular/core", "lodash", "../../array/array.service", "../../http/http.service", "../baseDataServiceBehavior", "../dataContractsHelper/dataContractsHelper.service"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var __decorate = (this && this.__decorate) || function(decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
      r = Reflect.decorate(decorators, target, key, desc);
    else
      for (var i = decorators.length - 1; i >= 0; i--)
        if (d = decorators[i])
          r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
  };
  var __metadata = (this && this.__metadata) || function(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
      return Reflect.metadata(k, v);
  };
  var core_1 = $__require('@angular/core');
  var _ = $__require('lodash');
  var array_service_1 = $__require('../../array/array.service');
  var http_service_1 = $__require('../../http/http.service');
  var baseDataServiceBehavior_1 = $__require('../baseDataServiceBehavior');
  var dataContractsHelper_service_1 = $__require('../dataContractsHelper/dataContractsHelper.service');
  var DataService = (function() {
    function DataService(http, array, options) {
      this.array = array;
      this.behavior = new baseDataServiceBehavior_1.BaseDataServiceBehavior(http, options.transform);
      this.useDeepSearch = options.useDeepSearch;
      this.mockData = options.mockData;
      this.endpoint = options.endpoint;
      this.url = this.endpoint;
      this.useMock = options.useMock;
      this.logRequests = options.logRequests;
    }
    DataService.prototype.getItemEndpoint = function(id) {
      return this.url + '/' + id.toString();
    };
    DataService.prototype.getList = function(params) {
      var _this = this;
      var requestParams = {
        params: params,
        endpoint: this.url,
        getMockData: function() {
          return _this.mockData;
        },
        useMock: this.useMock,
        logRequests: this.logRequests
      };
      if (this.useDeepSearch) {
        return this.behavior.search(requestParams);
      } else {
        return this.behavior.getList(requestParams);
      }
    };
    DataService.prototype.getDetail = function(id) {
      var _this = this;
      return this.behavior.getItem({
        endpoint: this.getItemEndpoint(id),
        getMockData: function() {
          return _.find(_this.mockData, function(item) {
            return item.id === id;
          });
        },
        useMock: this.useMock,
        logRequests: this.logRequests
      });
    };
    DataService.prototype.create = function(domainObject) {
      var _this = this;
      return this.behavior.create({
        domainObject: domainObject,
        endpoint: this.url,
        addMockData: function(data) {
          var nextId = _.maxBy(_this.mockData, 'id').id + 1;
          domainObject.id = nextId;
          _this.mockData.push(domainObject);
        },
        useMock: this.useMock,
        logRequests: this.logRequests
      });
    };
    DataService.prototype.update = function(domainObject) {
      var _this = this;
      return this.behavior.update({
        domainObject: domainObject,
        endpoint: this.getItemEndpoint(domainObject.id),
        updateMockData: function(data) {
          var oldObject = _.find(_this.mockData, function(item) {
            return item.id === data.id;
          });
          oldObject = _.assign(oldObject, data);
        },
        useMock: this.useMock,
        logRequests: this.logRequests
      });
    };
    DataService.prototype.delete = function(domainObject) {
      var _this = this;
      return this.behavior.delete({
        domainObject: domainObject,
        endpoint: this.getItemEndpoint(domainObject.id),
        removeMockData: function(data) {
          _this.array.remove(_this.mockData, domainObject);
        },
        useMock: this.useMock,
        logRequests: this.logRequests
      });
    };
    DataService.prototype.version = function(versionNumber) {
      var dataService = _.clone(this);
      dataService.url = dataContractsHelper_service_1.helper.versionEndpoint(dataService.url, versionNumber);
      return dataService;
    };
    DataService = __decorate([core_1.Injectable(), __metadata('design:paramtypes', [http_service_1.HttpUtility, array_service_1.ArrayUtility, Object])], DataService);
    return DataService;
  }());
  exports.DataService = DataService;
  var DataServiceFactory = (function() {
    function DataServiceFactory(http, array) {
      this.http = http;
      this.array = array;
    }
    DataServiceFactory.prototype.getInstance = function(options) {
      return new DataService(this.http, this.array, options);
    };
    DataServiceFactory = __decorate([core_1.Injectable(), __metadata('design:paramtypes', [http_service_1.HttpUtility, array_service_1.ArrayUtility])], DataServiceFactory);
    return DataServiceFactory;
  }());
  exports.DataServiceFactory = DataServiceFactory;
  function DataServiceProvider(options) {
    return core_1.provide(DataService, {
      deps: [http_service_1.HttpUtility, array_service_1.ArrayUtility],
      useFactory: function(http, array) {
        return new DataService(http, array, options);
      }
    });
  }
  exports.DataServiceProvider = DataServiceProvider;
  return module.exports;
});

System.registerDynamic("source/services/dataContracts/dataService/parent/parentData.service.js", ["lodash", "../data.service"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var __extends = (this && this.__extends) || function(d, b) {
    for (var p in b)
      if (b.hasOwnProperty(p))
        d[p] = b[p];
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
  var _ = $__require('lodash');
  var data_service_1 = $__require('../data.service');
  var ParentDataService = (function(_super) {
    __extends(ParentDataService, _super);
    function ParentDataService(http, array, options) {
      _super.call(this, http, array, options);
      this.resourceDictionaryBuilder = options.resourceDictionaryBuilder;
    }
    ParentDataService.prototype.childContracts = function(id) {
      var _this = this;
      if (_.isUndefined(id)) {
        var dictionary = this.resourceDictionaryBuilder();
        _.each(dictionary, function(dataService) {
          dataService.url = _this.url + dataService.endpoint;
        });
        return dictionary;
      } else {
        var dictionary = this.resourceDictionaryBuilder();
        return _.mapValues(dictionary, function(dataService) {
          var contract;
          if (_.isFunction(dataService.AsSingleton)) {
            contract = dataService.AsSingleton(id);
          } else {
            contract = dataService;
          }
          contract.url = _this.url + '/' + id + contract.endpoint;
          return contract;
        });
      }
    };
    return ParentDataService;
  }(data_service_1.DataService));
  exports.ParentDataService = ParentDataService;
  return module.exports;
});

System.registerDynamic("source/services/dataContracts/converters/aliasConverter/aliasConverter.js", ["lodash"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var _ = $__require('lodash');
  var AliasConverter = (function() {
    function AliasConverter(alias, composedConverter) {
      var _this = this;
      this.alias = alias;
      this.composedConverter = composedConverter;
      this.fromServer = function(raw, parent) {
        if (!_.has(parent, _this.alias)) {
          return null;
        }
        raw = parent[_this.alias];
        delete parent[_this.alias];
        if (_this.composedConverter != null) {
          return _this.composedConverter.fromServer(raw, parent);
        }
        return raw;
      };
      this.toServer = function(data, parent) {
        if (_this.composedConverter != null) {
          data = _this.composedConverter.toServer(data, parent);
        }
        parent[_this.alias] = data;
        return null;
      };
    }
    return AliasConverter;
  }());
  exports.AliasConverter = AliasConverter;
  return module.exports;
});

System.registerDynamic("source/services/dataContracts/converters/dateConverter/dateConverter.js", ["moment", "../../../date/index"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var moment = $__require('moment');
  var index_1 = $__require('../../../date/index');
  exports.defaultFormats = index_1.defaultFormats;
  exports.dateConverter = {
    fromServer: function(raw) {
      return index_1.dateUtility.getDateFromISOString(raw);
    },
    toServer: function(data) {
      return data != null ? moment(data).format(index_1.defaultFormats.isoFormat) : null;
    }
  };
  return module.exports;
});

System.registerDynamic("source/services/dataContracts/converters/enumConverter/enumConverter.js", [], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var EnumConverter = (function() {
    function EnumConverter(enumType) {
      var _this = this;
      this.enumType = enumType;
      this.fromServer = function(raw) {
        return _this.enumType.get(raw);
      };
      this.toServer = function(data) {
        return data != null ? data.value : null;
      };
    }
    return EnumConverter;
  }());
  exports.EnumConverter = EnumConverter;
  ;
  return module.exports;
});

System.registerDynamic("source/services/dataContracts/converters/timeConverter/timeConverter.js", ["moment", "../../../date/index", "../../../timezone/timezone.service"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var moment = $__require('moment');
  var index_1 = $__require('../../../date/index');
  exports.defaultFormats = index_1.defaultFormats;
  var timezone_service_1 = $__require('../../../timezone/timezone.service');
  exports.timeConverter = {
    fromServer: function(raw) {
      return raw != null ? timezone_service_1.timezoneService.buildMomentWithTimezone(raw, timezone_service_1.timezoneService.currentTimezone, index_1.defaultFormats.timeFormat) : null;
    },
    toServer: function(data) {
      return data != null ? moment(data).format(index_1.defaultFormats.timeFormat) : null;
    }
  };
  return module.exports;
});

System.registerDynamic("source/services/dataContracts/converters/converters.js", ["./aliasConverter/aliasConverter", "./dateConverter/dateConverter", "./enumConverter/enumConverter", "./timeConverter/timeConverter", "lodash", "../../object/object.service"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  function __export(m) {
    for (var p in m)
      if (!exports.hasOwnProperty(p))
        exports[p] = m[p];
  }
  __export($__require('./aliasConverter/aliasConverter'));
  __export($__require('./dateConverter/dateConverter'));
  __export($__require('./enumConverter/enumConverter'));
  __export($__require('./timeConverter/timeConverter'));
  var _ = $__require('lodash');
  var object_service_1 = $__require('../../object/object.service');
  var ConverterService = (function() {
    function ConverterService() {}
    ConverterService.prototype.applyTransform = function(data, transform, toServer, parent) {
      var _this = this;
      if (transform == null || (parent == null && object_service_1.objectUtility.isNullOrEmpty(data))) {
        return data;
      }
      if (_.isArray(data)) {
        return _.map(data, function(item) {
          return _this.applyTransform(item, transform, toServer);
        });
      }
      if (this.isConverter(transform)) {
        var transformFunc = toServer ? transform.toServer : transform.fromServer;
        return transformFunc(data, parent);
      } else {
        var mappedData_1 = _.clone(data);
        _.each(transform, function(childTransform, key) {
          mappedData_1[key] = _this.applyTransform(_.get(mappedData_1, key), childTransform, toServer, mappedData_1);
        });
        return mappedData_1;
      }
    };
    ConverterService.prototype.isConverter = function(object) {
      return _.isFunction(object.fromServer) || _.isFunction(object.toServer);
    };
    return ConverterService;
  }());
  exports.ConverterService = ConverterService;
  exports.converterService = new ConverterService();
  return module.exports;
});

System.registerDynamic("source/services/dataContracts/baseDataServiceBehavior.js", ["rxjs", "./converters/converters"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var rxjs_1 = $__require('rxjs');
  var converters_1 = $__require('./converters/converters');
  var BaseDataServiceBehavior = (function() {
    function BaseDataServiceBehavior(http, transform) {
      this.http = http;
      this.transform = transform;
    }
    BaseDataServiceBehavior.prototype.getList = function(options) {
      var _this = this;
      var request;
      if (options.useMock) {
        request = rxjs_1.Observable.of(options.getMockData());
      } else {
        request = this.http.get(options.endpoint, options.params);
      }
      return request.map(function(data) {
        data = converters_1.converterService.applyTransform(data, _this.transform, false);
        if (options.logRequests) {
          _this.log('getList', options.params, data, options.endpoint, options.useMock);
        }
        return data;
      });
    };
    BaseDataServiceBehavior.prototype.search = function(options) {
      var _this = this;
      var request;
      if (options.useMock) {
        request = rxjs_1.Observable.of({dataSet: options.getMockData()});
      } else {
        request = this.http.post(options.endpoint, options.params);
      }
      return request.map(function(result) {
        result.dataSet = converters_1.converterService.applyTransform(result.dataSet, _this.transform, false);
        if (options.logRequests) {
          _this.log('search', options.params, result, options.endpoint, options.useMock);
        }
        return result;
      });
    };
    BaseDataServiceBehavior.prototype.getItem = function(options) {
      var _this = this;
      var promise;
      if (options.useMock) {
        promise = rxjs_1.Observable.of(options.getMockData());
      } else {
        promise = this.http.get(options.endpoint);
      }
      return promise.map(function(data) {
        data = converters_1.converterService.applyTransform(data, _this.transform, false);
        if (options.logRequests) {
          _this.log('get', null, data, options.endpoint, options.useMock);
        }
        return data;
      });
    };
    BaseDataServiceBehavior.prototype.create = function(options) {
      var _this = this;
      var promise;
      options.domainObject = converters_1.converterService.applyTransform(options.domainObject, this.transform, true);
      if (options.useMock) {
        options.addMockData(options.domainObject);
        promise = rxjs_1.Observable.of(options.domainObject);
      } else {
        promise = this.http.post(options.endpoint, options.domainObject);
      }
      return promise.map(function(data) {
        data = converters_1.converterService.applyTransform(data, _this.transform, false);
        if (options.logRequests) {
          _this.log('create', options.domainObject, data, options.endpoint, options.useMock);
        }
        return data;
      });
    };
    BaseDataServiceBehavior.prototype.update = function(options) {
      var _this = this;
      var promise;
      options.domainObject = converters_1.converterService.applyTransform(options.domainObject, this.transform, true);
      if (options.useMock) {
        options.updateMockData(options.domainObject);
        promise = rxjs_1.Observable.of(options.domainObject);
      } else {
        promise = this.http.put(options.endpoint, options.domainObject);
      }
      return promise.map(function(data) {
        data = converters_1.converterService.applyTransform(data, _this.transform, false);
        if (options.logRequests) {
          _this.log('update', options.domainObject, data, options.endpoint, options.useMock);
        }
        return data;
      });
    };
    BaseDataServiceBehavior.prototype.delete = function(options) {
      var _this = this;
      var promise;
      if (options.useMock) {
        options.removeMockData(options.domainObject);
        promise = rxjs_1.Observable.empty();
      } else {
        promise = this.http.delete(options.endpoint);
      }
      return promise.map(function() {
        if (options.logRequests) {
          _this.log('delete', options.domainObject, null, options.endpoint, options.useMock);
        }
      });
    };
    BaseDataServiceBehavior.prototype.log = function(requestName, params, data, endpoint, useMock) {
      var mockString = useMock ? 'Mocked ' : '';
      var endpointString = endpoint == null ? 'unspecified' : endpoint;
      console.log(mockString + requestName + ' for endpoint ' + endpointString + ':');
      if (params != null) {
        console.log('params:');
        console.log(params);
      }
      if (data != null) {
        console.log('data:');
        console.log(data);
      }
    };
    return BaseDataServiceBehavior;
  }());
  exports.BaseDataServiceBehavior = BaseDataServiceBehavior;
  return module.exports;
});

System.registerDynamic("source/services/dataContracts/dataContractsHelper/dataContractsHelper.service.js", [], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var DataContractsHelper = (function() {
    function DataContractsHelper() {}
    DataContractsHelper.prototype.versionEndpoint = function(endpoint, versionNumber) {
      var versionExpression = /\/v\d+\//;
      var apiExpression = /\/api\//;
      var versionString = 'v' + versionNumber;
      var searchResult = endpoint.search(versionExpression);
      if (searchResult !== -1) {
        return endpoint.replace(versionExpression, '/' + versionString + '/');
      } else {
        return endpoint.replace(apiExpression, '/api/' + versionString + '/');
      }
    };
    return DataContractsHelper;
  }());
  exports.helper = new DataContractsHelper();
  return module.exports;
});

System.registerDynamic("source/services/dataContracts/singletonDataService/singletonData.service.js", ["@angular/core", "lodash", "../../http/http.service", "../baseDataServiceBehavior", "../dataContractsHelper/dataContractsHelper.service"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var __decorate = (this && this.__decorate) || function(decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
      r = Reflect.decorate(decorators, target, key, desc);
    else
      for (var i = decorators.length - 1; i >= 0; i--)
        if (d = decorators[i])
          r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
  };
  var __metadata = (this && this.__metadata) || function(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
      return Reflect.metadata(k, v);
  };
  var core_1 = $__require('@angular/core');
  var _ = $__require('lodash');
  var http_service_1 = $__require('../../http/http.service');
  var baseDataServiceBehavior_1 = $__require('../baseDataServiceBehavior');
  var dataContractsHelper_service_1 = $__require('../dataContractsHelper/dataContractsHelper.service');
  var SingletonDataService = (function() {
    function SingletonDataService(http, options) {
      this.behavior = new baseDataServiceBehavior_1.BaseDataServiceBehavior(http, options.transform);
      this.mockData = options.mockData;
      this.endpoint = options.endpoint;
      this.url = this.endpoint;
      this.useMock = options.useMock;
      this.logRequests = options.logRequests;
    }
    SingletonDataService.prototype.get = function() {
      var _this = this;
      return this.behavior.getItem({
        endpoint: this.url,
        getMockData: function() {
          return _this.mockData;
        },
        useMock: this.useMock,
        logRequests: this.logRequests
      });
    };
    SingletonDataService.prototype.update = function(domainObject) {
      var _this = this;
      return this.behavior.update({
        domainObject: domainObject,
        endpoint: this.url,
        updateMockData: function(data) {
          _this.mockData = _.assign(_this.mockData, domainObject);
        },
        useMock: this.useMock,
        logRequests: this.logRequests
      });
    };
    SingletonDataService.prototype.version = function(versionNumber) {
      var dataService = _.clone(this);
      dataService.url = dataContractsHelper_service_1.helper.versionEndpoint(dataService.url, versionNumber);
      return dataService;
    };
    return SingletonDataService;
  }());
  exports.SingletonDataService = SingletonDataService;
  var SingletonDataServiceFactory = (function() {
    function SingletonDataServiceFactory(http) {
      this.http = http;
    }
    SingletonDataServiceFactory.prototype.getInstance = function(options) {
      return new SingletonDataService(this.http, options);
    };
    SingletonDataServiceFactory = __decorate([core_1.Injectable(), __metadata('design:paramtypes', [http_service_1.HttpUtility])], SingletonDataServiceFactory);
    return SingletonDataServiceFactory;
  }());
  exports.SingletonDataServiceFactory = SingletonDataServiceFactory;
  function SingletonDataServiceProvider(options) {
    return core_1.provide(SingletonDataService, {
      deps: [http_service_1.HttpUtility],
      useFactory: function(http) {
        return new SingletonDataService(http, options);
      }
    });
  }
  exports.SingletonDataServiceProvider = SingletonDataServiceProvider;
  ;
  return module.exports;
});

System.registerDynamic("source/services/dataContracts/singletonDataService/parent/parentSingletonData.service.js", ["lodash", "../../singletonDataService/singletonData.service"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var __extends = (this && this.__extends) || function(d, b) {
    for (var p in b)
      if (b.hasOwnProperty(p))
        d[p] = b[p];
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
  var _ = $__require('lodash');
  var singletonData_service_1 = $__require('../../singletonDataService/singletonData.service');
  var ParentSingletonDataService = (function(_super) {
    __extends(ParentSingletonDataService, _super);
    function ParentSingletonDataService(http, options) {
      _super.call(this, http, options);
      this.resourceDictionaryBuilder = options.resourceDictionaryBuilder;
      this.parentId = options.parentId;
    }
    ParentSingletonDataService.prototype.childContracts = function() {
      var _this = this;
      var dictionary = this.resourceDictionaryBuilder();
      return _.mapValues(dictionary, function(dataService) {
        var contract;
        if (_.isFunction(dataService.AsSingleton)) {
          contract = dataService.AsSingleton(_this.parentId);
        } else {
          contract = dataService;
        }
        contract.url = _this.url + contract.endpoint;
        return contract;
      });
    };
    return ParentSingletonDataService;
  }(singletonData_service_1.SingletonDataService));
  exports.ParentSingletonDataService = ParentSingletonDataService;
  return module.exports;
});

System.registerDynamic("source/services/dataContracts/resourceBuilder/resourceBuilder.service.js", ["@angular/core", "../../array/array.service", "../../http/http.service", "../dataService/data.service", "../dataService/view/dataServiceView", "../dataService/parent/parentData.service", "../singletonDataService/singletonData.service", "../singletonDataService/parent/parentSingletonData.service"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var __decorate = (this && this.__decorate) || function(decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
      r = Reflect.decorate(decorators, target, key, desc);
    else
      for (var i = decorators.length - 1; i >= 0; i--)
        if (d = decorators[i])
          r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
  };
  var __metadata = (this && this.__metadata) || function(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
      return Reflect.metadata(k, v);
  };
  var core_1 = $__require('@angular/core');
  var array_service_1 = $__require('../../array/array.service');
  var http_service_1 = $__require('../../http/http.service');
  var data_service_1 = $__require('../dataService/data.service');
  var dataServiceView_1 = $__require('../dataService/view/dataServiceView');
  var parentData_service_1 = $__require('../dataService/parent/parentData.service');
  var singletonData_service_1 = $__require('../singletonDataService/singletonData.service');
  var parentSingletonData_service_1 = $__require('../singletonDataService/parent/parentSingletonData.service');
  var ResourceBuilder = (function() {
    function ResourceBuilder(http, array) {
      this.http = http;
      this.array = array;
    }
    ResourceBuilder.prototype.createResource = function(options) {
      options = this.useMockIfNoEndpoint(options);
      return new data_service_1.DataService(this.http, this.array, options);
    };
    ResourceBuilder.prototype.createResourceView = function(options) {
      options = this.useMockIfNoEndpoint(options);
      return new dataServiceView_1.DataServiceView(this.http, this.array, options);
    };
    ResourceBuilder.prototype.createParentResource = function(options) {
      options = this.useMockIfNoEndpoint(options);
      return new parentData_service_1.ParentDataService(this.http, this.array, options);
    };
    ResourceBuilder.prototype.createParentResourceView = function(options) {
      options = this.useMockIfNoEndpoint(options);
      return new dataServiceView_1.ParentDataServiceView(this.http, this.array, options);
    };
    ResourceBuilder.prototype.createSingletonResource = function(options) {
      options = this.useMockIfNoEndpoint(options);
      return new singletonData_service_1.SingletonDataService(this.http, options);
    };
    ResourceBuilder.prototype.createParentSingletonResource = function(options) {
      options = this.useMockIfNoEndpoint(options);
      return new parentSingletonData_service_1.ParentSingletonDataService(this.http, options);
    };
    ResourceBuilder.prototype.useMockIfNoEndpoint = function(options) {
      options.useMock = options.endpoint == null ? true : options.useMock;
      return options;
    };
    ResourceBuilder = __decorate([core_1.Injectable(), __metadata('design:paramtypes', [http_service_1.HttpUtility, array_service_1.ArrayUtility])], ResourceBuilder);
    return ResourceBuilder;
  }());
  exports.ResourceBuilder = ResourceBuilder;
  return module.exports;
});

System.registerDynamic("source/services/dataContracts/dataService/parent/parentData.service.tests.js", ["lodash", "../../resourceBuilder/resourceBuilder.service"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var _ = $__require('lodash');
  var resourceBuilder_service_1 = $__require('../../resourceBuilder/resourceBuilder.service');
  describe('parent data service', function() {
    var parentDataService;
    var resourceBuilder;
    var dataSet;
    var dataService;
    var dataServiceView;
    beforeEach(function() {
      dataSet = [{
        id: 1,
        prop: 'item1'
      }, {
        id: 2,
        prop: 'item2'
      }, {
        id: 3,
        prop: 'item3'
      }];
      resourceBuilder = new resourceBuilder_service_1.ResourceBuilder({}, {});
      dataService = resourceBuilder.createResource({
        mockData: dataSet,
        useMock: true
      });
      dataServiceView = resourceBuilder.createResourceView({
        mockData: dataSet,
        useMock: true
      });
      parentDataService = resourceBuilder.createParentResource({resourceDictionaryBuilder: function() {
          return {
            testView: dataServiceView,
            test: dataService
          };
        }});
    });
    describe('viewAsSingleton', function() {
      var children;
      beforeEach(function() {
        children = parentDataService.childContracts(1);
      });
      it('should expose a get function', function(done) {
        children.testView.get().subscribe(function(item) {
          expect(item).to.equal(dataSet[0]);
          done();
        });
      });
      it('should expose an update function and return the result of the update', function(done) {
        children.testView.update(dataSet[0]).subscribe(function(item) {
          expect(item).to.equal(dataSet[0]);
          done();
        });
      });
      it('should disable getList, getDetail, and create', function() {
        expect(children.testView.getList).to.not.exist;
        expect(children.testView.getDetail).to.not.exist;
        expect(children.testView.create).to.not.exist;
      });
      it('should leave standard data services untouched', function() {
        expect(_.isFunction(children.test.getList)).to.be.true;
        expect(_.isFunction(children.test.getDetail)).to.be.true;
        expect(_.isFunction(children.test.create)).to.be.true;
        expect(_.isFunction(children.test.update)).to.be.true;
        expect(children.test.get).to.not.exist;
      });
    });
  });
  return module.exports;
});

System.registerDynamic("source/services/date/date.service.tests.js", ["./date.service", "./dateTimeFormatStrings", "../timezone/timezone.enum", "../timezone/timezone.service", "../../types/compareResult", "moment", "moment-timezone"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var date_service_1 = $__require('./date.service');
  var dateTimeFormatStrings_1 = $__require('./dateTimeFormatStrings');
  var timezone_enum_1 = $__require('../timezone/timezone.enum');
  var timezone_service_1 = $__require('../timezone/timezone.service');
  var compareResult_1 = $__require('../../types/compareResult');
  var moment = $__require('moment');
  $__require('moment-timezone');
  describe('dateUtility', function() {
    var dateUtility;
    beforeEach(function() {
      dateUtility = new date_service_1.DateUtility();
    });
    describe('getFullString', function() {
      it('should get the month name', function() {
        expect(dateUtility.getFullString(0)).to.equal('January');
        expect(dateUtility.getFullString(1)).to.equal('February');
        expect(dateUtility.getFullString(2)).to.equal('March');
        expect(dateUtility.getFullString(3)).to.equal('April');
        expect(dateUtility.getFullString(4)).to.equal('May');
        expect(dateUtility.getFullString(5)).to.equal('June');
        expect(dateUtility.getFullString(6)).to.equal('July');
        expect(dateUtility.getFullString(7)).to.equal('August');
        expect(dateUtility.getFullString(8)).to.equal('September');
        expect(dateUtility.getFullString(9)).to.equal('October');
        expect(dateUtility.getFullString(10)).to.equal('November');
        expect(dateUtility.getFullString(11)).to.equal('December');
      });
    });
    describe('getDateFromServer', function() {
      it('should get dates from string in server format, "YYYY-MM-DDTHH:MM:SSZ"', function() {
        var expectedDate = moment('2015-11-24T20:12:00-07:00', dateTimeFormatStrings_1.defaultFormats.isoFormat).tz(timezone_enum_1.timezones.MST.momentName);
        var dateString = '2015-11-24T20:12:00-07:00';
        var date = dateUtility.getDateFromISOString(dateString);
        expect(date).to.equalMoment(expectedDate);
      });
      it('should return null if the server sends a null date', function() {
        expect(dateUtility.getDateFromISOString(null)).to.not.exist;
      });
      it('should use the default timezone if the offset is missing or not supported', function() {
        timezone_service_1.timezoneService.setCurrentTimezone(timezone_enum_1.timezones.CST.offset);
        expect(dateUtility.getDateFromISOString('2016-01-02T12:00:00+00:00').tz()).to.equal(timezone_enum_1.timezones.CST.momentName);
        expect(dateUtility.getDateFromISOString('2016-01-02T12:00:00').tz()).to.equal(timezone_enum_1.timezones.CST.momentName);
      });
    });
    describe('isDate', function() {
      it('should be true if item is a date or a string, date, or moment format', function() {
        expect(dateUtility.isDate('1/1/2014')).to.be.true;
        expect(dateUtility.isDate(new Date('1/1/2014'))).to.be.true;
        expect(dateUtility.isDate(moment('2014-01-01'))).to.be.true;
      });
      it('should return false if object is not a date', function() {
        expect(dateUtility.isDate(null)).to.be.false;
        expect(dateUtility.isDate({})).to.be.false;
        expect(dateUtility.isDate('123456')).to.be.false;
      });
      it('should return false if object is a Valid date object with an invalid value.', function() {
        expect(dateUtility.isDate(new Date("Null"))).to.be.false;
      });
    });
    describe('getNow', function() {
      it('should set the timezone on the new date if a timezone is configured', function() {
        timezone_service_1.timezoneService.setCurrentTimezone(timezone_enum_1.timezones.MST.offset);
        expect(dateUtility.getNow().tz()).to.equal(timezone_enum_1.timezones.MST.momentName);
      });
    });
    describe('subtractDates', function() {
      it('should get 0 years, months , and days when subtracting ths same date from itself', function() {
        var startDate = '9/10/2014';
        var endDate = '9/10/2014';
        var result = dateUtility.subtractDates(startDate, endDate, dateTimeFormatStrings_1.defaultFormats.dateFormat);
        expect(result.years).to.equal(0);
        expect(result.months).to.equal(0);
        expect(result.days).to.equal(0);
      });
      it('should get 3/3/3 when subtracting 6/6/2006 from 9/9/2009', function() {
        var startDate = '6/6/2006';
        var endDate = '9/9/2009';
        var result = dateUtility.subtractDates(startDate, endDate, dateTimeFormatStrings_1.defaultFormats.dateFormat);
        expect(result.years).to.equal(3);
        expect(result.months).to.equal(3);
        expect(result.days).to.equal(3);
      });
      it('should get 11/30/21 when subtracting 1/1/1999 from 12/31/2020', function() {
        var startDate = '1/1/1999';
        var endDate = '12/31/2020';
        var result = dateUtility.subtractDates(startDate, endDate, dateTimeFormatStrings_1.defaultFormats.dateFormat);
        expect(result.years).to.equal(21);
        expect(result.months).to.equal(11);
        expect(result.days).to.equal(30);
      });
      it('should take leap year into account and return 28 days when subtracting 2/3/2016 from 3/2/2016', function() {
        var startDate = '2/3/2016';
        var endDate = '3/2/2016';
        var result = dateUtility.subtractDates(startDate, endDate, dateTimeFormatStrings_1.defaultFormats.dateFormat);
        expect(result.years).to.equal(0);
        expect(result.months).to.equal(0);
        expect(result.days).to.equal(28);
      });
      it('should properly handle when day and month of start date are higher than day and month of end date', function() {
        var startDate = '12/31/2000';
        var endDate = '1/1/2001';
        var result = dateUtility.subtractDates(startDate, endDate, dateTimeFormatStrings_1.defaultFormats.dateFormat);
        expect(result.years).to.equal(0);
        expect(result.months).to.equal(0);
        expect(result.days).to.equal(1);
      });
      it('should recognize when days are just under a year apart', function() {
        var startDate = '9/12/2000';
        var endDate = '9/10/2001';
        var result = dateUtility.subtractDates(startDate, endDate, dateTimeFormatStrings_1.defaultFormats.dateFormat);
        expect(result.years).to.equal(0);
        expect(result.months).to.equal(11);
        expect(result.days).to.equal(28);
      });
      it('should also accept dates', function() {
        var startDate = new Date(2016, 4, 1);
        var endDate = new Date(2016, 4, 1);
        var result = dateUtility.subtractDates(startDate, endDate);
        expect(result.years).to.equal(0);
        expect(result.months).to.equal(0);
        expect(result.days).to.equal(0);
      });
      it('should also accept moments', function() {
        var startDate = moment('2016-4-1T00:00:00-05:00', dateTimeFormatStrings_1.defaultFormats.isoFormat);
        var endDate = moment('2016-4-1T00:00:00-05:00', dateTimeFormatStrings_1.defaultFormats.isoFormat);
        var result = dateUtility.subtractDates(startDate, endDate);
        expect(result.years).to.equal(0);
        expect(result.months).to.equal(0);
        expect(result.days).to.equal(0);
      });
      it('should handle nulls', function() {
        expect(dateUtility.subtractDates(null, '1/1/2016', dateTimeFormatStrings_1.defaultFormats.dateFormat)).to.be.null;
        expect(dateUtility.subtractDates('1/1/2016', null, dateTimeFormatStrings_1.defaultFormats.dateFormat)).to.be.null;
        expect(dateUtility.subtractDates(null, null, dateTimeFormatStrings_1.defaultFormats.dateFormat)).to.be.null;
      });
    });
    describe('subtractDatesInDays', function() {
      it('should get 0 days when subtracting the same date from itself', function() {
        var startDate = '9/10/2014';
        var endDate = '9/10/2014';
        expect(dateUtility.subtractDateInDays(startDate, endDate, dateTimeFormatStrings_1.defaultFormats.dateFormat)).to.equal(0);
      });
      it('should get 92 when subtracting 6/9/2009 from 9/9/2009', function() {
        var startDate = '6/9/2009';
        var endDate = '9/9/2009';
        expect(dateUtility.subtractDateInDays(startDate, endDate, dateTimeFormatStrings_1.defaultFormats.dateFormat)).to.equal(92);
      });
      it('should take leap yer into account and return 28 days when subtracting 2/3/2016 from 3/2/2016', function() {
        var startDate = '2/3/2016';
        var endDate = '3/2/2016';
        expect(dateUtility.subtractDateInDays(startDate, endDate, dateTimeFormatStrings_1.defaultFormats.dateFormat)).to.equal(28);
      });
      it('should properly handle when day and month of start date are higher than day and month of end date', function() {
        var startDate = '12/31/2000';
        var endDate = '1/1/2001';
        expect(dateUtility.subtractDateInDays(startDate, endDate, dateTimeFormatStrings_1.defaultFormats.dateFormat)).to.equal(1);
      });
      it('should handle dates that are just under a year apart', function() {
        var startDate = '9/12/2000';
        var endDate = '9/10/2001';
        expect(dateUtility.subtractDateInDays(startDate, endDate, dateTimeFormatStrings_1.defaultFormats.dateFormat)).to.equal(363);
      });
      it('should return a negative value if the first date is after the second', function() {
        var startDate = '9/10/2015';
        var endDate = '9/10/2014';
        expect(dateUtility.subtractDateInDays(startDate, endDate, dateTimeFormatStrings_1.defaultFormats.dateFormat)).to.equal(-365);
      });
      it('should also accept dates', function() {
        var startDate = new Date(2016, 4, 1);
        var endDate = new Date(2016, 4, 1);
        expect(dateUtility.subtractDateInDays(startDate, endDate)).to.equal(0);
      });
      it('should also accept moments', function() {
        var startDate = moment('2016-4-1T00:00:00-05:00', dateTimeFormatStrings_1.defaultFormats.isoFormat);
        var endDate = moment('2016-4-1T00:00:00-05:00', dateTimeFormatStrings_1.defaultFormats.isoFormat);
        expect(dateUtility.subtractDateInDays(startDate, endDate)).to.equal(0);
      });
      it('should handle nulls', function() {
        expect(dateUtility.subtractDateInDays(null, '1/1/2016', dateTimeFormatStrings_1.defaultFormats.dateFormat)).to.be.null;
        expect(dateUtility.subtractDateInDays('1/1/2016', null, dateTimeFormatStrings_1.defaultFormats.dateFormat)).to.be.null;
        expect(dateUtility.subtractDateInDays(null, null, dateTimeFormatStrings_1.defaultFormats.dateFormat)).to.be.null;
      });
    });
    describe('subtractDateInMilliseconds', function() {
      it('should handle nulls', function() {
        expect(dateUtility.subtractDateInMilliseconds(null, '1/1/2016', dateTimeFormatStrings_1.defaultFormats.dateFormat)).to.be.null;
        expect(dateUtility.subtractDateInMilliseconds('1/1/2016', null, dateTimeFormatStrings_1.defaultFormats.dateFormat)).to.be.null;
        expect(dateUtility.subtractDateInMilliseconds(null, null, dateTimeFormatStrings_1.defaultFormats.dateFormat)).to.be.null;
      });
    });
    describe('compareDates', function() {
      it('should return less if the first date is before the second', function() {
        var date = '9/10/2000';
        var laterDate = '9/10/2001';
        expect(dateUtility.compareDates(date, laterDate, dateTimeFormatStrings_1.defaultFormats.dateFormat)).to.equal(compareResult_1.CompareResult.less);
      });
      it('should return equal if the dates are the same', function() {
        var date = '9/10/2000';
        var equalDate = '9/10/2000';
        expect(dateUtility.compareDates(date, equalDate, dateTimeFormatStrings_1.defaultFormats.dateFormat)).to.equal(compareResult_1.CompareResult.equal);
      });
      it('should return greater if the first date if after the second', function() {
        var date = '9/10/2000';
        var earlierDate = '9/10/1999';
        expect(dateUtility.compareDates(date, earlierDate, dateTimeFormatStrings_1.defaultFormats.dateFormat)).to.equal(compareResult_1.CompareResult.greater);
      });
      it('should handle date-times where the date is the same', function() {
        var date = '9/10/2000 10:00 AM';
        var earlierDate = '9/10/2000 8:00 AM';
        expect(dateUtility.compareDates(date, earlierDate, dateTimeFormatStrings_1.defaultFormats.dateTimeFormat)).to.equal(compareResult_1.CompareResult.greater);
      });
      it('should handle dates where the hour is the same', function() {
        var date = '9/10/2000 10:30 AM';
        var earlierDate = '9/10/2000 10:15 AM';
        expect(dateUtility.compareDates(date, earlierDate, dateTimeFormatStrings_1.defaultFormats.dateTimeFormat)).to.equal(compareResult_1.CompareResult.greater);
      });
      it('should also accept dates', function() {
        var date = new Date(2016, 4, 1);
        var earlierDate = new Date(2016, 3, 1);
        expect(dateUtility.compareDates(date, earlierDate)).to.equal(compareResult_1.CompareResult.greater);
      });
      it('should also accept moments', function() {
        var date = moment('2016-4-1T00:00:00-05:00', dateTimeFormatStrings_1.defaultFormats.isoFormat);
        var earlierDate = moment('2016-3-1T00:00:00-05:00', dateTimeFormatStrings_1.defaultFormats.isoFormat);
        expect(dateUtility.compareDates(date, earlierDate)).to.equal(compareResult_1.CompareResult.greater);
      });
      it('should handle nulls', function() {
        expect(dateUtility.compareDates(null, '1/1/2016', dateTimeFormatStrings_1.defaultFormats.dateFormat)).to.equal(compareResult_1.CompareResult.invalid);
        expect(dateUtility.compareDates('1/1/2016', null, dateTimeFormatStrings_1.defaultFormats.dateFormat)).to.equal(compareResult_1.CompareResult.invalid);
        expect(dateUtility.compareDates(null, null, dateTimeFormatStrings_1.defaultFormats.dateFormat)).to.equal(compareResult_1.CompareResult.invalid);
      });
    });
    describe('dateInRange', function() {
      it('should return false if the date is before the beginning of the range', function() {
        expect(dateUtility.dateInRange('2014-1-1T00:00:00-07:00', '2015-1-1T00:00:00-07:00', '2018-1-1T00:00:00-07:00')).to.be.false;
        expect(dateUtility.dateInRange('2014-12-31T00:00:00-07:00', '2015-1-1T00:00:00-07:00', '2018-1-1T00:00:00-07:00')).to.be.false;
      });
      it('should return false if the date is after the end of the range', function() {
        expect(dateUtility.dateInRange('2019-1-1T00:00:00-07:00', '2015-1-1T00:00:00-07:00', '2018-1-1T00:00:00-07:00')).to.be.false;
        expect(dateUtility.dateInRange('2018-1-2T00:00:00-07:00', '2015-1-1T00:00:00-07:00', '2018-1-1T00:00:00-07:00')).to.be.false;
      });
      it('should return true if the date is within the range', function() {
        expect(dateUtility.dateInRange('2015-1-1T00:00:00-07:00', '2015-1-1T00:00:00-07:00', '2018-1-1T00:00:00-07:00')).to.be.true;
        expect(dateUtility.dateInRange('2016-1-1T00:00:00-07:00', '2015-1-1T00:00:00-07:00', '2018-1-1T00:00:00-07:00')).to.be.true;
        expect(dateUtility.dateInRange('2017-1-1T00:00:00-07:00', '2015-1-1T00:00:00-07:00', '2018-1-1T00:00:00-07:00')).to.be.true;
        expect(dateUtility.dateInRange('2018-1-1T00:00:00-07:00', '2015-1-1T00:00:00-07:00', '2018-1-1T00:00:00-07:00')).to.be.true;
      });
      it('should return true if the date is within the range for dates', function() {
        expect(dateUtility.dateInRange(new Date(2016, 4, 1), new Date(2016, 3, 1), new Date(2016, 5, 1))).to.be.true;
      });
      it('should return true if the date is within the range for moments', function() {
        expect(dateUtility.dateInRange(moment('2016-04-01'), moment('2016-03-01'), moment('2016-05-01'))).to.be.true;
      });
      it('should handle nulls', function() {
        expect(dateUtility.dateInRange(null, '2016-01-01T12:00:00-07:00', '2016-01-01T12:00:00-07:00')).to.be.null;
        expect(dateUtility.dateInRange('2016-01-01T12:00:00-07:00', null, '2016-01-01T12:00:00-07:00')).to.be.null;
        expect(dateUtility.dateInRange('2016-01-01T12:00:00-07:00', '2016-01-01T12:00:00-07:00', null)).to.be.null;
        expect(dateUtility.dateInRange(null, null, null)).to.be.null;
      });
      it('should allow for specifying a format', function() {
        expect(dateUtility.dateInRange(moment('2016-08-29T12:00:00'), '1/1/2015', '1/1/2016', dateTimeFormatStrings_1.defaultFormats.dateFormat)).to.be.false;
        expect(dateUtility.dateInRange(moment('2016-08-29T12:00:00'), '1/1/2016', '1/1/2017', dateTimeFormatStrings_1.defaultFormats.dateFormat)).to.be.true;
        expect(dateUtility.dateInRange(moment('2016-08-29T12:00:00'), '1/1/2017', '1/1/2018', dateTimeFormatStrings_1.defaultFormats.dateFormat)).to.be.false;
      });
    });
    describe('sameDate', function() {
      it('should return false if the dates are different', function() {
        var date1 = new Date(1995, 11, 17, 12, 0, 0);
        var date2 = new Date(1995, 11, 18, 3, 24, 0);
        expect(dateUtility.sameDate(date1, date2)).to.be.false;
        expect(dateUtility.sameDate('2015-1-1T00:00:00-07:00', '2016-1-1T00:00:00-07:00')).to.be.false;
        expect(dateUtility.sameDate(moment('2016-04-01'), moment('2016-05-01'))).to.be.false;
      });
      it('should return true if the dates are the same date', function() {
        var date1 = new Date(1995, 11, 17, 12, 0, 0);
        var date2 = new Date(1995, 11, 17, 3, 24, 0);
        expect(dateUtility.sameDate(date1, date2)).to.be.true;
        expect(dateUtility.sameDate('2015-1-1T11:11:11-07:00', '2015-1-1T15:15:15-07:00')).to.be.true;
        expect(dateUtility.sameDate(moment('2016-04-01'), moment('2016-04-01'))).to.be.true;
      });
      it('should handle nulls', function() {
        expect(dateUtility.sameDate(null, '2016-01-01T12:00:00-07:00')).to.be.null;
        expect(dateUtility.sameDate('2016-01-01T12:00:00-07:00', null)).to.be.null;
        expect(dateUtility.sameDate(null, null)).to.be.null;
      });
    });
    describe('sameDateTime', function() {
      it('should return false if the same dates have different times', function() {
        var date1 = new Date(1995, 11, 17, 0, 24, 0);
        var date2 = new Date(1995, 11, 17, 3, 24, 0);
        expect(dateUtility.sameDateTime(date1, date2)).to.be.false;
        expect(dateUtility.sameDateTime('2015-1-1T12:00:00-07:00', '2015-1-1T12:00:01-07:00')).to.be.false;
        expect(dateUtility.sameDateTime(moment('2016-03-01T12:10:00.000-05:00'), moment('2016-03-01T12:10:01.000-05:00'))).to.be.false;
      });
      it('should return true if the dates are the same date and time down to hour and minute', function() {
        var date1 = new Date(1995, 11, 17, 3, 24, 0);
        var date2 = new Date(1995, 11, 17, 3, 24, 0);
        expect(dateUtility.sameDateTime(date1, date2)).to.be.true;
        expect(dateUtility.sameDateTime('2015-1-1T12:00:00-07:00', '2015-1-1T12:00:00-07:00')).to.be.true;
        expect(dateUtility.sameDateTime(moment('2016-03-01T12:10:00.000-05:00'), moment('2016-03-01T12:10:00.000-05:00'))).to.be.true;
      });
      it('should handle nulls', function() {
        expect(dateUtility.sameDateTime(null, '2016-01-01T12:00:00-07:00')).to.be.null;
        expect(dateUtility.sameDateTime('2016-01-01T12:00:00-07:00', null)).to.be.null;
        expect(dateUtility.sameDateTime(null, null)).to.be.null;
      });
    });
    describe('setOffset', function() {
      var offset = 500;
      var originalMomentNow;
      beforeEach(function() {
        originalMomentNow = moment.now;
      });
      afterEach(function() {
        moment.now = originalMomentNow;
      });
      it('should offset current moment time', function() {
        var nowBeforeOffset = moment.now();
        dateUtility.setOffset(offset);
        var nowAfterOffset = moment.now();
        expect(nowAfterOffset - nowBeforeOffset).to.equal(offset);
      });
      it('should offset current date service time', function() {
        var nowBeforeOffset = dateUtility.getNow();
        dateUtility.setOffset(offset);
        var nowAfterOffset = dateUtility.getNow();
        expect(nowAfterOffset.valueOf() - nowBeforeOffset.valueOf()).to.equal(offset);
      });
    });
  });
  return module.exports;
});

System.registerDynamic("source/services/errorHandler/errorHandler.service.js", ["@angular/core", "../notification/notification.service", "../redirect/redirect.service"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var __decorate = (this && this.__decorate) || function(decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
      r = Reflect.decorate(decorators, target, key, desc);
    else
      for (var i = decorators.length - 1; i >= 0; i--)
        if (d = decorators[i])
          r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
  };
  var __metadata = (this && this.__metadata) || function(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
      return Reflect.metadata(k, v);
  };
  var core_1 = $__require('@angular/core');
  var notification_service_1 = $__require('../notification/notification.service');
  var redirect_service_1 = $__require('../redirect/redirect.service');
  (function(HttpStatusCode) {
    HttpStatusCode[HttpStatusCode["cancelledRequest"] = -1] = "cancelledRequest";
    HttpStatusCode[HttpStatusCode["badRequest"] = 400] = "badRequest";
    HttpStatusCode[HttpStatusCode["unauthorized"] = 401] = "unauthorized";
    HttpStatusCode[HttpStatusCode["forbidden"] = 403] = "forbidden";
    HttpStatusCode[HttpStatusCode["invalidUrl"] = 404] = "invalidUrl";
    HttpStatusCode[HttpStatusCode["timeout"] = 408] = "timeout";
    HttpStatusCode[HttpStatusCode["internalServerError"] = 500] = "internalServerError";
    HttpStatusCode[HttpStatusCode["gone"] = 410] = "gone";
  })(exports.HttpStatusCode || (exports.HttpStatusCode = {}));
  var HttpStatusCode = exports.HttpStatusCode;
  var DefaultErrors = (function() {
    function DefaultErrors() {
      this.badRequestError = 'Your request failed one or more validation checks.';
      this.forbiddenError = 'You have insufficient permissions to perform this action';
      this.invalidUrlError = 'Resource not found. This issue has been logged';
      this.timeoutError = 'Request timed out. Check your network connection or contact your administrator for issues';
      this.internalServerError = 'The system has encountered an error. This issue has been logged.' + ' Please contact support if you are unable to complete critical tasks';
      this.defaultError = 'Http status code not handled';
      this.goneError = 'The requested resource is no longer available.';
    }
    return DefaultErrors;
  }());
  exports.DefaultErrors = DefaultErrors;
  var DefaultLoginUrlSettings = (function() {
    function DefaultLoginUrlSettings() {
      this.loginUrl = '/login';
      this.returnUrlParam = 'returnUrl';
    }
    return DefaultLoginUrlSettings;
  }());
  exports.DefaultLoginUrlSettings = DefaultLoginUrlSettings;
  var ErrorHandlerService = (function() {
    function ErrorHandlerService(redirect, exceptionHandler, notification, errorMessages, loginSettings) {
      this.redirect = redirect;
      this.exceptionHandler = exceptionHandler;
      this.notification = notification;
      this.errorMessages = errorMessages;
      this.loginSettings = loginSettings;
    }
    ErrorHandlerService.prototype.httpResponseError = function(rejection) {
      switch (rejection.status) {
        case HttpStatusCode.badRequest:
          this.badRequestError(rejection);
          break;
        case HttpStatusCode.unauthorized:
          this.loggedOutError();
          break;
        case HttpStatusCode.forbidden:
          this.insufficientPermissionsError();
          break;
        case HttpStatusCode.invalidUrl:
          this.invalidUrlError();
          break;
        case HttpStatusCode.timeout:
          this.timeoutError();
          break;
        case HttpStatusCode.internalServerError:
          this.systemError();
          break;
        case HttpStatusCode.gone:
          this.goneError();
          break;
        case HttpStatusCode.cancelledRequest:
          break;
        default:
          this.exceptionHandler.call(new Error(this.errorMessages.defaultError));
          this.exceptionHandler.call(new Error('Status: ' + rejection.status));
          this.exceptionHandler.call(new Error('Response: ' + rejection));
          break;
      }
    };
    ErrorHandlerService.prototype.badRequestError = function(rejection) {
      if (rejection.data) {
        this.notification.error(rejection.data);
      } else {
        this.notification.error(this.errorMessages.badRequestError);
      }
    };
    ErrorHandlerService.prototype.loggedOutError = function() {
      var returnUrl = this.redirect.getCurrentLocationAsParam();
      var target = this.loginSettings.loginUrl + '?' + this.loginSettings.returnUrlParam + '=' + returnUrl;
      this.redirect.to(target);
    };
    ErrorHandlerService.prototype.insufficientPermissionsError = function() {
      this.notification.error(this.errorMessages.forbiddenError);
    };
    ErrorHandlerService.prototype.invalidUrlError = function() {
      this.notification.error(this.errorMessages.invalidUrlError);
    };
    ErrorHandlerService.prototype.timeoutError = function() {
      this.notification.error(this.errorMessages.timeoutError);
    };
    ErrorHandlerService.prototype.systemError = function() {
      this.notification.error(this.errorMessages.internalServerError);
    };
    ErrorHandlerService.prototype.goneError = function() {
      this.notification.error(this.errorMessages.goneError);
    };
    ErrorHandlerService = __decorate([core_1.Injectable(), __metadata('design:paramtypes', [redirect_service_1.RedirectService, core_1.ExceptionHandler, notification_service_1.NotificationService, DefaultErrors, DefaultLoginUrlSettings])], ErrorHandlerService);
    return ErrorHandlerService;
  }());
  exports.ErrorHandlerService = ErrorHandlerService;
  return module.exports;
});

System.registerDynamic("source/services/errorHandler/errorHandler.service.tests.js", ["./errorHandler.service"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var errorHandler_service_1 = $__require('./errorHandler.service');
  describe('errorHandler', function() {
    var errorHandler;
    var redirect;
    var notification;
    var returnUrl;
    beforeEach(function() {
      redirect = {
        getCurrentLocationAsParam: function() {
          return returnUrl;
        },
        to: sinon.spy()
      };
      notification = {error: sinon.spy()};
      var exceptionHandler = {call: sinon.spy()};
      errorHandler = new errorHandler_service_1.ErrorHandlerService(redirect, exceptionHandler, notification, new errorHandler_service_1.DefaultErrors(), new errorHandler_service_1.DefaultLoginUrlSettings());
    });
    it('should redirect the user to the login page with a redirect url on an unauthorized error', function() {
      var rejection = {status: errorHandler_service_1.HttpStatusCode.unauthorized};
      returnUrl = 'myReturnUrl';
      errorHandler.httpResponseError(rejection);
      sinon.assert.calledOnce(redirect.to);
      sinon.assert.calledWith(redirect.to, '/login?returnUrl=myReturnUrl');
    });
    it('should show an error for insufficient permissions', function() {
      var rejection = {status: errorHandler_service_1.HttpStatusCode.forbidden};
      errorHandler.httpResponseError(rejection);
      sinon.assert.calledOnce(notification.error);
      sinon.assert.calledWith(notification.error, 'You have insufficient permissions to perform this action');
    });
    it('should show an error for invalid url', function() {
      var rejection = {status: errorHandler_service_1.HttpStatusCode.invalidUrl};
      errorHandler.httpResponseError(rejection);
      sinon.assert.calledOnce(notification.error);
      sinon.assert.calledWith(notification.error, 'Resource not found. This issue has been logged');
    });
    it('should show an error for gone resource', function() {
      var rejection = {status: errorHandler_service_1.HttpStatusCode.gone};
      errorHandler.httpResponseError(rejection);
      sinon.assert.calledOnce(notification.error);
      sinon.assert.calledWith(notification.error, 'The requested resource is no longer available.');
    });
    it('should show an error for timeout', function() {
      var rejection = {status: errorHandler_service_1.HttpStatusCode.timeout};
      errorHandler.httpResponseError(rejection);
      sinon.assert.calledOnce(notification.error);
      sinon.assert.calledWith(notification.error, 'Request timed out. Check your network connection or contact your administrator for issues');
    });
    it('should show an error for system error', function() {
      var rejection = {status: errorHandler_service_1.HttpStatusCode.internalServerError};
      errorHandler.httpResponseError(rejection);
      sinon.assert.calledOnce(notification.error);
      sinon.assert.calledWith(notification.error, 'The system has encountered an error. This issue has been logged.' + ' Please contact support if you are unable to complete critical tasks');
    });
    it('should show a custom error for bad request error', function() {
      var errorMessage = 'An error occurred';
      var rejection = {
        status: errorHandler_service_1.HttpStatusCode.badRequest,
        data: errorMessage
      };
      errorHandler.httpResponseError(rejection);
      sinon.assert.calledOnce(notification.error);
      sinon.assert.calledWith(notification.error, errorMessage);
    });
  });
  return module.exports;
});

System.registerDynamic("source/services/fileSize/fileSize.service.js", [], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var FileSize = (function() {
    function FileSize(numberUtility, bytes) {
      this.BYTES_PER_GB = 1073741824;
      this.BYTES_PER_MB = 1048576;
      this.BYTES_PER_KB = 1024;
      this.bytes = bytes;
      if (bytes >= this.BYTES_PER_GB) {
        this.isGB = true;
        this.GB = bytes / this.BYTES_PER_GB;
        this.GB = numberUtility.preciseRound(this.GB, 1);
      } else {
        this.isGB = false;
        if (bytes >= this.BYTES_PER_MB) {
          this.isMB = true;
          this.MB = bytes / this.BYTES_PER_MB;
          this.MB = numberUtility.preciseRound(this.MB, 1);
        } else {
          this.isMB = false;
          if (bytes >= this.BYTES_PER_KB) {
            this.isKB = true;
            this.KB = bytes / this.BYTES_PER_KB;
            this.KB = numberUtility.preciseRound(this.KB, 1);
          } else {
            this.isKB = false;
          }
        }
      }
      this.bytes = Math.round(this.bytes);
    }
    FileSize.prototype.display = function() {
      if (this.isGB) {
        return this.GB + ' GB';
      } else if (this.isMB) {
        return this.MB + ' MB';
      } else if (this.isKB) {
        return this.KB + ' KB';
      } else {
        return this.bytes + ' bytes';
      }
    };
    return FileSize;
  }());
  exports.FileSize = FileSize;
  return module.exports;
});

System.registerDynamic("source/services/fileSize/fileSize.service.tests.js", ["./fileSize.service", "../number/number.service"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var fileSize_service_1 = $__require('./fileSize.service');
  var number_service_1 = $__require('../number/number.service');
  describe('fileSize', function() {
    it('should determine bytes', function() {
      expect(new fileSize_service_1.FileSize(number_service_1.numberUtility, 1).display()).to.equal('1 bytes');
      expect(new fileSize_service_1.FileSize(number_service_1.numberUtility, 1023).display()).to.equal('1023 bytes');
    });
    it('should determine kilo bytes', function() {
      expect(new fileSize_service_1.FileSize(number_service_1.numberUtility, 1024).display()).to.equal('1 KB');
      expect(new fileSize_service_1.FileSize(number_service_1.numberUtility, 1048575).display()).to.equal('1024 KB');
    });
    it('should determine mega bytes', function() {
      expect(new fileSize_service_1.FileSize(number_service_1.numberUtility, 1048576).display()).to.equal('1 MB');
      expect(new fileSize_service_1.FileSize(number_service_1.numberUtility, 1073741823).display()).to.equal('1024 MB');
    });
    it('should determine giga bytes', function() {
      expect(new fileSize_service_1.FileSize(number_service_1.numberUtility, 1073741824).display()).to.equal('1 GB');
      expect(new fileSize_service_1.FileSize(number_service_1.numberUtility, 1073741825).display()).to.equal('1 GB');
    });
  });
  return module.exports;
});

System.registerDynamic("source/filters/filter.js", ["rxjs/Rx", "../services/object/object.service"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var Rx = $__require('rxjs/Rx');
  var object_service_1 = $__require('../services/object/object.service');
  var SerializableFilter = (function() {
    function SerializableFilter() {
      this.subject = new Rx.Subject();
    }
    SerializableFilter.prototype.serialize = function() {
      return this;
    };
    SerializableFilter.prototype.subscribe = function(onValueChange) {
      return this.subject.subscribe(onValueChange);
    };
    SerializableFilter.prototype.onChange = function(force) {
      if (force === void 0) {
        force = true;
      }
      var newValue = this.serialize();
      if (force || !object_service_1.objectUtility.areEqual(newValue, this._value)) {
        this._value = newValue;
        this.subject.next(this._value);
      }
    };
    return SerializableFilter;
  }());
  exports.SerializableFilter = SerializableFilter;
  return module.exports;
});

System.registerDynamic("source/services/genericSearchFilter/genericSearchFilter.service.js", ["@angular/core", "../object/object.service", "../string/string.service", "../search/search.service", "../../filters/filter"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var __extends = (this && this.__extends) || function(d, b) {
    for (var p in b)
      if (b.hasOwnProperty(p))
        d[p] = b[p];
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
  var __decorate = (this && this.__decorate) || function(decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
      r = Reflect.decorate(decorators, target, key, desc);
    else
      for (var i = decorators.length - 1; i >= 0; i--)
        if (d = decorators[i])
          r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
  };
  var __metadata = (this && this.__metadata) || function(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
      return Reflect.metadata(k, v);
  };
  var core_1 = $__require('@angular/core');
  var object_service_1 = $__require('../object/object.service');
  var string_service_1 = $__require('../string/string.service');
  var search_service_1 = $__require('../search/search.service');
  var filter_1 = $__require('../../filters/filter');
  exports.filterName = 'search';
  var GenericSearchFilter = (function(_super) {
    __extends(GenericSearchFilter, _super);
    function GenericSearchFilter(object, string, tokenized) {
      _super.call(this);
      this.object = object;
      this.string = string;
      this.tokenized = tokenized;
      this.type = exports.filterName;
      this.minSearchLength = 1;
      this.caseSensitive = false;
    }
    Object.defineProperty(GenericSearchFilter.prototype, "searchText", {
      get: function() {
        return this._searchText;
      },
      set: function(value) {
        this._searchText = value;
        this.onChange(false);
      },
      enumerable: true,
      configurable: true
    });
    GenericSearchFilter.prototype.serialize = function() {
      return this.searchText != null && this.searchText.length >= this.minSearchLength ? this.searchText : null;
    };
    GenericSearchFilter.prototype.filter = function(item) {
      if (this.object.isNullOrEmpty(this.searchText) || this.searchText.length < this.minSearchLength) {
        return true;
      }
      if (this.tokenized) {
        return search_service_1.searchUtility.tokenizedSearch(item, this.searchText, this.caseSensitive);
      }
      return search_service_1.searchUtility.search(item, this.searchText, this.caseSensitive);
    };
    return GenericSearchFilter;
  }(filter_1.SerializableFilter));
  exports.GenericSearchFilter = GenericSearchFilter;
  var GenericSearchFilterFactory = (function() {
    function GenericSearchFilterFactory(objectUtility, stringUtility) {
      this.objectUtility = objectUtility;
      this.stringUtility = stringUtility;
    }
    GenericSearchFilterFactory.prototype.getInstance = function(tokenized) {
      return new GenericSearchFilter(this.objectUtility, this.stringUtility, tokenized);
    };
    GenericSearchFilterFactory = __decorate([core_1.Injectable(), __metadata('design:paramtypes', [object_service_1.ObjectUtility, string_service_1.StringUtility])], GenericSearchFilterFactory);
    return GenericSearchFilterFactory;
  }());
  exports.GenericSearchFilterFactory = GenericSearchFilterFactory;
  return module.exports;
});

System.registerDynamic("source/services/genericSearchFilter/genericSearchFilter.service.tests.js", ["./genericSearchFilter.service", "../object/object.service", "../string/string.service"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var genericSearchFilter_service_1 = $__require('./genericSearchFilter.service');
  var object_service_1 = $__require('../object/object.service');
  var string_service_1 = $__require('../string/string.service');
  describe('genericSearchFilter', function() {
    var genericSearchFilter;
    beforeEach(function() {
      var factory = new genericSearchFilter_service_1.GenericSearchFilterFactory(object_service_1.objectUtility, string_service_1.stringUtility);
      genericSearchFilter = factory.getInstance();
    });
    it('should include all items if query is null or empty', function() {
      genericSearchFilter.searchText = null;
      var object1 = {prop: 'some string'};
      var object2 = {prop: 'another value'};
      expect(genericSearchFilter.filter(object1)).to.be.true;
      expect(genericSearchFilter.filter(object2)).to.be.true;
      genericSearchFilter.searchText = '';
      expect(genericSearchFilter.filter(object1)).to.be.true;
      expect(genericSearchFilter.filter(object2)).to.be.true;
    });
    it('should include all items if search length is less than minimum', function() {
      genericSearchFilter.searchText = 'som';
      genericSearchFilter.minSearchLength = 4;
      var object1 = {prop: 'some string'};
      var object2 = {prop: 'another value'};
      expect(genericSearchFilter.filter(object1)).to.be.true;
      expect(genericSearchFilter.filter(object2)).to.be.true;
    });
    it('should search the actual data values if they arent objects', function() {
      genericSearchFilter.searchText = '2';
      expect(genericSearchFilter.filter(1)).to.be.false;
      expect(genericSearchFilter.filter(2)).to.be.true;
      expect(genericSearchFilter.filter(3)).to.be.false;
      expect(genericSearchFilter.filter(4)).to.be.false;
      expect(genericSearchFilter.filter(5)).to.be.false;
    });
    it('should include items that contain the search string', function() {
      genericSearchFilter.searchText = 'my';
      genericSearchFilter.caseSensitive = true;
      var matchingObject1 = {prop2: 'my string'};
      var matchingObject2 = {
        prop1: 5,
        prop2: 'some string with my'
      };
      var objectWithoutSearchString = {prop1: 2};
      var objectWithDifferentCase = {
        prop1: 5,
        prop2: 'MY string'
      };
      expect(genericSearchFilter.filter(matchingObject1)).to.be.true;
      expect(genericSearchFilter.filter(objectWithoutSearchString)).to.be.false;
      expect(genericSearchFilter.filter(matchingObject2)).to.be.true;
      expect(genericSearchFilter.filter(objectWithDifferentCase)).to.be.false;
    });
    it('should include items that contain the search string, case insensitive', function() {
      genericSearchFilter.searchText = 'my';
      genericSearchFilter.caseSensitive = false;
      var lowercaseMatch = {prop2: 'my string'};
      var uppercaseMatch = {
        prop1: 2.2,
        prop2: 'MY string'
      };
      expect(genericSearchFilter.filter(lowercaseMatch)).to.be.true;
      expect(genericSearchFilter.filter(uppercaseMatch)).to.be.true;
    });
    it('should recursively search the properties of an object', function() {
      genericSearchFilter.searchText = 'my';
      genericSearchFilter.caseSensitive = false;
      var objectWithNestedObject = {nestedObject: {prop2: 'my string'}};
      expect(genericSearchFilter.filter(objectWithNestedObject)).to.be.true;
    });
    describe('serialize', function() {
      it('should return the search if the length is greater than or equal to the minimum search length', function() {
        genericSearchFilter.searchText = '1234';
        genericSearchFilter.minSearchLength = 4;
        expect(genericSearchFilter.serialize()).to.equal('1234');
      });
      it('should return an empty string if the length is less than the minimum', function() {
        genericSearchFilter.searchText = '123';
        genericSearchFilter.minSearchLength = 4;
        expect(genericSearchFilter.serialize()).to.be.null;
      });
      it('should return an empty string if the search is null', function() {
        genericSearchFilter.searchText = null;
        expect(genericSearchFilter.serialize()).to.be.null;
      });
    });
    describe('observable', function() {
      it('should subscribe to changes to the serialized value', function() {
        var valueChangeSpy = sinon.spy();
        genericSearchFilter.searchText = null;
        genericSearchFilter.minSearchLength = 4;
        genericSearchFilter.subscribe(valueChangeSpy);
        genericSearchFilter.searchText = '1234';
        sinon.assert.calledOnce(valueChangeSpy);
        sinon.assert.calledWith(valueChangeSpy, '1234');
        genericSearchFilter.searchText = null;
        sinon.assert.calledTwice(valueChangeSpy);
        sinon.assert.calledWith(valueChangeSpy, null);
      });
    });
    describe('tokenized', function() {
      var factory;
      beforeEach(function() {
        factory = new genericSearchFilter_service_1.GenericSearchFilterFactory(object_service_1.objectUtility, string_service_1.stringUtility);
        genericSearchFilter = factory.getInstance(true);
      });
      it('should support tokenized search', function() {
        genericSearchFilter.searchText = 'some text';
        var object1 = {prop: 'some values ended up with text'};
        var object2 = {prop: 'some other something'};
        expect(genericSearchFilter.filter(object1)).to.be.true;
        expect(genericSearchFilter.filter(object2)).to.be.false;
      });
      it('should not use tokenized search by default', function() {
        genericSearchFilter = factory.getInstance();
        genericSearchFilter.searchText = 'some text';
        var object1 = {prop: 'some values ended up with text'};
        expect(genericSearchFilter.filter(object1)).to.be.false;
      });
    });
  });
  return module.exports;
});

System.registerDynamic("source/services/http/http.service.js", ["lodash", "@angular/core", "@angular/http", "rxjs/Observable", "rxjs/add/operator/map", "../object/object.service"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var __decorate = (this && this.__decorate) || function(decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
      r = Reflect.decorate(decorators, target, key, desc);
    else
      for (var i = decorators.length - 1; i >= 0; i--)
        if (d = decorators[i])
          r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
  };
  var __metadata = (this && this.__metadata) || function(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
      return Reflect.metadata(k, v);
  };
  var __param = (this && this.__param) || function(paramIndex, decorator) {
    return function(target, key) {
      decorator(target, key, paramIndex);
    };
  };
  var _ = $__require('lodash');
  var core_1 = $__require('@angular/core');
  var http_1 = $__require('@angular/http');
  var Observable_1 = $__require('rxjs/Observable');
  $__require('rxjs/add/operator/map');
  var object_service_1 = $__require('../object/object.service');
  var HttpInterceptor = (function() {
    function HttpInterceptor() {}
    return HttpInterceptor;
  }());
  exports.HttpInterceptor = HttpInterceptor;
  var HttpUtility = (function() {
    function HttpUtility(http, object, interceptor) {
      this.http = http;
      this.object = object;
      this.interceptor = this.setDefaults(interceptor);
    }
    HttpUtility.prototype.buildQueryString = function(params) {
      var searchParams = new http_1.URLSearchParams();
      _.each(params, function(param, key) {
        searchParams.set(key, param || '');
      });
      return searchParams;
    };
    HttpUtility.prototype.get = function(endpoint, params) {
      var _this = this;
      return this.http.get(endpoint, {search: this.buildQueryString(params)}).catch(this.handleError.bind(this)).map(this.handleSuccess.bind(this)).map(function(response) {
        return _this.parse(response);
      });
    };
    HttpUtility.prototype.post = function(endpoint, data) {
      var _this = this;
      var headers = new http_1.Headers({'Content-Type': 'application/json'});
      var options = new http_1.RequestOptions({headers: headers});
      return this.http.post(endpoint, JSON.stringify(data), options).catch(this.handleError.bind(this)).map(this.handleSuccess.bind(this)).map(function(response) {
        return _this.parse(response);
      });
    };
    HttpUtility.prototype.put = function(endpoint, data) {
      var _this = this;
      var headers = new http_1.Headers({'Content-Type': 'application/json'});
      var options = new http_1.RequestOptions({headers: headers});
      return this.http.put(endpoint, JSON.stringify(data), options).catch(this.handleError.bind(this)).map(this.handleSuccess.bind(this)).map(function(response) {
        return _this.parse(response);
      });
    };
    HttpUtility.prototype.delete = function(endpoint, params) {
      return this.http.delete(endpoint, {search: this.buildQueryString(params)}).catch(this.handleError.bind(this)).map(this.handleSuccess.bind(this)).map(function() {
        return null;
      });
    };
    HttpUtility.prototype.parse = function(response) {
      return this.object.isNullOrEmpty(response._body) ? null : response.json();
    };
    HttpUtility.prototype.handleError = function(response) {
      if (this.interceptor) {
        return this.interceptor.handleError(response);
      }
      return Observable_1.Observable.throw(response);
    };
    HttpUtility.prototype.handleSuccess = function(response) {
      if (this.interceptor) {
        return this.interceptor.handleSuccess(response);
      }
      return response;
    };
    HttpUtility.prototype.setDefaults = function(interceptor) {
      if (!interceptor) {
        return null;
      }
      interceptor.handleError = interceptor.handleError || (function(response) {
        return Observable_1.Observable.throw(response);
      });
      interceptor.handleSuccess = interceptor.handleSuccess || (function(response) {
        return response;
      });
      return interceptor;
    };
    HttpUtility = __decorate([core_1.Injectable(), __param(0, core_1.Inject(http_1.Http)), __param(2, core_1.Optional()), __metadata('design:paramtypes', [http_1.Http, object_service_1.ObjectUtility, HttpInterceptor])], HttpUtility);
    return HttpUtility;
  }());
  exports.HttpUtility = HttpUtility;
  return module.exports;
});

System.registerDynamic("source/services/http/http.service.tests.js", ["rxjs", "../object/object.service", "./http.service"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var rxjs_1 = $__require('rxjs');
  var object_service_1 = $__require('../object/object.service');
  var http_service_1 = $__require('./http.service');
  describe('HttpUtility', function() {
    var http;
    var mockHttpImplementation;
    var interceptor;
    beforeEach(function() {
      mockHttpImplementation = {
        get: sinon.spy(function() {
          return new rxjs_1.Subject();
        }),
        post: sinon.spy(function() {
          return new rxjs_1.Subject();
        }),
        put: sinon.spy(function() {
          return new rxjs_1.Subject();
        }),
        delete: sinon.spy(function() {
          return new rxjs_1.Subject();
        })
      };
      interceptor = {
        handleSuccess: sinon.spy(function(value) {
          return value;
        }),
        handleError: sinon.spy(function(error) {
          return error;
        })
      };
      http = new http_service_1.HttpUtility(mockHttpImplementation, object_service_1.objectUtility, interceptor);
    });
    it('should default to an empty string for null or undefined parameters', function() {
      var params = {
        nullParam: null,
        undefinedParam: undefined
      };
      http.get('/test', params);
      sinon.assert.calledOnce(mockHttpImplementation.get);
      var args = mockHttpImplementation.get.firstCall.args;
      expect(args[0]).to.equal('/test');
      expect(args[1].search.toString()).to.equal('nullParam=&undefinedParam=');
    });
    it('should parse the response from json', function() {
      var putStream = new rxjs_1.Subject();
      var response = {
        _body: 'content',
        json: sinon.spy()
      };
      mockHttpImplementation.put = sinon.spy(function() {
        return putStream;
      });
      http.put('/test', {}).subscribe();
      putStream.next(response);
      sinon.assert.calledOnce(response.json);
    });
    it('should not try to parse if the response is empty', function() {
      var putStream = new rxjs_1.Subject();
      var response = {
        _body: '',
        json: sinon.spy()
      };
      mockHttpImplementation.put = sinon.spy(function() {
        return putStream;
      });
      http.put('/test', {}).subscribe();
      putStream.next(response);
      sinon.assert.notCalled(response.json);
    });
  });
  return module.exports;
});

System.registerDynamic("source/services/logger/logger.service.tests.js", ["./logger.service"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var logger_service_1 = $__require('./logger.service');
  describe('logger', function() {
    var logger;
    beforeEach(function() {
      logger = new logger_service_1.Logger();
    });
    it('should log to the console', function() {
      var originalLog = console.log;
      var logSpy = sinon.spy();
      console.log = logSpy;
      logger.log('message');
      sinon.assert.calledOnce(logSpy);
      sinon.assert.calledWith(logSpy, 'message');
      console.log = originalLog;
    });
  });
  return module.exports;
});

System.registerDynamic("source/services/notification/notification.service.tests.js", ["./notification.service"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var notification_service_1 = $__require('./notification.service');
  describe('notification', function() {
    var notification;
    var mockWindow;
    var mockLogger;
    beforeEach(function() {
      mockWindow = {alert: sinon.spy()};
      mockLogger = {log: sinon.spy()};
      notification = new notification_service_1.NotificationService(mockWindow, mockLogger);
    });
    it('should call notifier to show an info notification', function() {
      notification.info('message');
      sinon.assert.calledOnce(mockWindow.alert);
      sinon.assert.calledWith(mockWindow.alert, 'message');
      sinon.assert.calledOnce(mockLogger.log);
      sinon.assert.calledWith(mockLogger.log, 'message');
    });
    it('should call notifier to show a warning notification', function() {
      notification.warning('message');
      sinon.assert.calledOnce(mockWindow.alert);
      sinon.assert.calledWith(mockWindow.alert, 'message');
      sinon.assert.calledOnce(mockLogger.log);
      sinon.assert.calledWith(mockLogger.log, 'message');
    });
    it('should call notifier to show an error notification', function() {
      notification.error('message');
      sinon.assert.calledOnce(mockWindow.alert);
      sinon.assert.calledWith(mockWindow.alert, 'message');
      sinon.assert.calledOnce(mockLogger.log);
      sinon.assert.calledWith(mockLogger.log, 'message');
    });
    it('should call notifier to show a success notification', function() {
      notification.success('message');
      sinon.assert.calledOnce(mockWindow.alert);
      sinon.assert.calledWith(mockWindow.alert, 'message');
      sinon.assert.calledOnce(mockLogger.log);
      sinon.assert.calledWith(mockLogger.log, 'message');
    });
  });
  return module.exports;
});

System.registerDynamic("source/services/number/number.service.js", [], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var Sign;
  (function(Sign) {
    Sign[Sign["positive"] = 1] = "positive";
    Sign[Sign["negative"] = -1] = "negative";
  })(Sign || (Sign = {}));
  var NumberUtility = (function() {
    function NumberUtility() {}
    NumberUtility.prototype.preciseRound = function(num, decimals) {
      var sign = num >= 0 ? Sign.positive : Sign.negative;
      return (Math.round((num * Math.pow(10, decimals)) + (sign * 0.001)) / Math.pow(10, decimals));
    };
    NumberUtility.prototype.integerDivide = function(dividend, divisor) {
      return Math.floor(dividend / divisor);
    };
    NumberUtility.prototype.roundToStep = function(num, step) {
      if (!step) {
        return num;
      }
      var remainder = num % step;
      if (remainder >= step / 2) {
        return num + (step - remainder);
      } else {
        return num - remainder;
      }
    };
    NumberUtility.prototype.isEven = function(num) {
      return !(num % 2);
    };
    return NumberUtility;
  }());
  exports.NumberUtility = NumberUtility;
  exports.numberUtility = new NumberUtility();
  return module.exports;
});

System.registerDynamic("source/services/number/number.service.tests.js", ["./number.service"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var number_service_1 = $__require('./number.service');
  describe('numberUtility', function() {
    var numberUtility;
    beforeEach(function() {
      numberUtility = new number_service_1.NumberUtility();
    });
    describe('preciseRound', function() {
      it('should round 6 to 6', function() {
        var roundedNum = numberUtility.preciseRound(6, 2);
        expect(roundedNum).to.equal(6);
      });
      it('should round 1.275 to 1.28', function() {
        var roundedNum = numberUtility.preciseRound(1.275, 2);
        expect(roundedNum).to.equal(1.28);
      });
      it('should round 1.274 to 1.27', function() {
        var roundedNum = numberUtility.preciseRound(1.274, 2);
        expect(roundedNum).to.equal(1.27);
      });
      it('should round 1.55555555555555555555 to 1.5555555555555555556', function() {
        var roundedNum = numberUtility.preciseRound(1.55555555555555555555, 19);
        expect(roundedNum).to.equal(1.5555555555555555556);
      });
      it('should round 1.999999999999999999999 to 2', function() {
        var roundedNum = numberUtility.preciseRound(1.999999999999999999999, 20);
        expect(roundedNum).to.equal(2);
      });
      it('should not round 1.111111111111111111111', function() {
        var roundedNum = numberUtility.preciseRound(1.111111111111111111111, 20);
        expect(roundedNum).to.equal(1.11111111111111111111);
      });
    });
    describe('roundToStep', function() {
      it('should round to the nearest 5', function() {
        expect(numberUtility.roundToStep(4, 5)).to.equal(5);
        expect(numberUtility.roundToStep(23, 5)).to.equal(25);
        expect(numberUtility.roundToStep(22, 5)).to.equal(20);
      });
      it('should round to a 365 divisible value', function() {
        expect(numberUtility.roundToStep(366, 3.65)).to.equal(365);
        expect(numberUtility.roundToStep(367, 3.65)).to.equal(368.65);
        expect(numberUtility.roundToStep(125, 3.65)).to.equal(124.10);
        expect(numberUtility.roundToStep(250, 3.65)).to.equal(248.20);
        expect(numberUtility.roundToStep(10.95, 3.65)).to.equal(10.95);
      });
    });
    describe('isEven', function() {
      it('should return true for even numbers', function() {
        expect(numberUtility.isEven(0)).to.be.true;
        expect(numberUtility.isEven(2)).to.be.true;
        expect(numberUtility.isEven(16)).to.be.true;
        expect(numberUtility.isEven(36)).to.be.true;
      });
      it('should return false for odd numbers', function() {
        expect(numberUtility.isEven(1)).to.be.false;
        expect(numberUtility.isEven(5)).to.be.false;
        expect(numberUtility.isEven(17)).to.be.false;
        expect(numberUtility.isEven(33)).to.be.false;
      });
    });
  });
  return module.exports;
});

System.registerDynamic("source/services/object/object.service.tests.js", ["./object.service", "../date/index", "../array/array.service", "moment", "moment-timezone"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var object_service_1 = $__require('./object.service');
  var index_1 = $__require('../date/index');
  var array_service_1 = $__require('../array/array.service');
  var moment = $__require('moment');
  $__require('moment-timezone');
  describe('objectUtility', function() {
    var objectUtility;
    beforeEach(function() {
      objectUtility = new object_service_1.ObjectUtility(array_service_1.arrayUtility, index_1.dateUtility);
    });
    describe('isNullOrEmpty', function() {
      it('should return true when null', function() {
        expect(objectUtility.isNullOrEmpty(null)).to.be.true;
      });
      it('should return true when empty', function() {
        expect(objectUtility.isNullOrEmpty('')).to.be.true;
      });
      it('should return false when string has contents', function() {
        expect(objectUtility.isNullOrEmpty('random string')).to.be.false;
      });
      it('should return true for null or empty arrays', function() {
        expect(objectUtility.isNullOrEmpty(null)).to.be.true;
        expect(objectUtility.isNullOrEmpty([])).to.be.true;
        expect(objectUtility.isNullOrEmpty([1, 2, 3])).to.be.false;
      });
      it('should return true if number type is not a number', function() {
        expect(objectUtility.isNullOrEmpty(Number.NaN)).to.be.true;
        expect(objectUtility.isNullOrEmpty(5)).to.be.false;
      });
      it('should return false for an array of items with 0 value', function() {
        expect(objectUtility.isNullOrEmpty([0])).to.be.false;
      });
    });
    describe('isNullOrWhitespace', function() {
      it('should return true for empty whitespace strings', function() {
        expect(objectUtility.isNullOrWhitespace('   ')).to.be.true;
      });
      it('should handle null and empty objects like isNullOrEmpty', function() {
        expect(objectUtility.isNullOrWhitespace(null)).to.equal(objectUtility.isNullOrEmpty(null));
        expect(objectUtility.isNullOrWhitespace([])).to.equal(objectUtility.isNullOrEmpty([]));
        expect(objectUtility.isNullOrWhitespace({})).to.equal(objectUtility.isNullOrEmpty({}));
        expect(objectUtility.isNullOrWhitespace('')).to.equal(objectUtility.isNullOrEmpty(''));
        expect(objectUtility.isNullOrWhitespace('random string')).to.equal(objectUtility.isNullOrEmpty('random string'));
      });
    });
    describe('areEqual', function() {
      it('should return true if two primitives are equal', function() {
        var string1 = 'abc';
        var string2 = 'abc';
        var num1 = 1;
        var num2 = 1;
        expect(objectUtility.areEqual(string1, string2)).to.be.true;
        expect(objectUtility.areEqual(num1, num2)).to.be.true;
      });
      it('should return false if two objects are not of the same type', function() {
        var string = 'abc';
        var num = 1;
        var obj = {};
        var array = [];
        expect(objectUtility.areEqual(string, num)).to.be.false;
        expect(objectUtility.areEqual(string, obj)).to.be.false;
        expect(objectUtility.areEqual(string, array)).to.be.false;
        expect(objectUtility.areEqual(num, obj)).to.be.false;
        expect(objectUtility.areEqual(num, array)).to.be.false;
      });
      it('should return false if one object is valid and the other is null', function() {
        var obj = {
          '1': 1,
          '2': 2
        };
        expect(objectUtility.areEqual(obj, null)).to.be.false;
      });
      it('should return false these objects are not equal', function() {
        var object1 = {
          name: 'objectName',
          date: new Date('1/1/1901')
        };
        var object2 = {
          name: 'objectName',
          date: new Date('1/1/1901')
        };
        expect(objectUtility.areEqual(object1, object2)).to.be.true;
        object2.date = new Date('1/2/1901');
        expect(objectUtility.areEqual(object1, object2)).to.be.false;
      });
      it('should return false if arrays have different lengths', function() {
        var array1 = [1, 2, 3, 4, 5];
        var array2 = [1, 2, 3];
        expect(objectUtility.areEqual(array1, array2)).to.be.false;
      });
      it('should compare arrays by element if they are the same length', function() {
        var array = [1, 2, 3, 4, 5];
        var similarArray = [1, 2, 3, 4, 5];
        var differentArray = [5, 4, 3, 2, 1];
        expect(objectUtility.areEqual(array, similarArray)).to.be.true;
        expect(objectUtility.areEqual(array, differentArray)).to.be.false;
      });
      it('should use the keys from the first object to compare properties', function() {
        var object = {
          '1': 1,
          '2': 2,
          '3': 3
        };
        var similarObject = {
          '2': 2,
          '3': 3,
          '1': 1
        };
        var differentObject = {
          '1': 1,
          'two': 2,
          '3': 3
        };
        expect(objectUtility.areEqual(object, similarObject)).to.be.true;
        expect(objectUtility.areEqual(object, differentObject)).to.be.false;
      });
      it('should return false if object 2 has the properties of object 1 with additional properties', function() {
        var object1 = {
          '1': 1,
          '2': 2,
          '3': 3
        };
        var object2 = {
          '1': 1,
          '2': 2,
          '3': 3,
          '4': 4,
          '5': 5
        };
        expect(objectUtility.areEqual(object1, object2)).to.be.false;
      });
      it('should recursively compare nested objects', function() {
        var object = {
          nestedObj: {
            '1': 1,
            '2': 2
          },
          nestedArray: [1, 2, 3],
          '3': 3
        };
        var similarObject = {
          nestedObj: {
            '1': 1,
            '2': 2
          },
          nestedArray: [1, 2, 3],
          '3': 3
        };
        var differentObject1 = {
          nestedObj: {
            'one': 1,
            'two': 2
          },
          nestedArray: [1, 2, 3],
          '3': 3
        };
        var differentObject2 = {
          nestedObj: {
            '1': 1,
            '2': 2
          },
          nestedArray: [1, 2, 3, 4, 5],
          '3': 3
        };
        expect(objectUtility.areEqual(object, similarObject)).to.be.true;
        expect(objectUtility.areEqual(object, differentObject1)).to.be.false;
        expect(objectUtility.areEqual(object, differentObject2)).to.be.false;
      });
      it('should compare moments by their time', function() {
        var firstMoment = moment('2016-01-02T10:00:00-07:00').tz('US/Central');
        var secondMoment = moment('2016-01-02T12:00:00-05:00').tz('US/Eastern');
        var differentMoment = moment('2016-01-02T12:00:00-08:00').tz('US/Pacific');
        expect(objectUtility.areEqual(firstMoment, secondMoment)).to.be.true;
        expect(objectUtility.areEqual(firstMoment, differentMoment)).to.be.false;
      });
    });
    describe('toString', function() {
      it('should turn numbers into strings', function() {
        expect(objectUtility.toString(5)).to.equal('5');
        expect(objectUtility.toString(2.5)).to.equal('2.5');
      });
      it('should turn booleans into strings', function() {
        expect(objectUtility.toString(false)).to.equal('false');
        expect(objectUtility.toString(true)).to.equal('true');
      });
      it('should turn undefined and null into strings', function() {
        expect(objectUtility.toString(undefined)).to.equal('undefined');
        expect(objectUtility.toString(null)).to.equal('null');
      });
    });
    describe('valueOrDefault', function() {
      it('should return the value if it is defined', function() {
        var someObject = {existingProperty: 'value'};
        expect(objectUtility.valueOrDefault(someObject.existingProperty, 'default')).to.equal('value');
      });
      it('should return the default if the value is not defined', function() {
        var someObject = {nullProperty: null};
        expect(objectUtility.valueOrDefault(someObject.nullProperty, 'default')).to.equal('default');
        expect(objectUtility.valueOrDefault(someObject.missingProperty, 'default')).to.equal('default');
      });
    });
    describe('propertyNameToString', function() {
      it('should return a value of name', function() {
        var object = {
          name: "John Doe",
          address: {street: "123 test st."}
        };
        expect(objectUtility.propertyNameToString(function() {
          return object.name;
        })).to.equal('name');
        expect(objectUtility.propertyNameToString(function() {
          return object.name;
        })).to.not.equal('John Doe');
        expect(objectUtility.propertyNameToString(function() {
          return object.address.street;
        })).to.equal('street');
        expect(objectUtility.propertyNameToString(function() {
          return object.address.street;
        })).to.not.equal('123 test st.');
      });
    });
  });
  return module.exports;
});

System.registerDynamic("source/services/observable/observable.service.js", ["@angular/core", "lodash"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var __decorate = (this && this.__decorate) || function(decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
      r = Reflect.decorate(decorators, target, key, desc);
    else
      for (var i = decorators.length - 1; i >= 0; i--)
        if (d = decorators[i])
          r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
  };
  var __metadata = (this && this.__metadata) || function(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
      return Reflect.metadata(k, v);
  };
  var core_1 = $__require('@angular/core');
  var _ = $__require('lodash');
  var ObservableService = (function() {
    function ObservableService(exceptionHandler) {
      this.watchers = [];
      this.nextKey = 0;
      this.exceptionHandler = exceptionHandler;
    }
    ObservableService.prototype.register = function(action, event) {
      var _this = this;
      if (!_.isFunction(action)) {
        this.exceptionHandler.call(new Error('Watcher must be a function'));
        return null;
      }
      if (this.allowableEvents != null && !_.find(this.allowableEvents, function(e) {
        return e === event;
      })) {
        this.exceptionHandler.call(new Error('This event is not allowed. Events: ' + this.allowableEvents.join(', ')));
        return null;
      }
      var currentKey = this.nextKey;
      this.nextKey++;
      this.watchers[currentKey] = {
        action: action,
        event: event
      };
      return function() {
        _this.unregister(currentKey);
      };
    };
    ObservableService.prototype.fire = function(event) {
      var _this = this;
      var params = [];
      for (var _i = 1; _i < arguments.length; _i++) {
        params[_i - 1] = arguments[_i];
      }
      return _(this.watchers).filter(function(watcher) {
        return watcher != null && watcher.event === event;
      }).map(function(watcher) {
        return watcher.action.apply(_this, params);
      }).value();
    };
    ObservableService.prototype.unregister = function(key) {
      this.watchers[key] = null;
    };
    ObservableService = __decorate([core_1.Injectable(), __metadata('design:paramtypes', [core_1.ExceptionHandler])], ObservableService);
    return ObservableService;
  }());
  exports.ObservableService = ObservableService;
  exports.observableToken = new core_1.OpaqueToken('Deprecated - a service for observables');
  exports.OBSERVABLE_PROVIDER = new core_1.Provider(exports.observableToken, {useClass: ObservableService});
  return module.exports;
});

System.registerDynamic("source/services/observable/observable.service.tests.js", ["./observable.service"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var observable_service_1 = $__require('./observable.service');
  describe('observable', function() {
    var observable;
    var exceptionHandler;
    beforeEach(function() {
      exceptionHandler = {call: sinon.spy()};
      observable = new observable_service_1.ObservableService(exceptionHandler);
    });
    it('should register a watcher and call the action when fire is called', function() {
      var func = sinon.spy();
      observable.register(func);
      observable.fire();
      sinon.assert.calledOnce(func);
    });
    it('should unregister only the indicated watcher', function() {
      var registeredFunc1 = sinon.spy();
      var unregisteredFunc = sinon.spy();
      var registeredFunc2 = sinon.spy();
      observable.register(registeredFunc1);
      var cancel = observable.register(unregisteredFunc);
      observable.register(registeredFunc2);
      cancel();
      observable.fire();
      sinon.assert.calledOnce(registeredFunc1);
      sinon.assert.notCalled(unregisteredFunc);
      sinon.assert.calledOnce(registeredFunc2);
    });
    it('should only call watcher registered with the specified event if fire is called with an event', function() {
      var funcWithEvent = sinon.spy();
      var funcWithoutEvent = sinon.spy();
      observable.register(funcWithEvent, 'myEvent');
      observable.register(funcWithoutEvent);
      observable.fire('myEvent');
      sinon.assert.notCalled(funcWithoutEvent);
      sinon.assert.calledOnce(funcWithEvent);
    });
    it('should not call watchers registered with a different event', function() {
      var func = sinon.spy();
      observable.register(func, 'myEvent');
      observable.fire('otherEvent');
      sinon.assert.notCalled(func);
    });
    it('should call the registered watchers with the additional params passed into the fire function', function() {
      var func = sinon.spy();
      observable.register(func, 'myEvent');
      observable.fire('myEvent', 1, 2, 3, 4, 5);
      sinon.assert.calledOnce(func);
      var args = func.firstCall.args;
      expect(args[0]).to.equal(1);
      expect(args[1]).to.equal(2);
      expect(args[2]).to.equal(3);
      expect(args[3]).to.equal(4);
      expect(args[4]).to.equal(5);
    });
    it('should return with an error if no function is provided', function() {
      var cancel = observable.register(null);
      sinon.assert.calledOnce(exceptionHandler.call);
      sinon.assert.calledWith(exceptionHandler.call, new Error('Watcher must be a function'));
      expect(cancel).to.be.null;
    });
    it('should return with an error if the event is not allowed', function() {
      observable.allowableEvents = ['event1', 'event2'];
      var cancel = observable.register(function() {
        return;
      }, 'event3');
      sinon.assert.calledOnce(exceptionHandler.call);
      sinon.assert.calledWith(exceptionHandler.call, new Error('This event is not allowed. Events: event1, event2'));
      expect(cancel).to.be.null;
    });
  });
  return module.exports;
});

System.registerDynamic("source/services/redirect/redirect.service.js", ["@angular/core", "../window/window.provider"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var __decorate = (this && this.__decorate) || function(decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
      r = Reflect.decorate(decorators, target, key, desc);
    else
      for (var i = decorators.length - 1; i >= 0; i--)
        if (d = decorators[i])
          r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
  };
  var __metadata = (this && this.__metadata) || function(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
      return Reflect.metadata(k, v);
  };
  var core_1 = $__require('@angular/core');
  var window_provider_1 = $__require('../window/window.provider');
  var RedirectService = (function() {
    function RedirectService(window) {
      this.window = window;
    }
    RedirectService.prototype.getCurrentLocationAsParam = function() {
      var baseUrl = this.window.location.pathname;
      var queryString = this.window.location.search || '';
      return encodeURIComponent(baseUrl + queryString);
    };
    RedirectService.prototype.to = function(target, newTab) {
      if (!newTab) {
        this.window.open(target, '_self');
      } else {
        var win = this.window.open(target, '_blank');
        win.focus();
      }
    };
    RedirectService.prototype.back = function() {
      this.window.history.back();
    };
    RedirectService = __decorate([core_1.Injectable(), __metadata('design:paramtypes', [window_provider_1.WindowWrapper])], RedirectService);
    return RedirectService;
  }());
  exports.RedirectService = RedirectService;
  return module.exports;
});

System.registerDynamic("source/services/redirect/redirect.service.tests.js", ["./redirect.service"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var redirect_service_1 = $__require('./redirect.service');
  describe('RedirectService', function() {
    var redirectService;
    var mockWindow;
    beforeEach(function() {
      mockWindow = {
        location: null,
        open: sinon.spy(function() {
          return mockWindow;
        }),
        focus: sinon.spy(),
        history: {back: sinon.spy()}
      };
      redirectService = new redirect_service_1.RedirectService(mockWindow);
    });
    describe('getCurrentLocationAsParam', function() {
      it('should get location as a query string', function() {
        mockWindow.location = {
          pathname: '/path',
          search: '?search=true&Die=angularUno'
        };
        var locationAsParam = redirectService.getCurrentLocationAsParam();
        expect(locationAsParam).to.equal('%2Fpath%3Fsearch%3Dtrue%26Die%3DangularUno');
      });
      it('should get location without query string', function() {
        mockWindow.location = {
          pathname: '/path',
          search: null
        };
        var locationAsParam = redirectService.getCurrentLocationAsParam();
        expect(locationAsParam).to.equal('%2Fpath');
      });
    });
    describe('to', function() {
      it('should redirect to the specified target', function() {
        redirectService.to('/some/path');
        sinon.assert.calledOnce(mockWindow.open);
        sinon.assert.calledWith(mockWindow.open, '/some/path', '_self');
      });
      it('should redirect to the specified target in new window', function() {
        redirectService.to('/some/path', true);
        sinon.assert.calledOnce(mockWindow.open);
        sinon.assert.calledWith(mockWindow.open, '/some/path', '_blank');
        sinon.assert.calledOnce(mockWindow.focus);
      });
    });
    describe('back', function() {
      it('should trigger back on the window history', function() {
        redirectService.back();
        sinon.assert.calledOnce(mockWindow.history.back);
      });
    });
  });
  return module.exports;
});

System.registerDynamic("source/services/search/search.service.js", ["@angular/core", "lodash", "../object/object.service", "../string/string.service"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var __decorate = (this && this.__decorate) || function(decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
      r = Reflect.decorate(decorators, target, key, desc);
    else
      for (var i = decorators.length - 1; i >= 0; i--)
        if (d = decorators[i])
          r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
  };
  var __metadata = (this && this.__metadata) || function(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
      return Reflect.metadata(k, v);
  };
  var core_1 = $__require('@angular/core');
  var _ = $__require('lodash');
  var object_service_1 = $__require('../object/object.service');
  var string_service_1 = $__require('../string/string.service');
  var SearchUtility = (function() {
    function SearchUtility(objectUtility, stringUtility) {
      this.objectUtility = objectUtility;
      this.stringUtility = stringUtility;
    }
    SearchUtility.prototype.search = function(object, search, caseSensitive) {
      var _this = this;
      if (this.objectUtility.isNullOrEmpty(search)) {
        return true;
      }
      if (_.isObject(object)) {
        var values = _.values(object);
        return _.some(values, function(value) {
          return _this.search(value, search, caseSensitive);
        });
      } else {
        var dataString = this.objectUtility.toString(object);
        if (!caseSensitive) {
          search = search.toLowerCase();
          dataString = dataString.toLowerCase();
        }
        return this.stringUtility.contains(dataString, search);
      }
    };
    SearchUtility.prototype.tokenizedSearch = function(object, search, caseSensitive) {
      var _this = this;
      if (search == null) {
        return true;
      }
      return _.every(search.split(' '), function(subsearch) {
        return _this.search(object, subsearch, caseSensitive);
      });
    };
    SearchUtility = __decorate([core_1.Injectable(), __metadata('design:paramtypes', [object_service_1.ObjectUtility, string_service_1.StringUtility])], SearchUtility);
    return SearchUtility;
  }());
  exports.SearchUtility = SearchUtility;
  exports.searchUtility = new SearchUtility(object_service_1.objectUtility, string_service_1.stringUtility);
  return module.exports;
});

System.registerDynamic("source/services/search/search.service.tests.js", ["./search.service"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var search_service_1 = $__require('./search.service');
  describe('search utility', function() {
    it('should return true for all items if search is null or empty', function() {
      var object1 = {prop: 'some string'};
      var object2 = {prop: 'another value'};
      expect(search_service_1.searchUtility.search(object1, null)).to.be.true;
      expect(search_service_1.searchUtility.search(object2, null)).to.be.true;
      expect(search_service_1.searchUtility.search(object1, '')).to.be.true;
      expect(search_service_1.searchUtility.search(object2, '')).to.be.true;
    });
    it('should search the actual data values if they arent objects', function() {
      expect(search_service_1.searchUtility.search(1, '2')).to.be.false;
      expect(search_service_1.searchUtility.search(2, '2')).to.be.true;
      expect(search_service_1.searchUtility.search(3, '2')).to.be.false;
      expect(search_service_1.searchUtility.search(4, '2')).to.be.false;
      expect(search_service_1.searchUtility.search(5, '2')).to.be.false;
    });
    it('should include items that contain the search string', function() {
      var searchText = 'my';
      var caseSensitive = true;
      var matchingObject1 = {prop2: 'my string'};
      var matchingObject2 = {
        prop1: 5,
        prop2: 'some string with my'
      };
      var objectWithoutSearchString = {prop1: 2};
      var objectWithDifferentCase = {
        prop1: 5,
        prop2: 'MY string'
      };
      expect(search_service_1.searchUtility.search(matchingObject1, searchText, caseSensitive)).to.be.true;
      expect(search_service_1.searchUtility.search(objectWithoutSearchString, searchText, caseSensitive)).to.be.false;
      expect(search_service_1.searchUtility.search(matchingObject2, searchText, caseSensitive)).to.be.true;
      expect(search_service_1.searchUtility.search(objectWithDifferentCase, searchText, caseSensitive)).to.be.false;
    });
    it('should include items that contain the search string, case insensitive', function() {
      var searchText = 'my';
      var caseInsensitive = false;
      var lowercaseMatch = {prop2: 'my string'};
      var uppercaseMatch = {
        prop1: 2.2,
        prop2: 'MY string'
      };
      expect(search_service_1.searchUtility.search(lowercaseMatch, searchText, caseInsensitive)).to.be.true;
      expect(search_service_1.searchUtility.search(uppercaseMatch, searchText, caseInsensitive)).to.be.true;
    });
    it('should recursively search the properties of an object', function() {
      var searchText = 'my';
      var caseInsensitive = false;
      var objectWithNestedObject = {nestedObject: {prop2: 'my string'}};
      expect(search_service_1.searchUtility.search(objectWithNestedObject, searchText, caseInsensitive)).to.be.true;
    });
    describe('tokenized', function() {
      it('should match against objects where each token appears at least once', function() {
        var searchText = 'some text';
        var object1 = {prop: 'some values ended up with text'};
        var objectWithNesting = {
          prop: 'some',
          nestedObject: {prop2: 'with text'}
        };
        var object2 = {prop: 'some other something'};
        expect(search_service_1.searchUtility.tokenizedSearch(object1, searchText)).to.be.true;
        expect(search_service_1.searchUtility.tokenizedSearch(objectWithNesting, searchText)).to.be.true;
        expect(search_service_1.searchUtility.tokenizedSearch(object2, searchText)).to.be.false;
      });
      it('should handle a null search', function() {
        var object = {prop: 'some values ended up with text'};
        expect(search_service_1.searchUtility.tokenizedSearch(object, null)).to.be.true;
      });
    });
  });
  return module.exports;
});

System.registerDynamic("source/services/string/string.service.tests.js", ["./string.service"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var string_service_1 = $__require('./string.service');
  describe('stringUtility', function() {
    var stringUtility;
    beforeEach(function() {
      stringUtility = new string_service_1.StringUtility();
    });
    describe('toNumber', function() {
      it('should convert a string to a number', function() {
        expect(stringUtility.toNumber('5')).to.equal(5);
        expect(stringUtility.toNumber('3')).to.equal(3);
        expect(stringUtility.toNumber('1.25')).to.equal(1.25);
      });
    });
    describe('contains', function() {
      it('should return true if the substring is contained within the string', function() {
        expect(stringUtility.contains('my string', 'my')).to.be.true;
        expect(stringUtility.contains('123', '1')).to.be.true;
        expect(stringUtility.contains('', null)).to.be.true;
        expect(stringUtility.contains('my string', '')).to.be.true;
      });
      it('should return false if the substring is not contained within the string', function() {
        expect(stringUtility.contains('my string', 'my val')).to.be.false;
        expect(stringUtility.contains('123', '4')).to.be.false;
        expect(stringUtility.contains('my string', 'my string 1')).to.be.false;
      });
    });
    describe('replaceAll', function() {
      it('should replace all occurances of some given text with another inside a string', function() {
        expect(stringUtility.replaceAll('hello world', 'foo', 'bar')).to.equal('hello world');
        expect(stringUtility.replaceAll('fooHellofooWorldfoo', 'foo', 'bar')).to.equal('barHellobarWorldbar');
      });
    });
    describe('substitute', function() {
      it('should substitute strings with their positional placeholder value in other strings', function() {
        expect(stringUtility.substitute('hello world', 'foo')).to.equal('hello world');
        expect(stringUtility.substitute('hello {0} world {1}', 'foo', 'bar')).to.equal('hello foo world bar');
      });
    });
  });
  return module.exports;
});

System.registerDynamic("source/services/synchronizedRequests/synchronizedRequests.service.js", ["@angular/core"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var core_1 = $__require('@angular/core');
  var SynchronizedRequestsService = (function() {
    function SynchronizedRequestsService(dataProvider, handleRequest) {
      this.requestId = 0;
      this.dataProvider = dataProvider;
      this.handleRequest = handleRequest;
    }
    SynchronizedRequestsService.prototype.getData = function() {
      var _this = this;
      var params = [];
      for (var _i = 0; _i < arguments.length; _i++) {
        params[_i - 0] = arguments[_i];
      }
      this.requestId++;
      var currentRequestId = this.requestId;
      Promise.resolve(this.dataProvider.apply(this, params)).then(function() {
        var data = [];
        for (var _i = 0; _i < arguments.length; _i++) {
          data[_i - 0] = arguments[_i];
        }
        if (currentRequestId == _this.requestId) {
          _this.handleRequest.apply(_this, data);
        }
      });
    };
    return SynchronizedRequestsService;
  }());
  exports.SynchronizedRequestsService = SynchronizedRequestsService;
  var SynchronizedRequestsFactory = (function() {
    function SynchronizedRequestsFactory() {}
    SynchronizedRequestsFactory.prototype.getInstance = function(dataProvider, handleRequest) {
      return new SynchronizedRequestsService(dataProvider, handleRequest);
    };
    return SynchronizedRequestsFactory;
  }());
  exports.SynchronizedRequestsFactory = SynchronizedRequestsFactory;
  function SynchronizedRequestsProvider(dataProvider, handleRequest) {
    return core_1.provide(SynchronizedRequestsService, {useFactory: function() {
        return new SynchronizedRequestsService(dataProvider, handleRequest);
      }});
  }
  exports.SynchronizedRequestsProvider = SynchronizedRequestsProvider;
  return module.exports;
});

System.registerDynamic("source/services/synchronizedRequests/synchronizedRequests.service.tests.js", ["../test/mockAsync", "./synchronizedRequests.service", "../test/fakeAsync"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var mockAsync_1 = $__require('../test/mockAsync');
  var synchronizedRequests_service_1 = $__require('./synchronizedRequests.service');
  var fakeAsync_1 = $__require('../test/fakeAsync');
  describe('synchronizedRequests', function() {
    var synchronizedRequests;
    it('should accept the results from only the most recent request', fakeAsync_1.rlFakeAsync(function() {
      var firstRequestData = [1, 2];
      var secondRequestData = [3, 4];
      var firstRequest = mockAsync_1.mock.promise(firstRequestData);
      var secondRequest = mockAsync_1.mock.promise(secondRequestData);
      var callback = sinon.spy();
      var get = sinon.spy(function() {
        return firstRequest();
      });
      synchronizedRequests = new synchronizedRequests_service_1.SynchronizedRequestsService(get, callback);
      synchronizedRequests.getData();
      sinon.assert.calledOnce(get);
      get = sinon.spy(function() {
        return secondRequest();
      });
      synchronizedRequests.dataProvider = get;
      synchronizedRequests.getData();
      sinon.assert.calledOnce(get);
      firstRequest.flush();
      sinon.assert.notCalled(callback);
      secondRequest.flush();
      sinon.assert.calledOnce(callback);
      sinon.assert.calledWith(callback, secondRequestData);
    }));
  });
  return module.exports;
});

System.registerDynamic("source/services/test/chaiMoment.js", ["moment", "../date/dateTimeFormatStrings"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var moment = $__require('moment');
  var dateTimeFormatStrings_1 = $__require('../date/dateTimeFormatStrings');
  var chai = window.chai;
  if (chai) {
    chai.Assertion.addMethod('sameMoment', equalMoment);
    chai.Assertion.addMethod('equalMoment', equalMoment);
    chai.Assertion.addMethod('beforeMoment', function(expected, granularity) {
      var obj = this._obj;
      var objMoment = moment(obj);
      var expectedMoment = moment(expected);
      this.assert(objMoment.isBefore(expectedMoment, granularity), 'expected ' + objMoment.format(dateTimeFormatStrings_1.defaultFormats.dateTimeFormat + ' z') + ' to be before ' + expectedMoment.format(dateTimeFormatStrings_1.defaultFormats.dateTimeFormat + ' z') + (granularity ? ' (granularity: ' + granularity + ')' : ''), 'expected ' + objMoment.format(dateTimeFormatStrings_1.defaultFormats.dateTimeFormat + ' z') + ' not to be before ' + expectedMoment.format(dateTimeFormatStrings_1.defaultFormats.dateTimeFormat + ' z') + (granularity ? ' (granularity: ' + granularity + ')' : ''), expected, obj, true);
    });
    chai.Assertion.addMethod('afterMoment', function(expected, granularity) {
      var obj = this._obj;
      var objMoment = moment(obj);
      var expectedMoment = moment(expected);
      this.assert(objMoment.isAfter(expectedMoment, granularity), 'expected ' + objMoment.format(dateTimeFormatStrings_1.defaultFormats.dateTimeFormat + ' z') + ' to be after ' + expectedMoment.format(dateTimeFormatStrings_1.defaultFormats.dateTimeFormat + ' z') + (granularity ? ' (granularity: ' + granularity + ')' : ''), 'expected ' + objMoment.format(dateTimeFormatStrings_1.defaultFormats.dateTimeFormat + ' z') + ' not to be after ' + expectedMoment.format(dateTimeFormatStrings_1.defaultFormats.dateTimeFormat + ' z') + (granularity ? ' (granularity: ' + granularity + ')' : ''), expected, obj, true);
    });
  }
  function equalMoment(expected, granularity) {
    var obj = this._obj;
    var objMoment = moment(obj);
    var expectedMoment = moment(expected);
    this.assert(objMoment.isSame(expectedMoment, granularity), 'expected ' + objMoment.format(dateTimeFormatStrings_1.defaultFormats.dateTimeFormat + ' z') + ' not to be the same as ' + expectedMoment.format(dateTimeFormatStrings_1.defaultFormats.dateTimeFormat + ' z') + (granularity ? ' (granularity: ' + granularity + ')' : ''), 'expected ' + objMoment.format(dateTimeFormatStrings_1.defaultFormats.dateTimeFormat + ' z') + ' to be the same as ' + expectedMoment.format(dateTimeFormatStrings_1.defaultFormats.dateTimeFormat + ' z') + (granularity ? ' (granularity: ' + granularity + ')' : ''), expected, obj, true);
  }
  return module.exports;
});

System.registerDynamic("source/services/test/angularFixture.js", ["angular", "angular-mocks", "lodash"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var angular = $__require('angular');
  $__require('angular-mocks');
  var _ = $__require('lodash');
  var AngularFixture = (function() {
    function AngularFixture() {}
    AngularFixture.prototype.inject = function() {
      var serviceNames = [];
      for (var _i = 0; _i < arguments.length; _i++) {
        serviceNames[_i - 0] = arguments[_i];
      }
      var services = {};
      var injectParameters = _.clone(serviceNames);
      injectParameters.push(function() {
        var injectedServices = [];
        for (var _i = 0; _i < arguments.length; _i++) {
          injectedServices[_i - 0] = arguments[_i];
        }
        _.each(serviceNames, function(service, index) {
          services[service] = injectedServices[index];
        });
      });
      angular.mock.inject(injectParameters);
      return services;
    };
    AngularFixture.prototype.mock = function(mocks) {
      angular.mock.module(function($provide) {
        _.each(mocks, function(value, key) {
          $provide.value(key.toString(), value);
        });
      });
    };
    AngularFixture.prototype.componentController = function(componentName, bindings, locals, scope) {
      var services = this.inject('$rootScope', '$componentController');
      var $rootScope = services.$rootScope;
      var $componentController = services.$componentController;
      scope = _.extend($rootScope.$new(), scope);
      if (locals == null) {
        locals = {};
      }
      locals.$scope = scope;
      return {
        scope: scope,
        controller: $componentController(componentName, locals, bindings)
      };
    };
    AngularFixture.prototype.controllerWithBindings = function(controllerName, bindings, locals, scope) {
      var services = this.inject('$rootScope', '$controller');
      var $rootScope = services.$rootScope;
      var $controller = services.$controller;
      scope = _.extend($rootScope.$new(), scope);
      if (locals == null) {
        locals = {};
      }
      locals.$scope = scope;
      return {
        scope: scope,
        controller: $controller(controllerName, locals, bindings)
      };
    };
    AngularFixture.prototype.directive = function(directiveName, dom, scope) {
      var services = this.inject('$rootScope', '$compile');
      scope = _.extend(services.$rootScope.$new(), scope);
      var $compile = services.$compile;
      var component = $compile(dom)(scope);
      scope.$digest();
      return {
        directive: component,
        scope: component.isolateScope(),
        controller: component.controller(directiveName)
      };
    };
    return AngularFixture;
  }());
  exports.angularFixture = new AngularFixture();
  return module.exports;
});

System.registerDynamic("source/services/test/index.js", ["./chaiMoment", "@angular/core/testing", "./fakeAsync", "./mockAsync", "./angularFixture"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  function __export(m) {
    for (var p in m)
      if (!exports.hasOwnProperty(p))
        exports[p] = m[p];
  }
  $__require('./chaiMoment');
  var testing_1 = $__require('@angular/core/testing');
  exports.async = testing_1.async;
  __export($__require('./fakeAsync'));
  __export($__require('./mockAsync'));
  __export($__require('./angularFixture'));
  return module.exports;
});

System.registerDynamic("source/services/test/chaiMoment.tests.js", ["moment", "moment-timezone", "./index"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var moment = $__require('moment');
  $__require('moment-timezone');
  $__require('./index');
  describe('chai moment', function() {
    it('should return true if moments are equal', function() {
      expect(moment('2015-01-01')).to.be.sameMoment(moment('2015-01-01'));
      expect(moment('2015-01-01')).to.equalMoment(moment('2015-01-01'));
      expect(moment('2015-01-01')).to.not.be.sameMoment(moment('2016-01-01'));
      expect(moment('2015-01-01')).to.not.equalMoment(moment('2016-01-01'));
    });
    it('should return true if the first moment is after the second', function() {
      expect(moment('2015-01-01')).to.be.afterMoment(moment('2014-01-01'));
      expect(moment('2015-01-01')).to.not.be.afterMoment(moment('2016-01-01'));
    });
    it('should return true if the first moment is before the second', function() {
      expect(moment('2015-01-01')).to.be.beforeMoment(moment('2016-01-01'));
      expect(moment('2015-01-01')).to.not.be.beforeMoment(moment('2014-01-01'));
    });
    it('should accept strings and dates', function() {
      expect('2015-01-01').to.equalMoment('2015-01-01');
      expect(new Date(2015, 1, 1)).to.equalMoment(new Date(2015, 1, 1));
    });
    it('should handle timezones', function() {
      var est_moment = moment('2016-01-02T12:00:00.000-05:00').tz('US/Eastern');
      var pst_moment = moment('2016-01-02T09:00:00.000-08:00').tz('US/Pacific');
      expect(est_moment).to.equalMoment(pst_moment);
    });
  });
  return module.exports;
});

System.registerDynamic("source/services/test/fakeAsync.tests.js", ["rxjs", "./fakeAsync"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var rxjs_1 = $__require('rxjs');
  var fakeAsync_1 = $__require('./fakeAsync');
  describe('fakeAsync', function() {
    it('should schedule an rxjs action', fakeAsync_1.rlFakeAsync(function() {
      var testStream = new rxjs_1.Subject();
      var testSpy = sinon.spy();
      testStream.delay(1000).subscribe(function() {
        return testSpy();
      });
      testStream.next(null);
      sinon.assert.notCalled(testSpy);
      fakeAsync_1.rlTick(1000);
      fakeAsync_1.flushMicrotasks();
      sinon.assert.calledOnce(testSpy);
    }));
    it('should throw an error if there are pending requests', function() {
      expect(fakeAsync_1.rlFakeAsync(function() {
        fakeAsync_1.rlQueueRequest({pending: true});
      })).to.throw('There are still pending requests. Please be sure to flush all of your requests');
    });
    it('should run successfully if all requests in the queue are resolved', function() {
      fakeAsync_1.rlFakeAsync(function() {
        fakeAsync_1.rlQueueRequest({pending: false});
      })();
    });
  });
  return module.exports;
});

System.registerDynamic("source/services/test/mockAsync.tests.js", ["rxjs", "./mockAsync", "./fakeAsync"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var rxjs_1 = $__require('rxjs');
  var mockAsync_1 = $__require('./mockAsync');
  var fakeAsync_1 = $__require('./fakeAsync');
  describe('mockAsync', function() {
    it('should create a request that resolves when flushed', fakeAsync_1.rlFakeAsync(function() {
      var mockedObservable = mockAsync_1.mock.request({value: 10});
      mockedObservable().subscribe(function(result) {
        expect(result.value).to.equal(10);
      });
      mockedObservable.flush();
    }));
    it('should create a request that resolves with dynamic content when flushed', fakeAsync_1.rlFakeAsync(function() {
      var mockedObservable = mockAsync_1.mock.request(function(value1, value2) {
        return {value: value1 + value2};
      });
      mockedObservable(5, 3).subscribe(function(result) {
        expect(result.value).to.equal(8);
      });
      mockedObservable.flush();
    }));
    it('should create a request that is rejected', fakeAsync_1.rlFakeAsync(function() {
      var mockedObservable = mockAsync_1.mock.rejectedRequest(new Error('an error'));
      mockedObservable().subscribe(function() {
        assert.fail(null, null, 'Request should be rejected, not resolved');
      }, function(error) {
        expect(error.message).to.equal('an error');
      });
      mockedObservable.flush();
    }));
    it('should create a request and set it to be rejected', fakeAsync_1.rlFakeAsync(function() {
      var mockedObservable = mockAsync_1.mock.request({value: 3});
      mockedObservable.reject(new Error('error message'));
      mockedObservable().subscribe(function() {
        assert.fail(null, null, 'Observable should be rejected, not resolved');
      }, function(error) {
        expect(error.message).to.equal('error message');
      });
      mockedObservable.flush();
    }));
    it('should be able to reuse mocked requests', fakeAsync_1.rlFakeAsync(function() {
      var mockedObservable = mockAsync_1.mock.request({value: 3}, true);
      mockedObservable().subscribe(function(result1) {
        expect(result1.value).to.equal(3);
        mockedObservable().subscribe(function(result2) {
          expect(result2.value).to.equal(3);
        });
        mockedObservable.flush();
      });
      mockedObservable.flush();
    }));
    it('should allow unique parameters with successive calls', fakeAsync_1.rlFakeAsync(function() {
      var mockedObservable = mockAsync_1.mock.request(function(value1, value2) {
        return {value: value1 + value2};
      }, true);
      mockedObservable(5, 3).subscribe(function(result) {
        expect(result.value).to.equal(8);
        mockedObservable(8, 2).subscribe(function(result) {
          expect(result.value).to.equal(10);
        });
        mockedObservable.flush();
      });
      mockedObservable.flush();
    }));
    it('should reuse a pending request when sharing', function() {
      var mockedObservable = mockAsync_1.mock.request({value: 3}, true);
      expect(mockedObservable()).to.equal(mockedObservable());
    });
    it('should not reuse a pending request by default or not sharing', function() {
      var mockedObservable = mockAsync_1.mock.request({value: 3});
      expect(mockedObservable()).to.not.equal(mockedObservable());
      mockedObservable = mockAsync_1.mock.request({value: 3}, false);
      expect(mockedObservable()).to.not.equal(mockedObservable());
    });
    it('should flush all requests on an unshared mock request', fakeAsync_1.rlFakeAsync(function() {
      var mockedObservable = mockAsync_1.mock.request(function(result) {
        return result;
      });
      rxjs_1.Observable.forkJoin([mockedObservable(5), mockedObservable(10)]).subscribe(function(_a) {
        var result1 = _a[0],
            result2 = _a[1];
        expect(result1).to.equal(5);
        expect(result2).to.equal(10);
      });
      mockedObservable.flush();
    }));
    it('should spy on the request function', function() {
      var mockedObservable = mockAsync_1.mock.request({value: 3});
      mockedObservable(6);
      sinon.assert.calledOnce(mockedObservable);
      sinon.assert.calledWith(mockedObservable, 6);
    });
    it('should flush all request on an object', fakeAsync_1.rlFakeAsync(function() {
      var service = {
        request1: mockAsync_1.mock.request({value: 3}),
        request2: mockAsync_1.mock.request({value: 4})
      };
      rxjs_1.Observable.forkJoin([service.request1(), service.request2()]).subscribe(function(_a) {
        var result1 = _a[0],
            result2 = _a[1];
        expect(result1.value).to.equal(3);
        expect(result2.value).to.equal(4);
      });
      mockAsync_1.mock.flushAll(service);
    }));
    it('should work with Observable.from and Observable.forkJoin', fakeAsync_1.rlFakeAsync(function() {
      var mockedObservables = [mockAsync_1.mock.request(5), mockAsync_1.mock.request(10)];
      var whens = mockedObservables.map(function(mocked) {
        return rxjs_1.Observable.from(mocked());
      });
      rxjs_1.Observable.forkJoin(whens).subscribe(function(_a) {
        var result1 = _a[0],
            result2 = _a[1];
        expect(result1).to.equal(5);
        expect(result2).to.equal(10);
      });
      mockAsync_1.mock.flushAll(mockedObservables);
    }));
    it('should work with toPromise', fakeAsync_1.rlFakeAsync(function() {
      var mockedObservable = mockAsync_1.mock.request({value: 10});
      mockedObservable().toPromise().then(function(result) {
        expect(result.value).to.equal(10);
      });
      mockedObservable.flush();
    }));
  });
  return module.exports;
});

System.registerDynamic("source/services/test/mockPromise.js", ["lodash", "./fakeAsync"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var _ = $__require('lodash');
  var fakeAsync_1 = $__require('./fakeAsync');
  var MockPromiseService = (function() {
    function MockPromiseService() {}
    MockPromiseService.prototype.promise = function(result, share) {
      if (_.isUndefined(share)) {
        share = false;
      }
      if (_.isFunction(result)) {
        return this.makeDynamicMockPromise(result, share);
      } else {
        return this.makeMockPromise(result, share);
      }
    };
    MockPromiseService.prototype.rejectedPromise = function() {
      var params = [];
      for (var _i = 0; _i < arguments.length; _i++) {
        params[_i - 0] = arguments[_i];
      }
      var mocked = this.makeMockPromise(null, false);
      mocked.rejected = true;
      mocked.rejectParams = params;
      return mocked;
    };
    MockPromiseService.prototype.flushAll = function(service) {
      _.each(service, function(promise) {
        if (promise && _.isFunction(promise.flush)) {
          promise.flush();
        }
      });
    };
    MockPromiseService.prototype.makeMockPromise = function(result, share) {
      return this.makeDynamicMockPromise(function() {
        return result;
      }, share);
    };
    MockPromiseService.prototype.makeDynamicMockPromise = function(result, shareParam) {
      var share = shareParam;
      ;
      var requests = [];
      var mocked;
      var promiseBuilder = (function() {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
          args[_i - 0] = arguments[_i];
        }
        if (share && _.some(requests)) {
          return _.first(requests).promise;
        }
        var newRequest = {
          resolve: null,
          reject: null,
          params: args,
          promise: null,
          rejected: mocked.rejected,
          rejectParams: mocked.rejectParams,
          pending: true
        };
        newRequest.promise = new Promise(function(resolve, reject) {
          newRequest.resolve = resolve;
          newRequest.reject = reject;
        });
        requests.push(newRequest);
        fakeAsync_1.rlQueueRequest(newRequest);
        return newRequest.promise;
      });
      var spiedBuilder = sinon.spy(promiseBuilder);
      mocked = spiedBuilder;
      mocked.reject = function() {
        var params = [];
        for (var _i = 0; _i < arguments.length; _i++) {
          params[_i - 0] = arguments[_i];
        }
        mocked.rejected = true;
        mocked.rejectParams = params;
      };
      mocked.share = function(shareParam) {
        if (_.isUndefined(shareParam)) {
          share = true;
        }
        share = shareParam;
      };
      mocked.flush = function() {
        _.each(requests, function(request) {
          request.pending = false;
          if (request.rejected) {
            request.reject.apply(request, request.rejectParams);
          } else {
            request.resolve(result.apply(void 0, request.params));
          }
        });
        requests = [];
        fakeAsync_1.flushMicrotasks();
      };
      return mocked;
    };
    return MockPromiseService;
  }());
  exports.mockPromise = new MockPromiseService();
  return module.exports;
});

System.registerDynamic("source/services/test/mockAsync.js", ["lodash", "rxjs", "./fakeAsync", "./mockPromise"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var lodash_1 = $__require('lodash');
  var rxjs_1 = $__require('rxjs');
  var fakeAsync_1 = $__require('./fakeAsync');
  var mockPromise_1 = $__require('./mockPromise');
  var MockAsyncService = (function() {
    function MockAsyncService() {}
    MockAsyncService.prototype.promise = function(result, share) {
      return mockPromise_1.mockPromise.promise(result, share);
    };
    MockAsyncService.prototype.rejectedPromise = function() {
      var params = [];
      for (var _i = 0; _i < arguments.length; _i++) {
        params[_i - 0] = arguments[_i];
      }
      return mockPromise_1.mockPromise.rejectedPromise.apply(mockPromise_1.mockPromise, params);
    };
    MockAsyncService.prototype.request = function(result, share) {
      if (lodash_1.isUndefined(share)) {
        share = false;
      }
      if (lodash_1.isFunction(result)) {
        return this.makeDynamicMockRequest(result, share);
      } else {
        return this.makeMockRequest(result, share);
      }
    };
    MockAsyncService.prototype.rejectedRequest = function(error) {
      var mocked = this.makeMockRequest(null, false);
      mocked.rejected = true;
      mocked.rejectParam = error;
      return mocked;
    };
    MockAsyncService.prototype.flushAll = function(service) {
      lodash_1.each(service, function(request) {
        if (request && lodash_1.isFunction(request.flush)) {
          request.flush();
        }
      });
    };
    MockAsyncService.prototype.makeMockRequest = function(result, share) {
      return this.makeDynamicMockRequest(function() {
        return result;
      }, share);
    };
    MockAsyncService.prototype.makeDynamicMockRequest = function(result, shareParam) {
      var share = shareParam;
      ;
      var requests = [];
      var mocked;
      var requestBuilder = (function() {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
          args[_i - 0] = arguments[_i];
        }
        if (share && lodash_1.some(requests) && lodash_1.first(requests).pending) {
          return lodash_1.first(requests).observable;
        }
        var newRequest = {
          resolve: null,
          reject: null,
          params: args,
          stream: null,
          observable: null,
          rejected: mocked.rejected,
          rejectParam: mocked.rejectParam,
          pending: true
        };
        newRequest.stream = new rxjs_1.Subject();
        newRequest.observable = newRequest.stream.asObservable();
        requests.push(newRequest);
        fakeAsync_1.rlQueueRequest(newRequest);
        return newRequest.observable;
      });
      var spiedBuilder = sinon.spy(requestBuilder);
      mocked = spiedBuilder;
      mocked.reject = function(error) {
        mocked.rejected = true;
        mocked.rejectParam = error;
      };
      mocked.share = function(shareParam) {
        if (lodash_1.isUndefined(shareParam)) {
          share = true;
        }
        share = shareParam;
      };
      mocked.flush = function() {
        lodash_1.each(requests, function(request) {
          if (!request.pending) {
            return;
          }
          request.pending = false;
          if (request.rejected) {
            request.stream.error(request.rejectParam);
          } else {
            request.stream.next(result.apply(void 0, request.params));
            request.stream.complete();
          }
        });
        requests = [];
        fakeAsync_1.flushMicrotasks();
      };
      return mocked;
    };
    return MockAsyncService;
  }());
  exports.mock = new MockAsyncService();
  return module.exports;
});

System.registerDynamic("source/services/test/mockPromise.tests.js", ["./mockAsync", "./fakeAsync"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var mockAsync_1 = $__require('./mockAsync');
  var fakeAsync_1 = $__require('./fakeAsync');
  describe('mockPromise', function() {
    it('should create a promise that resolves when flushed', fakeAsync_1.rlFakeAsync(function() {
      var mockedPromise = mockAsync_1.mock.promise({value: 10});
      mockedPromise().then(function(result) {
        expect(result.value).to.equal(10);
      });
      mockedPromise.flush();
    }));
    it('should create a promise that resolves with dynamic content when flushed', fakeAsync_1.rlFakeAsync(function() {
      var mockedPromise = mockAsync_1.mock.promise(function(value1, value2) {
        return {value: value1 + value2};
      });
      mockedPromise(5, 3).then(function(result) {
        expect(result.value).to.equal(8);
      });
      mockedPromise.flush();
    }));
    it('should create a promise that is rejected', fakeAsync_1.rlFakeAsync(function() {
      var mockedPromise = mockAsync_1.mock.rejectedPromise(new Error('an error'));
      mockedPromise().then(function() {
        assert.fail(null, null, 'Promise should be rejected, not resolved');
      }, function(error) {
        expect(error.message).to.equal('an error');
      });
      mockedPromise.flush();
    }));
    it('should create a promise and set it to be rejected', fakeAsync_1.rlFakeAsync(function() {
      var mockedPromise = mockAsync_1.mock.promise({value: 3});
      mockedPromise.reject(new Error('error message'));
      mockedPromise().then(function() {
        assert.fail(null, null, 'Promise should be rejected, not resolved');
      }, function(error) {
        expect(error.message).to.equal('error message');
      });
      mockedPromise.flush();
    }));
    it('should be able to reuse mocked promises', fakeAsync_1.rlFakeAsync(function() {
      var mockedPromise = mockAsync_1.mock.promise({value: 3}, true);
      mockedPromise.reject(new Error('error message'));
      mockedPromise().then(function() {
        return null;
      }, function(error) {
        mockedPromise.rejected = false;
        mockedPromise().then(function(result) {
          expect(result.value).to.equal(3);
        });
        mockedPromise.flush();
      });
      mockedPromise.flush();
    }));
    it('should allow unique parameters with successive calls', fakeAsync_1.rlFakeAsync(function() {
      var mockedPromise = mockAsync_1.mock.promise(function(value1, value2) {
        return {value: value1 + value2};
      }, true);
      mockedPromise(5, 3).then(function(result) {
        expect(result.value).to.equal(8);
        mockedPromise(8, 2).then(function(result) {
          expect(result.value).to.equal(10);
        });
        mockedPromise.flush();
      });
      mockedPromise.flush();
    }));
    it('should reuse a pending promise when sharing', function() {
      var mockedPromise = mockAsync_1.mock.promise({value: 3}, true);
      expect(mockedPromise()).to.equal(mockedPromise());
    });
    it('should not reuse a pending promise by default or not sharing', function() {
      var mockedPromise = mockAsync_1.mock.promise({value: 3});
      expect(mockedPromise()).to.not.equal(mockedPromise());
      mockedPromise = mockAsync_1.mock.promise({value: 3}, false);
      expect(mockedPromise()).to.not.equal(mockedPromise());
    });
    it('should flush all requests on an unshared promise', fakeAsync_1.rlFakeAsync(function() {
      var mockedPromise = mockAsync_1.mock.promise(function(result) {
        return result;
      });
      Promise.all([mockedPromise(5), mockedPromise(10)]).then(function(_a) {
        var result1 = _a[0],
            result2 = _a[1];
        expect(result1).to.equal(5);
        expect(result2).to.equal(10);
      });
      mockedPromise.flush();
    }));
    it('should spy on the promise function', function() {
      var mockedPromise = mockAsync_1.mock.promise({value: 3});
      mockedPromise(6);
      sinon.assert.calledOnce(mockedPromise);
      sinon.assert.calledWith(mockedPromise, 6);
    });
    it('should flush all promises on an object', fakeAsync_1.rlFakeAsync(function() {
      var service = {
        promise1: mockAsync_1.mock.promise({value: 3}),
        promise2: mockAsync_1.mock.promise({value: 4})
      };
      Promise.all([service.promise1(), service.promise2()]).then(function(_a) {
        var result1 = _a[0],
            result2 = _a[1];
        expect(result1.value).to.equal(3);
        expect(result2.value).to.equal(4);
      });
      mockAsync_1.mock.flushAll(service);
    }));
    it('should work with Promise.resolve and Promise.all', fakeAsync_1.rlFakeAsync(function() {
      var mockedPromises = [mockAsync_1.mock.promise(5), mockAsync_1.mock.promise(10)];
      var whens = mockedPromises.map(function(mocked) {
        return Promise.resolve(mocked());
      });
      Promise.all(whens).then(function(_a) {
        var result1 = _a[0],
            result2 = _a[1];
        expect(result1).to.equal(5);
        expect(result2).to.equal(10);
      });
      mockAsync_1.mock.flushAll(mockedPromises);
    }));
  });
  return module.exports;
});

System.registerDynamic("source/services/time/time.service.js", ["@angular/core", "moment", "lodash", "../../types/compareResult", "../date/index", "../string/string.service", "../object/object.service"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var __decorate = (this && this.__decorate) || function(decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
      r = Reflect.decorate(decorators, target, key, desc);
    else
      for (var i = decorators.length - 1; i >= 0; i--)
        if (d = decorators[i])
          r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
  };
  var __metadata = (this && this.__metadata) || function(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
      return Reflect.metadata(k, v);
  };
  var core_1 = $__require('@angular/core');
  var moment = $__require('moment');
  var lodash_1 = $__require('lodash');
  var compareResult_1 = $__require('../../types/compareResult');
  var index_1 = $__require('../date/index');
  var string_service_1 = $__require('../string/string.service');
  var object_service_1 = $__require('../object/object.service');
  exports.timePeriods = {
    AM: 'AM',
    PM: 'PM'
  };
  var defaultHour = 12;
  var defaultMinute = 0;
  var TimeUtility = (function() {
    function TimeUtility(stringUtility, objectUtility) {
      this.stringUtility = stringUtility;
      this.objectUtility = objectUtility;
    }
    TimeUtility.prototype.compareTimes = function(start, end) {
      var format = index_1.defaultFormats.timeFormat;
      var startMoment = moment(start, format);
      var endMoment = moment(end, format);
      if (startMoment.hours() === endMoment.hours() && startMoment.minutes() === endMoment.minutes()) {
        return compareResult_1.CompareResult.equal;
      } else if (startMoment.hours() >= endMoment.hours() && startMoment.minutes() >= endMoment.minutes()) {
        return compareResult_1.CompareResult.greater;
      } else {
        return compareResult_1.CompareResult.less;
      }
    };
    TimeUtility.prototype.durationInHours = function(start, end) {
      var format = index_1.defaultFormats.timeFormat;
      var startMoment = moment(start, format);
      var endMoment = moment(end, format);
      var hours = endMoment.hours() - startMoment.hours();
      var minutes = endMoment.minutes() - startMoment.minutes();
      if (minutes >= 30) {
        hours += 1;
      }
      return hours;
    };
    TimeUtility.prototype.parseTime = function(value) {
      if (this.objectUtility.isNullOrEmpty(value)) {
        return null;
      }
      var time = {};
      var _a = value.split(':'),
          hourString = _a[0],
          subsetWithoutHour = _a[1];
      time.hour = this.stringUtility.toNumber(hourString);
      time.minute = this.stringUtility.toNumber(lodash_1.dropRight(subsetWithoutHour, 2).join(''));
      time.period = lodash_1.takeRight(subsetWithoutHour, 2).join('') === exports.timePeriods.PM ? exports.timePeriods.PM : exports.timePeriods.AM;
      return time;
    };
    TimeUtility.prototype.formatTime = function(time, includePeriod) {
      if (includePeriod === void 0) {
        includePeriod = true;
      }
      if (time == null) {
        return null;
      }
      var postfix = includePeriod ? time.period : '';
      return (time.hour || defaultHour) + ':' + lodash_1.padStart((time.minute || defaultMinute).toString(), 2, '0') + postfix;
    };
    TimeUtility.prototype.inversePeriod = function(period) {
      return period === exports.timePeriods.AM ? exports.timePeriods.PM : exports.timePeriods.AM;
    };
    TimeUtility = __decorate([core_1.Injectable(), __metadata('design:paramtypes', [string_service_1.StringUtility, object_service_1.ObjectUtility])], TimeUtility);
    return TimeUtility;
  }());
  exports.TimeUtility = TimeUtility;
  exports.timeUtility = new TimeUtility(string_service_1.stringUtility, object_service_1.objectUtility);
  return module.exports;
});

System.registerDynamic("source/services/string/string.service.js", ["lodash"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var _ = $__require('lodash');
  var StringUtility = (function() {
    function StringUtility() {}
    StringUtility.prototype.toNumber = function(string) {
      return +string;
    };
    StringUtility.prototype.contains = function(str, substring) {
      if (substring) {
        return str.indexOf(substring) !== -1;
      }
      return true;
    };
    StringUtility.prototype.substitute = function(formatString) {
      var _this = this;
      var params = [];
      for (var _i = 1; _i < arguments.length; _i++) {
        params[_i - 1] = arguments[_i];
      }
      _.each(params, function(param, index) {
        formatString = _this.replaceAll(formatString, '\\{' + index + '\\}', param);
      });
      return formatString;
    };
    StringUtility.prototype.replaceAll = function(str, patternToFind, replacementString) {
      return str.replace(new RegExp(patternToFind, 'gi'), replacementString);
    };
    return StringUtility;
  }());
  exports.StringUtility = StringUtility;
  exports.stringUtility = new StringUtility();
  return module.exports;
});

System.registerDynamic("source/services/array/array.service.js", ["lodash"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var _ = $__require('lodash');
  var ArrayUtility = (function() {
    function ArrayUtility() {}
    ArrayUtility.prototype.findIndexOf = function(array, predicate) {
      var targetIndex;
      _.each(array, function(item, index) {
        if (predicate(item)) {
          targetIndex = index;
          return false;
        }
      });
      return targetIndex != null ? targetIndex : -1;
    };
    ArrayUtility.prototype.remove = function(array, item) {
      var index;
      if (_.isFunction(item)) {
        index = this.findIndexOf(array, item);
      } else {
        index = _.indexOf(array, item);
      }
      if (index >= 0) {
        return array.splice(index, 1)[0];
      } else {
        return null;
      }
    };
    ArrayUtility.prototype.replace = function(array, oldItem, newItem) {
      var index = _.indexOf(array, oldItem);
      if (index >= 0) {
        array.splice(index, 1, newItem);
      }
    };
    ArrayUtility.prototype.sum = function(array, transform) {
      var list;
      if (transform != null) {
        list = _.map(array, function(item) {
          return transform(item);
        });
      } else {
        list = array;
      }
      return _.reduce(list, function(sum, num) {
        return sum + num;
      }, 0);
    };
    ArrayUtility.prototype.toDictionary = function(array, keySelector) {
      array = _.reject(array, function(item) {
        return keySelector(item) == null;
      });
      return _.reduce(array, function(dictionary, item) {
        dictionary[keySelector(item)] = item;
        return dictionary;
      }, {});
    };
    ArrayUtility.prototype.last = function(array) {
      if (array != null && array.length > 0) {
        return array[array.length - 1];
      }
    };
    ArrayUtility.prototype.has = function(array, index) {
      if (array == null || index < 0 || index >= array.length) {
        return false;
      }
      return array[index] != null;
    };
    ArrayUtility.prototype.arrayify = function(maybeArray) {
      if (_.isArray(maybeArray)) {
        return maybeArray;
      } else if (maybeArray) {
        return [maybeArray];
      } else {
        return [];
      }
    };
    return ArrayUtility;
  }());
  exports.ArrayUtility = ArrayUtility;
  exports.arrayUtility = new ArrayUtility();
  return module.exports;
});

System.registerDynamic("source/services/object/object.service.js", ["@angular/core", "lodash", "moment", "../array/array.service", "../date/index"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var __decorate = (this && this.__decorate) || function(decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
      r = Reflect.decorate(decorators, target, key, desc);
    else
      for (var i = decorators.length - 1; i >= 0; i--)
        if (d = decorators[i])
          r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
  };
  var __metadata = (this && this.__metadata) || function(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
      return Reflect.metadata(k, v);
  };
  var core_1 = $__require('@angular/core');
  var _ = $__require('lodash');
  var moment = $__require('moment');
  var array_service_1 = $__require('../array/array.service');
  var index_1 = $__require('../date/index');
  var ObjectUtility = (function() {
    function ObjectUtility(array, dateUtility) {
      this.array = array;
      this.dateUtility = dateUtility;
    }
    ObjectUtility.prototype.isNullOrEmpty = function(object) {
      if (object == null) {
        return true;
      } else if (_.isArray(object)) {
        return object.length <= 0;
      } else if (_.isNumber(object)) {
        return _.isNaN(object);
      } else {
        return object === '';
      }
    };
    ObjectUtility.prototype.isNullOrWhitespace = function(object) {
      if (_.isString(object)) {
        object = object.trim();
      }
      return this.isNullOrEmpty(object);
    };
    ObjectUtility.prototype.areEqual = function(obj1, obj2) {
      var _this = this;
      var type1 = typeof obj1;
      var type2 = typeof obj2;
      if (obj1 == null && obj2 == null) {
        return true;
      } else if (obj1 == null || obj2 == null) {
        return false;
      }
      if (type1 !== type2) {
        return false;
      } else if (obj1 instanceof Array) {
        if (obj1.length !== obj2.length) {
          return false;
        }
        for (var i = 0; i < obj1.length; i++) {
          if (this.areEqual(obj1[i], obj2[i]) === false) {
            return false;
          }
        }
      } else if (this.areDates(obj1, obj2)) {
        return this.dateUtility.sameDateTime(obj1, obj2);
      } else if (type1 === 'object') {
        var keys2 = _.keys(obj2);
        _.forIn(obj1, function(value, key) {
          if (_.has(obj2, key)) {
            if (_this.areEqual(value, obj2[key]) === false) {
              return false;
            } else {
              _this.array.remove(keys2, key);
            }
          } else {
            return false;
          }
        });
        if (_.some(keys2)) {
          return false;
        }
      } else {
        return obj1 === obj2;
      }
      return true;
    };
    ObjectUtility.prototype.areDates = function(obj1, obj2) {
      if ((_.isDate(obj1) && _.isDate(obj2)) || (moment.isMoment(obj1) && moment.isMoment(obj2))) {
        return true;
      }
      return false;
    };
    ObjectUtility.prototype.toString = function(object) {
      return object + '';
    };
    ObjectUtility.prototype.valueOrDefault = function(value, defaultValue) {
      if (value != null) {
        return value;
      } else {
        return defaultValue;
      }
    };
    ObjectUtility.prototype.propertyNameToString = function(propertyFunction) {
      var stringValue = propertyFunction.toString();
      var regExpLiteral = /\.([^\.;]+);?\s*\}$/;
      var propertyName = regExpLiteral.exec(stringValue)[1];
      return propertyName;
    };
    ObjectUtility = __decorate([core_1.Injectable(), __metadata('design:paramtypes', [array_service_1.ArrayUtility, index_1.DateUtility])], ObjectUtility);
    return ObjectUtility;
  }());
  exports.ObjectUtility = ObjectUtility;
  exports.objectUtility = new ObjectUtility(array_service_1.arrayUtility, index_1.dateUtility);
  return module.exports;
});

System.registerDynamic("source/services/time/time.service.tests.js", ["./time.service", "../../types/compareResult", "../string/string.service", "../object/object.service"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var time_service_1 = $__require('./time.service');
  var compareResult_1 = $__require('../../types/compareResult');
  var string_service_1 = $__require('../string/string.service');
  var object_service_1 = $__require('../object/object.service');
  describe('timeUtility', function() {
    var timeUtility;
    beforeEach(function() {
      timeUtility = new time_service_1.TimeUtility(string_service_1.stringUtility, object_service_1.objectUtility);
    });
    it('should compare times and return a compare result to indicate which is greater', function() {
      expect(timeUtility.compareTimes('12:00PM', '1:00PM')).to.equal(compareResult_1.CompareResult.less);
      expect(timeUtility.compareTimes('12:00PM', '12:00PM')).to.equal(compareResult_1.CompareResult.equal);
      expect(timeUtility.compareTimes('2:00PM', '1:00PM')).to.equal(compareResult_1.CompareResult.greater);
    });
    it('should return the rounded number of hours between two times', function() {
      expect(timeUtility.durationInHours('8:00AM', '5:00PM')).to.equal(9);
      expect(timeUtility.durationInHours('8:00AM', '8:00AM')).to.equal(0);
      expect(timeUtility.durationInHours('2:45PM', '3:15PM')).to.equal(1);
      expect(timeUtility.durationInHours('12:00AM', '12:00AM')).to.equal(0);
      expect(timeUtility.durationInHours('12:00AM', '12:00PM')).to.equal(12);
      expect(timeUtility.durationInHours('12:00AM', '11:59PM')).to.equal(24);
    });
    it('should return null if the time is null or empty', function() {
      expect(timeUtility.parseTime(null)).to.be.null;
      expect(timeUtility.parseTime('')).to.be.null;
      expect(timeUtility.formatTime(null)).to.be.null;
    });
    it('should parse the time string into a time object', function() {
      expect(timeUtility.parseTime('8:00AM')).to.deep.equal({
        hour: 8,
        minute: 0,
        period: 'AM'
      });
      expect(timeUtility.parseTime('12:00PM')).to.deep.equal({
        hour: 12,
        minute: 0,
        period: 'PM'
      });
      expect(timeUtility.parseTime('12:00AM')).to.deep.equal({
        hour: 12,
        minute: 0,
        period: 'AM'
      });
      expect(timeUtility.parseTime('10:15AM')).to.deep.equal({
        hour: 10,
        minute: 15,
        period: 'AM'
      });
      expect(timeUtility.parseTime('1:41PM')).to.deep.equal({
        hour: 1,
        minute: 41,
        period: 'PM'
      });
    });
    it('should format the time object into a time string', function() {
      expect(timeUtility.formatTime({
        hour: 8,
        minute: 0,
        period: 'AM'
      })).to.equal('8:00AM');
      expect(timeUtility.formatTime({
        hour: 12,
        minute: 0,
        period: 'PM'
      })).to.equal('12:00PM');
      expect(timeUtility.formatTime({
        hour: 12,
        minute: 0,
        period: 'AM'
      })).to.equal('12:00AM');
      expect(timeUtility.formatTime({
        hour: 10,
        minute: 15,
        period: 'AM'
      })).to.equal('10:15AM');
      expect(timeUtility.formatTime({
        hour: 1,
        minute: 41,
        period: 'PM'
      })).to.equal('1:41PM');
    });
    it('should hide the period if includePeriod is false', function() {
      expect(timeUtility.formatTime({
        hour: 8,
        minute: 0,
        period: 'AM'
      }, false)).to.equal('8:00');
      expect(timeUtility.formatTime({
        hour: 12,
        minute: 0,
        period: 'PM'
      }, false)).to.equal('12:00');
    });
    it('should handle null hours or minutes', function() {
      expect(timeUtility.formatTime({
        hour: 9,
        minute: null,
        period: 'AM'
      })).to.equal('9:00AM');
      expect(timeUtility.formatTime({
        hour: null,
        minute: 30,
        period: 'AM'
      })).to.equal('12:30AM');
    });
    it('should return the opposite period, defaulting to AM', function() {
      expect(timeUtility.inversePeriod('AM')).to.equal('PM');
      expect(timeUtility.inversePeriod('PM')).to.equal('AM');
      expect(timeUtility.inversePeriod(null)).to.equal('AM');
    });
  });
  return module.exports;
});

System.registerDynamic("source/services/timeout/timeout.service.js", ["lodash"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var lodash_1 = $__require('lodash');
  var TimeoutService = (function() {
    function TimeoutService() {}
    TimeoutService.prototype.setTimeout = function(callbackOrDuration, duration) {
      var useCallback = lodash_1.isFunction(callbackOrDuration);
      var callback = useCallback ? callbackOrDuration : function() {
        return null;
      };
      duration = useCallback ? duration : callbackOrDuration;
      var pending;
      var rejectFunc;
      var promise = new Promise(function(resolve, reject) {
        pending = true;
        rejectFunc = reject;
        setTimeout(function() {
          if (pending) {
            pending = false;
            resolve();
            callback();
          }
        }, duration);
      });
      return this.wrapPromiseAsTimeout(promise, function() {
        pending = false;
        rejectFunc();
      });
    };
    TimeoutService.prototype.wrapPromiseAsTimeout = function(promise, cancel) {
      var _this = this;
      var promiseThen = promise.then.bind(promise);
      var promiseCatch = promise.catch.bind(promise);
      var timeout = promise;
      timeout.cancel = cancel;
      timeout.then = function(onSuccess, onError) {
        var newPromise = promiseThen(onSuccess, onError);
        return _this.wrapPromiseAsTimeout(newPromise, cancel);
      };
      return timeout;
    };
    return TimeoutService;
  }());
  exports.TimeoutService = TimeoutService;
  return module.exports;
});

System.registerDynamic("source/services/test/fakeAsync.js", ["rxjs", "@angular/core/testing"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var rxjs_1 = $__require('rxjs');
  var requestQueue = [];
  var timeElapsed = 0;
  var testing_1 = $__require('@angular/core/testing');
  exports.flushMicrotasks = testing_1.flushMicrotasks;
  function rlFakeAsync(fn) {
    return testing_1.fakeAsync(function() {
      var args = [];
      for (var _i = 0; _i < arguments.length; _i++) {
        args[_i - 0] = arguments[_i];
      }
      var originalNow = rxjs_1.Scheduler.async.now;
      timeElapsed = 0;
      rxjs_1.Scheduler.async.now = function() {
        return timeElapsed;
      };
      requestQueue = [];
      var res = fn.apply(void 0, args);
      testing_1.flushMicrotasks();
      if (requestQueue.some(function(request) {
        return request.pending;
      })) {
        throw new Error('There are still pending requests. Please be sure to flush all of your requests');
      }
      rxjs_1.Scheduler.async.now = originalNow;
      return res;
    });
  }
  exports.rlFakeAsync = rlFakeAsync;
  exports.fakeAsync = rlFakeAsync;
  function rlQueueRequest(request) {
    requestQueue.push(request);
  }
  exports.rlQueueRequest = rlQueueRequest;
  exports.queueRequest = rlQueueRequest;
  function rlTick(milliseconds) {
    timeElapsed += milliseconds;
    testing_1.tick(milliseconds);
  }
  exports.rlTick = rlTick;
  exports.tick = rlTick;
  return module.exports;
});

System.registerDynamic("source/services/timeout/timeout.service.tests.js", ["./timeout.service", "../test/fakeAsync"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var timeout_service_1 = $__require('./timeout.service');
  var fakeAsync_1 = $__require('../test/fakeAsync');
  describe('TimeoutService', function() {
    var timeoutService;
    beforeEach(function() {
      timeoutService = new timeout_service_1.TimeoutService();
    });
    it('should resolve the promise and call the callback when the timeout finishes', fakeAsync_1.rlFakeAsync(function() {
      var promiseSpy = sinon.spy();
      var callback = sinon.spy();
      timeoutService.setTimeout(callback, 2000).then(promiseSpy);
      fakeAsync_1.rlTick(2000);
      fakeAsync_1.flushMicrotasks();
      sinon.assert.calledOnce(promiseSpy);
      sinon.assert.calledOnce(callback);
    }));
    it('should reject the promise without calling the callback if the timeout is canceled', fakeAsync_1.rlFakeAsync(function() {
      var rejectSpy = sinon.spy();
      var callback = sinon.spy();
      var timeout = timeoutService.setTimeout(callback, 2000).then(assert.fail).catch(rejectSpy);
      timeout.cancel();
      fakeAsync_1.rlTick(2000);
      fakeAsync_1.flushMicrotasks();
      sinon.assert.calledOnce(rejectSpy);
      sinon.assert.notCalled(callback);
    }));
    it('should allow for specifying just a duration for chaining as a promise', fakeAsync_1.rlFakeAsync(function() {
      var promiseSpy = sinon.spy();
      timeoutService.setTimeout(2000).then(promiseSpy);
      fakeAsync_1.flushMicrotasks();
      sinon.assert.notCalled(promiseSpy);
      fakeAsync_1.rlTick(2000);
      fakeAsync_1.flushMicrotasks();
      sinon.assert.calledOnce(promiseSpy);
    }));
  });
  return module.exports;
});

System.registerDynamic("source/services/timezone/timezone.enum.tests.js", ["../date/index", "moment", "moment-timezone", "./timezone.enum"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var index_1 = $__require('../date/index');
  var moment = $__require('moment');
  $__require('moment-timezone');
  var timezone_enum_1 = $__require('./timezone.enum');
  describe('timezone enum', function() {
    it('should handle daylight savings time', function() {
      var dateWithoutDaylightSavings = moment('2016-2-1T12:00:00-07:00', index_1.defaultFormats.isoFormat).tz(timezone_enum_1.timezones.PST.momentName);
      var dateWithDaylightSavings = moment('2016-4-1T12:00:00-07:00', index_1.defaultFormats.isoFormat).tz(timezone_enum_1.timezones.PST.momentName);
      expect(dateWithoutDaylightSavings.format('Z')).to.equal('-08:00');
      expect(dateWithDaylightSavings.format('Z')).to.equal('-07:00');
    });
    it('should return the appropriate timezone enum', function() {
      var ast_timezone = moment('2016-1-2T12:00:00-04:00', index_1.defaultFormats.isoFormat).tz(timezone_enum_1.timezones.AST.momentName);
      var est_timezone = moment('2016-1-2T12:00:00-04:00', index_1.defaultFormats.isoFormat).tz(timezone_enum_1.timezones.EST.momentName);
      var cst_timezone = moment('2016-1-2T12:00:00-04:00', index_1.defaultFormats.isoFormat).tz(timezone_enum_1.timezones.CST.momentName);
      var mst_timezone = moment('2016-1-2T12:00:00-04:00', index_1.defaultFormats.isoFormat).tz(timezone_enum_1.timezones.MST.momentName);
      var pst_timezone = moment('2016-1-2T12:00:00-04:00', index_1.defaultFormats.isoFormat).tz(timezone_enum_1.timezones.PST.momentName);
      var akst_timezone = moment('2016-1-2T12:00:00-04:00', index_1.defaultFormats.isoFormat).tz(timezone_enum_1.timezones.AKST.momentName);
      var hast_timezone = moment('2016-1-2T12:00:00-04:00', index_1.defaultFormats.isoFormat).tz(timezone_enum_1.timezones.HAST.momentName);
      expect(ast_timezone.format('Z')).to.equal('-04:00');
      expect(est_timezone.format('Z')).to.equal('-05:00');
      expect(cst_timezone.format('Z')).to.equal('-06:00');
      expect(mst_timezone.format('Z')).to.equal('-07:00');
      expect(pst_timezone.format('Z')).to.equal('-08:00');
      expect(akst_timezone.format('Z')).to.equal('-09:00');
      expect(hast_timezone.format('Z')).to.equal('-10:00');
    });
    it('should get a timezone from a moment timezone', function() {
      expect(timezone_enum_1.timezones.get(timezone_enum_1.timezones.MST.momentName)).to.equal(timezone_enum_1.timezones.MST);
    });
  });
  return module.exports;
});

System.registerDynamic("source/services/timezone/timezone.service.js", ["moment", "lodash", "./timezone.enum"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  function __export(m) {
    for (var p in m)
      if (!exports.hasOwnProperty(p))
        exports[p] = m[p];
  }
  var moment = $__require('moment');
  var _ = $__require('lodash');
  var timezone_enum_1 = $__require('./timezone.enum');
  __export($__require('./timezone.enum'));
  var TimezoneService = (function() {
    function TimezoneService() {}
    Object.defineProperty(TimezoneService.prototype, "currentTimezone", {
      get: function() {
        return this._currentTimezone;
      },
      enumerable: true,
      configurable: true
    });
    TimezoneService.prototype.setCurrentTimezone = function(offset) {
      var timezone = timezone_enum_1.timezones.get(offset);
      this._currentTimezone = timezone;
    };
    TimezoneService.prototype.getTimezone = function(isoString) {
      if (isoString == null) {
        return null;
      }
      var offsetText = '-' + _.last(isoString.split('-'));
      return timezone_enum_1.timezones.get(offsetText);
    };
    TimezoneService.prototype.getMomentTimezone = function(isoString) {
      var timezone = this.getTimezone(isoString);
      return timezone != null ? timezone.momentName : null;
    };
    TimezoneService.prototype.buildMomentWithTimezone = function(dateValue, timezone, format) {
      var previousTimezone;
      var previousOffset;
      if (_.isString(dateValue)) {
        previousTimezone = this.getTimezone(dateValue);
      }
      if (previousTimezone != null) {
        previousOffset = previousTimezone.offsetMinutes;
      } else {
        previousOffset = moment(dateValue, format).utcOffset();
      }
      var dateWithNewTimezone = moment(dateValue, format).tz(timezone.momentName);
      var offsetDifferenceBetweenOriginalAndNewTimezones = previousOffset - dateWithNewTimezone.utcOffset();
      dateWithNewTimezone.add(offsetDifferenceBetweenOriginalAndNewTimezones, 'minutes');
      return dateWithNewTimezone;
    };
    return TimezoneService;
  }());
  exports.TimezoneService = TimezoneService;
  exports.timezoneService = new TimezoneService();
  return module.exports;
});

System.registerDynamic("source/types/compareResult.js", [], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  (function(CompareResult) {
    CompareResult[CompareResult["greater"] = 1] = "greater";
    CompareResult[CompareResult["equal"] = 0] = "equal";
    CompareResult[CompareResult["less"] = -1] = "less";
    CompareResult[CompareResult["invalid"] = null] = "invalid";
  })(exports.CompareResult || (exports.CompareResult = {}));
  var CompareResult = exports.CompareResult;
  function getCompareResult(num) {
    if (num == null) {
      return CompareResult.invalid;
    }
    if (num === 0) {
      return CompareResult.equal;
    } else if (num > 0) {
      return CompareResult.greater;
    } else {
      return CompareResult.less;
    }
  }
  exports.getCompareResult = getCompareResult;
  return module.exports;
});

System.registerDynamic("source/services/date/date.service.js", ["lodash", "moment", "moment-timezone", "../timezone/timezone.service", "./dateTimeFormatStrings", "../../types/compareResult"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var _ = $__require('lodash');
  var moment = $__require('moment');
  $__require('moment-timezone');
  var timezone_service_1 = $__require('../timezone/timezone.service');
  var dateTimeFormatStrings_1 = $__require('./dateTimeFormatStrings');
  var compareResult_1 = $__require('../../types/compareResult');
  var DateUtility = (function() {
    function DateUtility() {
      this.baseFormat = dateTimeFormatStrings_1.defaultFormats.isoFormat;
      this.usingOffset = false;
    }
    DateUtility.prototype.getFullString = function(month) {
      return moment().month(month).format('MMMM');
    };
    DateUtility.prototype.subtractDates = function(start, end, dateFormat) {
      var duration = this.subtractDatesMoment(start, end, dateFormat);
      if (duration == null) {
        return null;
      }
      var result = {};
      result.days = Math.floor(duration.days());
      result.months = Math.floor(duration.months());
      result.years = Math.floor(duration.years());
      return result;
    };
    DateUtility.prototype.subtractDateInDays = function(start, end, dateFormat) {
      var duration = this.subtractDatesMoment(start, end, dateFormat);
      return duration != null ? duration.asDays() : null;
    };
    DateUtility.prototype.subtractDateInMilliseconds = function(start, end, dateFormat) {
      var duration = this.subtractDatesMoment(start, end, dateFormat);
      return duration != null ? duration.asMilliseconds() : null;
    };
    DateUtility.prototype.subtractDatesMoment = function(start, end, dateFormat) {
      if (start == null || end == null) {
        return null;
      }
      var startDate = this.parseDate(start, dateFormat);
      var endDate = this.parseDate(end, dateFormat);
      return moment.duration(endDate.diff(startDate));
    };
    DateUtility.prototype.compareDates = function(date1, date2, dateFormat) {
      var difference = this.subtractDateInMilliseconds(date2, date1, dateFormat);
      return compareResult_1.getCompareResult(difference);
    };
    DateUtility.prototype.dateInRange = function(date, rangeStart, rangeEnd, dateFormat) {
      if (date == null || rangeStart == null || rangeEnd == null) {
        return null;
      }
      if (this.compareDates(date, rangeStart, dateFormat) === compareResult_1.CompareResult.less || this.compareDates(date, rangeEnd, dateFormat) === compareResult_1.CompareResult.greater) {
        return false;
      } else {
        return true;
      }
    };
    DateUtility.prototype.getDateFromISOString = function(isoDateTime) {
      if (isoDateTime == null) {
        return null;
      }
      var momentOffset = timezone_service_1.timezoneService.getMomentTimezone(isoDateTime);
      var momentDate = moment(isoDateTime, dateTimeFormatStrings_1.defaultFormats.isoFormat);
      return momentOffset != null ? momentDate.tz(momentOffset) : momentDate.tz(timezone_service_1.timezoneService.currentTimezone.momentName);
    };
    DateUtility.prototype.isDate = function(date, dateFormat) {
      if (_.isDate(date)) {
        return !isNaN(date.getTime());
      }
      return moment(date, this.getFormat(dateFormat)).isValid();
    };
    DateUtility.prototype.getNow = function() {
      return this.setTimezone(moment());
    };
    DateUtility.prototype.formatDate = function(date, dateFormat) {
      return moment(this.parseDate(date, dateFormat)).format(this.getFormat(dateFormat));
    };
    DateUtility.prototype.sameDate = function(date1, date2, date1Format, date2Format, granularity) {
      if (date1 == null || date2 == null) {
        return null;
      }
      date2Format = date2Format || date1Format;
      granularity = granularity || 'day';
      if (this.isDate(date1, date1Format) && this.isDate(date2, date2Format)) {
        var moment1 = this.parseDate(date1, date1Format);
        var moment2 = this.parseDate(date2, date2Format);
        return moment1.isSame(moment2, granularity);
      } else {
        return false;
      }
    };
    DateUtility.prototype.sameDateTime = function(date1, date2, date1Format, date2Format) {
      return this.sameDate(date1, date2, date1Format, date2Format, 'milliseconds');
    };
    DateUtility.prototype.setOffset = function(millis) {
      var _this = this;
      moment.now = function() {
        var now = moment(new Date());
        now = _this.setTimezone(now);
        return now.valueOf() + millis;
      };
      this.usingOffset = true;
    };
    DateUtility.prototype.parseDate = function(date, dateFormat) {
      if (_.isDate(date)) {
        return moment(date);
      }
      return moment(date, this.getFormat(dateFormat));
    };
    DateUtility.prototype.getFormat = function(customFormat) {
      return customFormat != null ? customFormat : this.baseFormat;
    };
    DateUtility.prototype.setTimezone = function(date) {
      if (timezone_service_1.timezoneService.currentTimezone != null) {
        date = date.tz(timezone_service_1.timezoneService.currentTimezone.momentName);
      }
      return date;
    };
    return DateUtility;
  }());
  exports.DateUtility = DateUtility;
  exports.dateUtility = new DateUtility();
  return module.exports;
});

System.registerDynamic("source/services/date/dateTimeFormatStrings.js", [], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  exports.dateTimeFormatServiceName = 'dateTimeFormatStrings';
  exports.defaultFormats = {
    isoFormat: 'YYYY-MM-DDTHH:mm:ssZ',
    dateTimeFormat: 'MM/DD/YYYY h:mm A',
    dateFormat: 'MM/DD/YYYY',
    timeFormat: 'h:mmA'
  };
  return module.exports;
});

System.registerDynamic("source/services/date/index.js", ["./date.service", "./dateTimeFormatStrings"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  function __export(m) {
    for (var p in m)
      if (!exports.hasOwnProperty(p))
        exports[p] = m[p];
  }
  __export($__require('./date.service'));
  __export($__require('./dateTimeFormatStrings'));
  return module.exports;
});

System.registerDynamic("source/services/timezone/timezone.enum.js", ["lodash"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var _ = $__require('lodash');
  var Timezones = (function() {
    function Timezones() {
      this.AST = new Timezone({
        offset: '-04:00',
        display: 'AST',
        momentName: 'Canada/Atlantic',
        offsetMinutes: -240
      });
      this.EST = new Timezone({
        offset: '-05:00',
        display: 'EST',
        momentName: 'US/Eastern',
        offsetMinutes: -300
      });
      this.CST = new Timezone({
        offset: '-06:00',
        display: 'CST',
        momentName: 'US/Central',
        offsetMinutes: -360
      });
      this.MST = new Timezone({
        offset: '-07:00',
        display: 'MST',
        momentName: 'US/Mountain',
        offsetMinutes: -420
      });
      this.PST = new Timezone({
        offset: '-08:00',
        display: 'PST',
        momentName: 'US/Pacific',
        offsetMinutes: -480
      });
      this.AKST = new Timezone({
        offset: '-09:00',
        display: 'AKST',
        momentName: 'US/Alaska',
        offsetMinutes: -540
      });
      this.HAST = new Timezone({
        offset: '-10:00',
        display: 'HAST',
        momentName: 'US/Hawaii',
        offsetMinutes: -600
      });
      this.items = [this.AST, this.EST, this.CST, this.MST, this.PST, this.AKST, this.HAST];
    }
    Timezones.prototype.get = function(offsetOrMomentName) {
      return _.find(this.items, function(item) {
        return (item.offset === offsetOrMomentName || item.momentName === offsetOrMomentName);
      });
    };
    Timezones.prototype.all = function() {
      return this.items;
    };
    return Timezones;
  }());
  exports.Timezones = Timezones;
  var Timezone = (function() {
    function Timezone(data) {
      this.offset = data.offset;
      this.display = data.display;
      this.momentName = data.momentName;
      this.offsetMinutes = data.offsetMinutes;
    }
    return Timezone;
  }());
  exports.timezones = new Timezones();
  exports.UTC = {
    offset: '+00:00',
    display: 'UTC',
    momentName: 'UTC',
    offsetMinutes: 0
  };
  return module.exports;
});

System.registerDynamic("source/services/timezone/timezone.service.tests.js", ["./timezone.service", "../date/index", "moment", "moment-timezone", "./timezone.enum"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var timezone_service_1 = $__require('./timezone.service');
  var index_1 = $__require('../date/index');
  var moment = $__require('moment');
  $__require('moment-timezone');
  var timezone_enum_1 = $__require('./timezone.enum');
  describe('timezone service', function() {
    it('should get the timezone', function() {
      var date = '2016-2-1T12:00:00-07:00';
      var timezone = timezone_service_1.timezoneService.getTimezone(date);
      expect(timezone).to.equal(timezone_enum_1.timezones.MST);
    });
    it('should return moment formatted time zone name from an iso string based on the offset', function() {
      var pacificOffset = '2016-2-1T12:00:00-07:00';
      expect(timezone_service_1.timezoneService.getMomentTimezone(pacificOffset)).to.equal(timezone_enum_1.timezones.MST.momentName);
    });
    it('should set the current timezone from an offset', function() {
      timezone_service_1.timezoneService.setCurrentTimezone(timezone_enum_1.timezones.MST.offset);
      expect(timezone_service_1.timezoneService.currentTimezone).to.equal(timezone_enum_1.timezones.MST);
    });
    it('should build a moment with the correct time and timezone', function() {
      var dateTimeString = '2016-02-01T12:00';
      var convertedDateTimeString = timezone_service_1.timezoneService.buildMomentWithTimezone(dateTimeString, timezone_enum_1.timezones.MST);
      expect(convertedDateTimeString.tz()).to.equal(timezone_enum_1.timezones.MST.momentName);
      expect(convertedDateTimeString).to.equalMoment('2016-02-01T12:00:00-07:00');
      var dateTimeStringWithOffset = '2016-02-01T12:00:00.000-07:00';
      var convertedDateTimeStringWithOffset = timezone_service_1.timezoneService.buildMomentWithTimezone(dateTimeStringWithOffset, timezone_enum_1.timezones.MST);
      expect(convertedDateTimeStringWithOffset.tz()).to.equal(timezone_enum_1.timezones.MST.momentName);
      expect(convertedDateTimeStringWithOffset).to.equalMoment('2016-02-01T12:00:00-07:00');
      var momentTime = moment('2016-02-01T18:05:50.000-06:00').tz(timezone_enum_1.timezones.CST.momentName);
      var convertedMomentTime2 = timezone_service_1.timezoneService.buildMomentWithTimezone(momentTime, timezone_enum_1.timezones.MST);
      expect(convertedMomentTime2.tz()).to.equal(timezone_enum_1.timezones.MST.momentName);
      expect(convertedMomentTime2).to.equalMoment('2016-02-01T18:05:50-07:00');
      var momentTime2 = moment('2016-02-01T12:00:00.000-06:00').tz(timezone_enum_1.timezones.EST.momentName);
      var convertedMomentTime = timezone_service_1.timezoneService.buildMomentWithTimezone(momentTime2, timezone_enum_1.timezones.MST);
      expect(convertedMomentTime.tz()).to.equal(timezone_enum_1.timezones.MST.momentName);
      expect(convertedMomentTime).to.not.equalMoment('2016-02-01T12:00:00-07:00');
    });
    it('should also handle times', function() {
      var timeString = '12:00PM';
      var convertedTimeString = timezone_service_1.timezoneService.buildMomentWithTimezone(timeString, timezone_enum_1.timezones.MST, index_1.defaultFormats.timeFormat);
      expect(convertedTimeString.tz()).to.equal(timezone_enum_1.timezones.MST.momentName);
      expect(convertedTimeString.format(index_1.defaultFormats.timeFormat)).to.equal('12:00PM');
    });
  });
  return module.exports;
});

System.registerDynamic("source/services/transform/transform.service.js", ["lodash"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var _ = $__require('lodash');
  var TransformService = (function() {
    function TransformService() {}
    TransformService.prototype.getValue = function(item, transform) {
      if (item == null) {
        return null;
      }
      if (transform == null) {
        return item;
      }
      return _.isFunction(transform) ? transform(item) : item[transform];
    };
    return TransformService;
  }());
  exports.TransformService = TransformService;
  exports.transform = new TransformService();
  return module.exports;
});

System.registerDynamic("source/services/transform/transform.service.tests.js", ["./transform.service"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var transform_service_1 = $__require('./transform.service');
  describe('transform', function() {
    var valueTransform;
    var transform;
    beforeEach(function() {
      transform = new transform_service_1.TransformService();
      valueTransform = sinon.spy(function(item) {
        return item.value;
      });
    });
    it('should call the transform if a function is provided', function() {
      var item = {value: 4};
      expect(transform.getValue(item, valueTransform)).to.equal(4);
    });
    it('should use the transform as a key selector if a string is provided', function() {
      var item = {value: 4};
      expect(transform.getValue(item, 'value')).to.equal(4);
    });
    it('should return null if the item is null', function() {
      expect(transform.getValue(null, 'value')).to.be.null;
      expect(transform.getValue(null, valueTransform)).to.be.null;
    });
    it('should return the item if no transform is provided', function() {
      var item = {value: 4};
      expect(transform.getValue(item, null)).to.equal(item);
    });
  });
  return module.exports;
});

System.registerDynamic("source/services/validation/emailValidation.service.js", ["@angular/core"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var __decorate = (this && this.__decorate) || function(decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
      r = Reflect.decorate(decorators, target, key, desc);
    else
      for (var i = decorators.length - 1; i >= 0; i--)
        if (d = decorators[i])
          r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
  };
  var __metadata = (this && this.__metadata) || function(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
      return Reflect.metadata(k, v);
  };
  var core_1 = $__require('@angular/core');
  var EmailValidationService = (function() {
    function EmailValidationService() {}
    EmailValidationService.prototype.isValidEmailAddress = function(emailAddress) {
      var validEmailPattern = /^([^.\@])([\w.\+\.\-]+)@([\w\-]+)(\.([\w\-]+))*((\.(\w){2,3})+)/i;
      return validEmailPattern.test(emailAddress);
    };
    EmailValidationService = __decorate([core_1.Injectable(), __metadata('design:paramtypes', [])], EmailValidationService);
    return EmailValidationService;
  }());
  exports.EmailValidationService = EmailValidationService;
  return module.exports;
});

System.registerDynamic("source/services/validation/emailValidation.service.tests.js", ["./emailValidation.service"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var emailValidation_service_1 = $__require('./emailValidation.service');
  describe('EmailValidationService', function() {
    var emailValidationService = new emailValidation_service_1.EmailValidationService();
    var validCharacterTestCases = ['_', '+', '.', '+'];
    var invalidCharacterTestCases = ['!', '^', '%', '*', ' ', '~', '&', '$', '#', '?', '`', '=', '/', '\\', ',', ':', ';', '"', '\'', '{', '}', '[', ']', '(', ')', '|', '>', '<'];
    var invalidStartCharacterTestCase = ['@', '.'];
    it('should return true when email is valid', function() {
      var fakeEmailToTest = 'fake@email.com';
      var isValid = emailValidationService.isValidEmailAddress(fakeEmailToTest);
      expect(isValid).to.be.true;
    });
    it('should return false when email has double at signs', function() {
      var fakeEmailToTest = 'fake@@email.com';
      var isValid = emailValidationService.isValidEmailAddress(fakeEmailToTest);
      expect(isValid).to.be.false;
    });
    invalidCharacterTestCases.forEach(function(invalidCharacter) {
      it("should return false when an emailaddress contains " + invalidCharacter, function() {
        var fakeEmailToTest = "fake" + invalidCharacter + "invalid@email.org";
        var isValid = emailValidationService.isValidEmailAddress(fakeEmailToTest);
        expect(isValid).to.be.false;
      });
    });
    validCharacterTestCases.forEach(function(validCharacter) {
      it("should return true when an emailaddress contains " + validCharacter, function() {
        var fakeEmailToTest = "fake" + validCharacter + "invalid@email.org";
        var isValid = emailValidationService.isValidEmailAddress(fakeEmailToTest);
        expect(isValid).to.be.true;
      });
    });
    invalidStartCharacterTestCase.forEach(function(invalidCharacter) {
      it("should return false when an emailaddress starts with " + invalidCharacter, function() {
        var fakeEmailToTest = invalidCharacter + "invalid@email.org";
        var isValid = emailValidationService.isValidEmailAddress(fakeEmailToTest);
        expect(isValid).to.be.false;
      });
    });
    it('should return false when an emailaddress ends with .', function() {
      var fakeEmailToTest = 'invalid@emailorg.';
      var isValid = emailValidationService.isValidEmailAddress(fakeEmailToTest);
      expect(isValid).to.be.false;
    });
    it('should return false when an emailaddress ends with a @', function() {
      var fakeEmailToTest = 'invalidemail.org@';
      var isValid = emailValidationService.isValidEmailAddress(fakeEmailToTest);
      expect(isValid).to.be.false;
    });
    it('should not contain a double dot', function() {
      var fakeEmailToTest = 'invalid@email..org';
      var isValid = emailValidationService.isValidEmailAddress(fakeEmailToTest);
      expect(isValid).to.be.false;
    });
    it('should allow more than one dot contiguously', function() {
      var fakeEmailToTest = 'fake@cs.email.org';
      var isValid = emailValidationService.isValidEmailAddress(fakeEmailToTest);
      expect(isValid).to.be.true;
    });
    it('should not allow a dot immediately after an at sign', function() {
      var fakeEmailToTest = 'fake@.email.org';
      var isValid = emailValidationService.isValidEmailAddress(fakeEmailToTest);
      expect(isValid).to.be.false;
    });
  });
  return module.exports;
});

System.registerDynamic("source/services/window/window.provider.js", ["@angular/core"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var core_1 = $__require('@angular/core');
  var WindowWrapper = (function() {
    function WindowWrapper() {}
    return WindowWrapper;
  }());
  exports.WindowWrapper = WindowWrapper;
  exports.WINDOW_PROVIDER = new core_1.Provider(WindowWrapper, {useValue: window});
  return module.exports;
});

System.registerDynamic("source/services/logger/logger.service.js", [], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var Logger = (function() {
    function Logger() {
      this.console = console;
    }
    Logger.prototype.log = function(message) {
      this.console.log(message);
    };
    return Logger;
  }());
  exports.Logger = Logger;
  return module.exports;
});

System.registerDynamic("source/services/notification/notification.service.js", ["@angular/core", "../window/window.provider", "../logger/logger.service"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var __decorate = (this && this.__decorate) || function(decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
      r = Reflect.decorate(decorators, target, key, desc);
    else
      for (var i = decorators.length - 1; i >= 0; i--)
        if (d = decorators[i])
          r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
  };
  var __metadata = (this && this.__metadata) || function(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
      return Reflect.metadata(k, v);
  };
  var core_1 = $__require('@angular/core');
  var window_provider_1 = $__require('../window/window.provider');
  var logger_service_1 = $__require('../logger/logger.service');
  var NotificationService = (function() {
    function NotificationService(window, logger) {
      this.window = window;
      this.logger = logger;
    }
    NotificationService.prototype.info = function(message) {
      this.notify(message);
    };
    NotificationService.prototype.warning = function(message) {
      this.notify(message);
    };
    NotificationService.prototype.error = function(message) {
      this.notify(message);
    };
    NotificationService.prototype.success = function(message) {
      this.notify(message);
    };
    NotificationService.prototype.notify = function(message) {
      this.window.alert(message);
      this.logger.log(message);
    };
    NotificationService = __decorate([core_1.Injectable(), __metadata('design:paramtypes', [window_provider_1.WindowWrapper, logger_service_1.Logger])], NotificationService);
    return NotificationService;
  }());
  exports.NotificationService = NotificationService;
  return module.exports;
});

System.registerDynamic("source/services/validation/validator.js", ["lodash"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var _ = $__require('lodash');
  var Validator = (function() {
    function Validator(showError) {
      this.showError = showError;
      this.validationHandlers = {};
      this.nextKey = 0;
    }
    Validator.prototype.validate = function(value) {
      var _this = this;
      var isValid = true;
      _.each(this.validationHandlers, function(handler) {
        var isActive = _this.isActive(handler);
        if (isActive && !handler.validate(value)) {
          isValid = false;
          var error = _this.errorMessage(handler);
          _this.showError(error, handler.name);
          return false;
        }
      });
      return isValid;
    };
    Validator.prototype.getErrorCount = function() {
      var _this = this;
      return _.reduce(this.validationHandlers, function(count, handler) {
        var isActive = _this.isActive(handler);
        if (isActive && !handler.validate()) {
          count++;
        }
        return count;
      }, 0);
    };
    Validator.prototype.registerValidationHandler = function(handler) {
      var _this = this;
      var currentKey = this.nextKey;
      this.nextKey++;
      this.validationHandlers[currentKey] = handler;
      return function() {
        _this.unregister(currentKey);
      };
    };
    Validator.prototype.unregister = function(key) {
      delete this.validationHandlers[key];
    };
    Validator.prototype.isActive = function(handler) {
      return (_.isFunction(handler.isActive) && handler.isActive()) || handler.isActive == null || handler.isActive === true;
    };
    Validator.prototype.errorMessage = function(handler) {
      return _.isFunction(handler.errorMessage) ? handler.errorMessage() : handler.errorMessage;
    };
    return Validator;
  }());
  exports.Validator = Validator;
  return module.exports;
});

System.registerDynamic("source/services/validation/compositeValidator.js", ["lodash", "./validator"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var _ = $__require('lodash');
  var validator_1 = $__require('./validator');
  var CompositeValidator = (function() {
    function CompositeValidator(showError) {
      this.showError = showError;
      this.childValidators = {};
      this.nextKey = 0;
    }
    CompositeValidator.prototype.validate = function(value) {
      var isValid = true;
      _.each(this.childValidators, function(handler) {
        if (!handler.validate(value)) {
          isValid = false;
          return false;
        }
      });
      return isValid;
    };
    CompositeValidator.prototype.getErrorCount = function() {
      return _.reduce(this.childValidators, function(count, handler) {
        return count += handler.getErrorCount();
      }, 0);
    };
    CompositeValidator.prototype.buildChildValidator = function() {
      var _this = this;
      var validator = new validator_1.Validator(function(error) {
        _this.showError(error);
      });
      var currentKey = this.nextKey;
      this.nextKey++;
      this.childValidators[currentKey] = validator;
      validator.key = currentKey;
      return validator;
    };
    CompositeValidator.prototype.unregisterChild = function(validator) {
      delete this.childValidators[validator.key];
    };
    return CompositeValidator;
  }());
  exports.CompositeValidator = CompositeValidator;
  return module.exports;
});

System.registerDynamic("source/services/validation/validation.service.js", ["@angular/core", "../notification/notification.service", "./validator", "./compositeValidator"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var __decorate = (this && this.__decorate) || function(decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
      r = Reflect.decorate(decorators, target, key, desc);
    else
      for (var i = decorators.length - 1; i >= 0; i--)
        if (d = decorators[i])
          r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
  };
  var __metadata = (this && this.__metadata) || function(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
      return Reflect.metadata(k, v);
  };
  var core_1 = $__require('@angular/core');
  var notification_service_1 = $__require('../notification/notification.service');
  var validator_1 = $__require('./validator');
  var compositeValidator_1 = $__require('./compositeValidator');
  var ValidationService = (function() {
    function ValidationService(notification) {
      this.notification = notification;
    }
    ValidationService.prototype.buildNotificationWarningValidator = function() {
      var _this = this;
      return new validator_1.Validator(function(error) {
        _this.notification.warning(error);
      });
    };
    ValidationService.prototype.buildNotificationErrorValidator = function() {
      var _this = this;
      return new validator_1.Validator(function(error) {
        _this.notification.error(error);
      });
    };
    ValidationService.prototype.buildCustomValidator = function(showError) {
      return new validator_1.Validator(showError);
    };
    ValidationService.prototype.buildCompositeNotificationWarningValidator = function() {
      var _this = this;
      return new compositeValidator_1.CompositeValidator(function(error) {
        _this.notification.warning(error);
      });
    };
    ValidationService.prototype.buildCompositeNotificationErrorValidator = function() {
      var _this = this;
      return new compositeValidator_1.CompositeValidator(function(error) {
        _this.notification.error(error);
      });
    };
    ValidationService.prototype.buildCompositeCustomValidator = function(showError) {
      return new compositeValidator_1.CompositeValidator(showError);
    };
    ValidationService = __decorate([core_1.Injectable(), __metadata('design:paramtypes', [notification_service_1.NotificationService])], ValidationService);
    return ValidationService;
  }());
  exports.ValidationService = ValidationService;
  return module.exports;
});

System.registerDynamic("source/services/validation/validation.service.tests.js", ["./validation.service"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this || self,
      GLOBAL = global;
  var validation_service_1 = $__require('./validation.service');
  describe('validation', function() {
    var validationService;
    var validator;
    var notification;
    var showErrorSpy;
    beforeEach(function() {
      showErrorSpy = sinon.spy();
      notification = {
        error: sinon.spy(),
        warning: sinon.spy()
      };
      validationService = new validation_service_1.ValidationService(notification);
      validator = validationService.buildCustomValidator(showErrorSpy);
    });
    describe('validate', function() {
      it('should register a validation handler and use it to validate', function() {
        var handler = {validate: sinon.spy(function() {
            return true;
          })};
        validator.registerValidationHandler(handler);
        var isValid = validator.validate();
        sinon.assert.calledOnce(handler.validate);
        expect(isValid).to.be.true;
      });
      it('should show the handler\'s error message if validation fails', function() {
        var handler = {
          validate: sinon.spy(function() {
            return false;
          }),
          errorMessage: 'error'
        };
        validator.registerValidationHandler(handler);
        var isValid = validator.validate();
        sinon.assert.calledOnce(handler.validate);
        expect(isValid).to.be.false;
        sinon.assert.calledOnce(showErrorSpy);
        sinon.assert.calledWith(showErrorSpy, 'error');
      });
      it('should allow the handler to specify a function for returning the error message', function() {
        var handler = {
          validate: sinon.spy(function() {
            return false;
          }),
          errorMessage: sinon.spy(function() {
            return 'error';
          })
        };
        validator.registerValidationHandler(handler);
        validator.validate();
        sinon.assert.calledOnce(handler.errorMessage);
        sinon.assert.calledOnce(showErrorSpy);
        sinon.assert.calledWith(showErrorSpy, 'error');
      });
      it('should handle multiple validators and only show the error of the first one to fail', function() {
        var firstValidHandler = {validate: sinon.spy(function() {
            return true;
          })};
        var secondValidHandler = {validate: sinon.spy(function() {
            return true;
          })};
        var firstFailingHandler = {
          validate: sinon.spy(function() {
            return false;
          }),
          errorMessage: 'error1'
        };
        var thirdValidHandler = {validate: sinon.spy(function() {
            return true;
          })};
        var secondFailingHandler = {
          validate: sinon.spy(function() {
            return false;
          }),
          errorMessage: 'error2'
        };
        validator.registerValidationHandler(firstValidHandler);
        validator.registerValidationHandler(secondValidHandler);
        validator.registerValidationHandler(firstFailingHandler);
        validator.registerValidationHandler(thirdValidHandler);
        validator.registerValidationHandler(secondFailingHandler);
        var isValid = validator.validate();
        sinon.assert.calledOnce(firstFailingHandler.validate);
        sinon.assert.calledOnce(secondValidHandler.validate);
        sinon.assert.calledOnce(firstFailingHandler.validate);
        sinon.assert.notCalled(thirdValidHandler.validate);
        sinon.assert.notCalled(secondFailingHandler.validate);
        expect(isValid).to.be.false;
        sinon.assert.calledOnce(showErrorSpy);
        sinon.assert.calledWith(showErrorSpy, 'error1');
      });
      it('should pass a value to each of the validators to validate against', function() {
        var firstValidHandler = {validate: sinon.spy(function(value) {
            return value;
          })};
        var secondValidHandler = {validate: sinon.spy(function(value) {
            return value;
          })};
        validator.registerValidationHandler(firstValidHandler);
        validator.registerValidationHandler(secondValidHandler);
        expect(validator.validate(true)).to.be.true;
      });
    });
    describe('isActive', function() {
      it('should disable a validator if isActive is set to false', function() {
        var inactiveHandler = {
          validate: sinon.spy(),
          isActive: false
        };
        validator.registerValidationHandler(inactiveHandler);
        var isValid = validator.validate();
        sinon.assert.notCalled(inactiveHandler.validate);
        expect(isValid).to.be.true;
      });
      it('should call isActive and disable the validator if the result is false', function() {
        var inactiveHandler = {
          validate: sinon.spy(function() {
            return false;
          }),
          isActive: sinon.spy(function() {
            return false;
          })
        };
        var activeHandler = {
          validate: sinon.spy(function() {
            return true;
          }),
          isActive: sinon.spy(function() {
            return true;
          })
        };
        validator.registerValidationHandler(inactiveHandler);
        validator.registerValidationHandler(activeHandler);
        var isValid = validator.validate();
        sinon.assert.calledOnce(inactiveHandler.isActive);
        sinon.assert.notCalled(inactiveHandler.validate);
        sinon.assert.calledOnce(activeHandler.isActive);
        sinon.assert.calledOnce(activeHandler.validate);
        expect(isValid).to.be.true;
      });
    });
    describe('unregister', function() {
      it('should return a function to unregister the validation handler', function() {
        var handlerToUnregister = {validate: sinon.spy(function() {
            return false;
          })};
        var activeHandler = {validate: sinon.spy(function() {
            return true;
          })};
        var unregister = validator.registerValidationHandler(handlerToUnregister);
        validator.registerValidationHandler(activeHandler);
        var isValid = validator.validate();
        expect(isValid).to.be.false;
        sinon.assert.calledOnce(handlerToUnregister.validate);
        sinon.assert.notCalled(activeHandler.validate);
        handlerToUnregister.validate.reset();
        activeHandler.validate.reset();
        unregister();
        isValid = validator.validate();
        expect(isValid).to.be.true;
        sinon.assert.notCalled(handlerToUnregister.validate);
        sinon.assert.calledOnce(activeHandler.validate);
      });
    });
    describe('notification', function() {
      it('should show errors as error notifications', function() {
        validator = validationService.buildNotificationErrorValidator();
        var handler = {
          validate: sinon.spy(function() {
            return false;
          }),
          errorMessage: 'error'
        };
        validator.registerValidationHandler(handler);
        validator.validate();
        sinon.assert.calledOnce(notification.error);
        sinon.assert.calledWith(notification.error, 'error');
      });
      it('should show errors as warning notifications', function() {
        validator = validationService.buildNotificationWarningValidator();
        var handler = {
          validate: sinon.spy(function() {
            return false;
          }),
          errorMessage: 'error'
        };
        validator.registerValidationHandler(handler);
        validator.validate();
        sinon.assert.calledOnce(notification.warning);
        sinon.assert.calledWith(notification.warning, 'error');
      });
    });
    describe('getErrorCount', function() {
      it('should get the count of failing validators', function() {
        var validHandler = {validate: sinon.spy(function() {
            return true;
          })};
        var firstFailingHandler = {validate: sinon.spy(function() {
            return false;
          })};
        var inactiveFailingHandler = {
          validate: sinon.spy(function() {
            return false;
          }),
          isActive: false
        };
        var secondFailingHandler = {validate: sinon.spy(function() {
            return false;
          })};
        validator.registerValidationHandler(validHandler);
        validator.registerValidationHandler(firstFailingHandler);
        validator.registerValidationHandler(inactiveFailingHandler);
        validator.registerValidationHandler(secondFailingHandler);
        var errorCount = validator.getErrorCount();
        sinon.assert.calledOnce(firstFailingHandler.validate);
        sinon.assert.calledOnce(firstFailingHandler.validate);
        sinon.assert.calledOnce(secondFailingHandler.validate);
        sinon.assert.notCalled(inactiveFailingHandler.validate);
        expect(errorCount).to.equal(2);
      });
    });
    describe('compositeValidator', function() {
      it('should run each of the child validators', function() {
        var compositeValidator = validationService.buildCompositeCustomValidator(showErrorSpy);
        var firstChild = compositeValidator.buildChildValidator();
        var secondChild = compositeValidator.buildChildValidator();
        var firstChildHandler = {validate: sinon.spy(function() {
            return true;
          })};
        var secondChildHandler = {validate: sinon.spy(function() {
            return true;
          })};
        firstChild.registerValidationHandler(firstChildHandler);
        secondChild.registerValidationHandler(secondChildHandler);
        var isValid = compositeValidator.validate();
        sinon.assert.calledOnce(firstChildHandler.validate);
        sinon.assert.calledOnce(secondChildHandler.validate);
        expect(isValid).to.be.true;
      });
      it('should show the first error from a child validator', function() {
        var compositeValidator = validationService.buildCompositeCustomValidator(showErrorSpy);
        var firstChild = compositeValidator.buildChildValidator();
        var secondChild = compositeValidator.buildChildValidator();
        var failingChildHandler = {
          validate: sinon.spy(function() {
            return false;
          }),
          errorMessage: 'error1'
        };
        var secondChildHandler = {validate: sinon.spy(function() {
            return true;
          })};
        firstChild.registerValidationHandler(failingChildHandler);
        secondChild.registerValidationHandler(secondChildHandler);
        var isValid = compositeValidator.validate();
        sinon.assert.calledOnce(failingChildHandler.validate);
        sinon.assert.notCalled(secondChildHandler.validate);
        expect(isValid).to.be.false;
        sinon.assert.calledOnce(showErrorSpy);
        sinon.assert.calledWith(showErrorSpy, 'error1');
      });
      it('should sum the counts of the child validation failures', function() {
        var compositeValidator = validationService.buildCompositeCustomValidator(showErrorSpy);
        var firstChild = compositeValidator.buildChildValidator();
        var secondChild = compositeValidator.buildChildValidator();
        var firstChildFailingHandler1 = {validate: sinon.spy(function() {
            return false;
          })};
        var firstChildFailingHandler2 = {validate: sinon.spy(function() {
            return false;
          })};
        var secondChildFailingHandler = {validate: sinon.spy(function() {
            return false;
          })};
        firstChild.registerValidationHandler(firstChildFailingHandler1);
        firstChild.registerValidationHandler(firstChildFailingHandler2);
        secondChild.registerValidationHandler(secondChildFailingHandler);
        var firstChildCount = firstChild.getErrorCount();
        var secondChildCount = secondChild.getErrorCount();
        expect(firstChildCount).to.equal(2);
        expect(secondChildCount).to.equal(1);
        firstChildFailingHandler1.validate.reset();
        firstChildFailingHandler2.validate.reset();
        secondChildFailingHandler.validate.reset();
        expect(compositeValidator.getErrorCount()).to.equal(firstChildCount + secondChildCount);
        sinon.assert.calledOnce(firstChildFailingHandler1.validate);
        sinon.assert.calledOnce(firstChildFailingHandler2.validate);
        sinon.assert.calledOnce(secondChildFailingHandler.validate);
      });
    });
  });
  return module.exports;
});

//# sourceMappingURL=tests.bundle.js.map